(function($){

	$.fn.scheduler = function (options) {

		return this.each(function(){
			var retData = new SmxScheduler(options);
			retData.init($(this));
			$(this).data("smxScheduler", retData);

			$(this).on("update", function(e, data){
				$(this).data("smxScheduler").update(data);
			});

		});
	}
/*
	var getBoxSvg1 = function(settings){
		var svg = '\<\?xml version="1.0" encoding="iso-8859-1" ?>';
		svg += '<svg xmlns="http://www.w3.org/2000/svg" width="' + settings.timeslotWidth + '" height="' + settings.timeslotHeight + '">';
		// svg += '<rect x="0" y="0" width="' + settings.timeslotWidth + '" height="' + settings.timeslotHeight + '" style="fill:#FFF;stroke-width:0.5;stroke:#555" /></svg>';
		svg += '<line x1="' + settings.timeslotWidth + '" y1="0" x2="' + settings.timeslotWidth + '" y2="' + settings.timeslotHeight + '" style="stroke-width:0.5;stroke:#555"></line>';
		svg += '</svg>';

		svg = "url('data:image/svg+xml;utf8," + svg + "')";

		$("<style type='text/css'>.sch-body-group { background-image:" + svg + ";}</style>").appendTo("head");
	};
*/
	var canvas = null, ctx = null, canvasHeight = 3;
	var getBoxSvg = function(settings, dt, col){

		if (!canvas || !dt) {
			canvas = $("<canvas/>");
			canvas = canvas.get(0);
			canvas.height = canvasHeight;

			ctx = canvas.getContext("2d");

			var days = (new Date(settings.endDate) - new Date(settings.startDate)) / (1000*60*60*24);
			canvas.width = (days + 1) * settings.timeslotWidth;

			return;
		}

		ctx.beginPath();

		ctx.moveTo(col * settings.timeslotWidth, 0);
		ctx.lineTo(col * settings.timeslotWidth, canvasHeight);
		ctx.strokeStyle = "#d9d9d9";
		// ctx.strokeStyle = "#EEEEEE";
		ctx.lineWidth = 2;
		if (dt.isMonthStart()) {
			ctx.lineWidth = 6;
			ctx.strokeStyle = "#d9d9d9";
		}
		ctx.stroke();

		ctx.fillStyle = "#FFF";
		if (dt.isLeave()) {
			ctx.fillStyle = "#fff2e1";
		}
		if (dt.isToday()) {
			ctx.fillStyle = "#e1f2fd";
		}
		/*
		if (dt.isMonthStart()) {
			ctx.fillStyle = "#feddff";
		}
		*/
		ctx.fillRect(col * settings.timeslotWidth, 0, settings.timeslotWidth, canvasHeight);
	};

	var finishBox = function(){
		svg = "url(" + canvas.toDataURL() + ")";
		$("<style type='text/css'>.sch-body-group { background-image:" + svg + ";}</style>").appendTo("head");
	};

	var lastDay = null, lastTop = 0;

	function SmxScheduler(options)
	{
		var _this = this;

		var defaults = {
			date: new Date(),
			startDate: null,
			endDate: null,
			perDayHours: 8,
			timeslotHeight: 50,
			timeslotWidth: 75,
			// items: [""],
			data: [],

			onReady: null,
			onAdd: null,
			onEdit: null,
			onRemove: null,
			onLoadMore: null,
			onDragDrop: null,
			onResize: null,
			onDeleteBar: null,
			onUserTmpl: function(userObj){
				return $("<span/>").text(userObj.userName).addClass("sch-title");
			}
		};

		var settings = {};

		settings = $.extend({}, defaults, options);

		// Elements
		var columnHeader = "",
			rowContainer = "",
			containerGroup = "",
			rowHeaderContainer = "",
			table = "";

		var classPrefix = "sch-";

		var getClass = function(classNames){
			return classNames.replace(/(\S+)/g, function(a){return a ? classPrefix + a : "";});
		};

		var drawDatas = [];

		var id = "";
		var totHours = {};

		var rsvnPlugins = function(elems){
			elems.resizable(resizableParams);
			elems.draggable(draggableParams);
			elems.contextmenu(contextMenuParams);
		};

		var render = {
			calendar: function (container) {
				table = $("<div/>").addClass("sch-table");

				switch(settings.view)
				{
					case 'W':
						table.addClass("week");
						settings.timeslotWidth = 200;
					break;
					case 'M':
						table.addClass("month");
						settings.timeslotWidth = 75;
					break;
				}

				table.appendTo(container);

				/* Header Begins */
				rowHeaderContainer = $("<div/>").addClass("sch-row-header");
		        rowHeaderContainer.append("<div class=\"sch-day weekslot\" style=\"height:auto;border-bottom-color:transparent;\">&nbsp;</div>");
		        rowHeaderContainer.append("<div class=\"sch-day timeslot\"></div>");
		        rowHeaderContainer.appendTo(table);
		        /* Header End */

				/* Body Begins */
				containerGroup = $("<div/>").addClass("sch-container-group");
				rowContainer = $("<div/>").addClass("sch-row-container");
				column0Header = $("<div/>").addClass("sch-column-header weekslot");
				columnHeader = $("<div/>").addClass("sch-column-header timeslot");

				draggableParams.containment = rowContainer;
				getBoxSvg(settings);

				var col=0, col1=1, startDay = null, txt="", nthDay = Date.firstDayOfWeek-1;
				nthDay = nthDay < 0 ? 6 : nthDay;
				var days = getDays(function(obj){
					columnHeader.append($("<div/>").addClass(
						"sch-timeslot " + "sch-day"
					).addClass(
						(obj.date.isLeave() ? " leave" : "") +
						(obj.date.isToday() ? " today" : "") +
						(obj.date.isMonthStart() ? " mstart" : "") +
						(obj.date.isMonthEnd() ? " mend" : "") +
						(obj.date.isWeekStart() ? " wstart" : "") +
						(obj.date.isWeekEnd() ? " wend" : "")
					).text(obj.text));

					getBoxSvg(settings, obj.date, col++);

					if (!startDay)
					{
						startDay = obj.date;
					}

					txt = "DD";
					if (startDay.getMonth() != obj.date.getMonth())
					{
						txt += " MMM";
					}
					if (startDay.getFullYear() != obj.date.getFullYear())
					{
						txt += " YYYY";
					}

					txt = startDay.format(txt) + obj.date.format(" - DD MMM YYYY");

					if (startDay == obj.date)
					{
						txt = obj.date.format("MMM YYYY");
					}

					if (nthDay == obj.date.getDay())
					{
						column0Header.append($("<div/>").css("minWidth", col1 * settings.timeslotWidth).addClass("sch-weekslot sch-day").text(txt));
						col1 = 0;
						startDay = null;
					}

					col1++;

					return true;
				});

				if (--col1 > 0) {
					column0Header.append($("<div/>").css("minWidth", col1 * settings.timeslotWidth).addClass("sch-weekslot sch-day").text(txt));
				}

				finishBox();

				$("> div", columnHeader).css("minWidth", settings.timeslotWidth);

				rowContainer.append(column0Header);
				rowContainer.append(columnHeader);
				rowContainer.appendTo(containerGroup);
				containerGroup.appendTo(table);
				/* Body End */

				if (typeof settings.onLoadMore === "function") {
					var lastLeft = 0, currLeft=0;
					var _rowContainer = rowContainer.get(0);
					rowContainer.scroll(function(e){
						currLeft = rowContainer.scrollLeft();

						lastTop = rowContainer.scrollTop();
						rowHeaderContainer.scrollTop(lastTop);

						lastDay = new Date(settings.startDate).addDays((currLeft - (currLeft % settings.timeslotWidth)) / settings.timeslotWidth);

						// Reach Right End
						if (currLeft == (_rowContainer.scrollWidth - _rowContainer.clientWidth)) {
							settings.onLoadMore(e, 1);
						}

						// is scroll left && reach to begin
						if (lastLeft > currLeft && currLeft == 0) {
							settings.onLoadMore(e, -1);
						}

						lastLeft = currLeft;
					});
				}

				var rowIdx = 0;

				$.each(settings.data, function(idx, val){
					/* show only for active users */
					if (!(Otime.Details.all_users[val.user_id].is_active -0)) return '';
					
					/* Header Begins */
					var header = $("<div/>").addClass("sch-item").attr("uid", val.user_id);

					settings.onUserTmpl(val).appendTo(header);
					header.appendTo(rowHeaderContainer);
					/* Header End */

					var bodyGroup = $("<div/>").addClass("sch-body-group");
					var rsvnContainer = $("<div/>").addClass("sch-rsvn-container");
					var canvasGrid = $("<div/>").addClass("sch-canvas-grid");
					bodyGroup.append(rsvnContainer);
					bodyGroup.append(canvasGrid);
					bodyGroup.appendTo(rowContainer);

					bodyGroup.attr("uid", val.user_id);
					bodyGroup.attr("rows", val.rows);

					bodyGroup.height(settings.timeslotHeight * (val.rows+1));
					header.height(settings.timeslotHeight * (val.rows+1));

					bodyGroup.width(rowContainer.get(0).scrollWidth);

					render.drawBars(val.drawData, rsvnContainer);
					render.totHours(val.totHoursArr, rsvnContainer);

					rsvnPlugins($(".sch-reservation-final", rsvnContainer));

					rsvnContainer.droppable({
						// scope: "schReservation",
						accept: ".sch-reservation-final",
						drop: function(e, ui){
							var $target = $(ui.draggable);

							var params = {
								tsdata: $target.data("tsdata"),
								dates: getDates(ui.draggable),
								target: ui.draggable
							};

							if (ui.draggable.parent().get(0) != e.target) {
								params.user_id = $(e.target).parent().attr("uid");
							}

							var errClbk = function(){
								var col = (params.tsdata.start.getTime() - settings.startDate.getTime()) / (1000*60*60*24);

								$target.css({
									top: (params.tsdata.row * settings.timeslotHeight) + 1,
									left: col * settings.timeslotWidth
								});
							};

							if (!params.user_id && params.dates.start.toInt() == params.tsdata.start.toInt() && params.dates.end.toInt() == params.tsdata.end.toInt())
							{
								errClbk();
								e.stopPropagation();
								return false;
							}

							typeof settings.onDragDrop === "function" && settings.onDragDrop(params, null, errClbk);
						}
					});
				});

				return table;
			},
			drawBars: function(drawData, rsvnContainer){
				var col=0;
				var lessHeight = $(".sch-column-header").height();
				var retArr = [];
				var $workedHours = null, progress = 0;

				$.each(drawData, function(idx, val){
					col = (val.start.getTime() - settings.startDate.getTime()) / (1000*60*60*24);

					var $rsvn = $("<div/>"),
						top = (val.row * settings.timeslotHeight),
						height = settings.timeslotHeight,
						left = col * settings.timeslotWidth,
						width = 1 * settings.timeslotWidth + 1;

					$rsvn.css("background-color", val.bg_color);

					$rsvn.addClass("sch-reservation").addClass("sch-reservation-final").css({
						top: top + 1,
						height: height,
						left: left,
						width: width
					});

					$rsvn.data("tsdata", val);
					rsvnContainer.append($rsvn);

					// 12 means padding & border
					$rsvn.width((val.cols * settings.timeslotWidth) - 12);

					// $rsvn.text(val.text);
					$rsvn.html(val.text);
					$rsvn.attr("title", val.title);
/*
// Worked Hours Progress Begins
					$.each(val.sheets, function(_idx, _v){
						if (!(_v.hours-0)) {
							return true;
						}

						$workedHours = $("<span/>").addClass("sch-worked-hours");
						$workedHours.appendTo($rsvn);

						$workedHours.css({
							left: (_idx * settings.timeslotWidth)
						});

						progress = settings.timeslotWidth * ((_v.hours-0) / (_v.estimated_hours-0));
						if (progress > settings.timeslotWidth){
							$workedHours.addClass("red");
							progress = settings.timeslotWidth;
						}

						$workedHours.width(progress);
					});
// Worked Hours Progress End
*/
					retArr.push($rsvn);
				});

				// Calculate & Set UserName box height
				var elems = null;
				$(".sch-row-header .sch-item[uid]").each(function(idx, elem){
					elems = $(".sch-row[uid=" + elem.getAttribute("uid") + "]");
					$(elem).height(elems.height() * elems.length);
				});

				return retArr;
			},
			totHours: function(totHours, rsvnContainer){
				var parent = null,
					elem = null,
					left = 0, hrs = 0;

				$.each(totHours, function(key, val){
					left = ((val.date.getTime() - settings.startDate.getTime()) / (1000*60*60*24)) * settings.timeslotWidth;

					elem = $("<div/>").addClass("sch-tot-hrs").text(val.hours);
					elem.appendTo(rsvnContainer);
					elem.css({
						width: settings.timeslotWidth - 2,
						left: left + 1
					});

					hrs = settings.perDayHours - val.hours;

					if (hrs > 0) {
						elem.addClass("bg-danger");
					} else if (hrs == 0) {
						elem.addClass("bg-success");
					} else if (hrs < 0) {
						elem.addClass("bg-primary");
					}
				});
			}
		};

		// Attch event listeners for whole scheduler
		var clickHandler = function(e){
			var rsvn = $(e.target);

			if (e.type != "contextmenu" && rsvn.is(".sch-reservation.selected")) {
				// typeof settings.onEdit === "function" && settings.onEdit(rsvn.data("tsdata"));
				return true;
			}

			$(".sch-reservation.selected").removeClass("selected");

			if (rsvn.is(".sch-reservation-creating .icon-plus"))
			{
				rsvn = rsvn.parent();
			}

			if (rsvn.is(".sch-reservation-creating")) {
				var data = rsvn.data("schData");

				if (typeof settings.onAdd === "function") {
					settings.onAdd(data, rsvn, function(respData){
						addNew(data, rsvn, respData);
					});
				} else {
					addNew(data, rsvn);
				}

				return true;
			}

			clearSelection();
			$(this).addClass("selected");

			// typeof settings.onRemove === "function" && settings.onRemove($(this).data("dates"), $(this));
			// $(this).remove();
		};

		var dblClickHandler = function(e){
			typeof settings.onEdit === "function" && settings.onEdit($(this).data("tsdata"));
		}

		var resizableParams = {
			handles: "e, w",
			grid: settings.timeslotWidth,
			helper: "ui-resizable-helper",
			minWidth: settings.timeslotWidth,
			minHeight: settings.timeslotHeight,
			stop: function(e, ui){
				var dates = getDates(e.target);
				if (!dates)
				{
					ui.element.css({
						left: ui.originalPosition.left - ui.element.parent().offset().left
					});
					ui.element.css(ui.originalSize);
					return false;
				}

				var tsdata = ui.element.data("tsdata");

				var obj = getResizedDates(new Date(tsdata.start), new Date(tsdata.end), new Date(dates.start), new Date(dates.end));

				tsdata.start = new Date(dates.start);
				tsdata.end = new Date(dates.end);
				obj.user_id = tsdata.user_id;

				typeof settings.onResize === "function" && settings.onResize(obj, tsdata, function(val){
					_this.updateUser(tsdata.user_id, val);
				});
			}
		};
		
		_this.updateUser = function(user_id, obj){
			obj = obj || {
				rows: 0
			};

			var rsvnContainer = $(".sch-body-group[uid=" + user_id + "] .sch-rsvn-container");
			rsvnContainer.empty();

			var bodyGroup = $(".sch-body-group[uid=" + user_id + "]");
			bodyGroup.attr("rows", obj.rows);
			bodyGroup.height(settings.timeslotHeight * (obj.rows+1));
			
			var header = $(".sch-item[uid=" + user_id + "]", rowHeaderContainer);
			header.height(settings.timeslotHeight * (obj.rows+1));

			render.drawBars(obj.drawData, rsvnContainer);
			render.totHours(obj.totHoursArr, rsvnContainer);

			rsvnPlugins($(".sch-reservation-final", rsvnContainer));
		};

		_this.showUser = function(usrIds){
			if (!usrIds) {
				$(".sch-item", rowHeaderContainer).show();
				$(".sch-body-group", rowContainer).show();
				return;
			}

			$(".sch-item", rowHeaderContainer).hide();
			$(".sch-body-group", rowContainer).hide();

			$.each(usrIds, function(key, val){
				$(".sch-item[uid=" + val + "]", rowHeaderContainer).show();
				$(".sch-body-group[uid=" + val + "]", rowContainer).show();
			});
		};

		var draggableParams = {
			snap: true,
			grid: [settings.timeslotWidth, settings.timeslotHeight],			
			snapMode: "outer",
			/*
			revert: function(event, ui){
				$(this).data("uiDraggable").originalPosition = {
					top : 0,
					left : 0
				};
				return true;
			}
			*/
			// revert: "invalid",
			// containment: "parent",
			// scope: "tasks",
			// start: function(e, ui){},
		};

		var contextMenuParams = {
			target: "#contextMenu",
			before: function(e){
				clickHandler.call(this.$element, e);
			},
			onItem: function(elem, e){
				if (!e || !e.currentTarget) {
					return;
				}

				// $(e.currentTarget).data("event")
				var evt = $(e.currentTarget).attr("data-event");

				return (evt && menuEvents[evt] && menuEvents[evt](elem))
			}
		};

		var menuEvents = {
			deleteItem: function(elem){
				if (typeof settings.onDeleteBar === "function") {
					settings.onDeleteBar(elem);
				}
			},
			splitItem: function(elem){
				var tsdata = elem.data("tsdata");

				if (tsdata.sheets.length < 1) {
					return true;
				}

				var bk = JSON.stringify(tsdata), drawData = null;
				var sheets = [];

				var rsvnContainer = $(".sch-body-group[uid=" + tsdata.user_id + "] .sch-rsvn-container");

				$.each(tsdata.sheets, function(key, sheet){
					drawData = JSON.parse(bk);
					drawData.start = new Date(sheet._entry_date);
					drawData.end = new Date(sheet._entry_date);
					drawData.sheets = [sheet];
					drawData.cols = 1;

					sheets.push(drawData);
				});

				var newElemArr = render.drawBars(sheets, rsvnContainer);

				setTimeout(function(){
					elem.remove();
				}, 200);
			
				rsvnPlugins($(newElemArr));

				return true;
			}
		};

		var attachEventListeners = function () {
			$(document).unbind(".schevent");

			$(document).on("mousedown.schevent", ".sch-canvas-grid", createRsvn.start);

			// Allows for reservation deletion
			$(document).on("click.schevent", ".sch-reservation", clickHandler);
			$(document).on("dblclick.schevent", ".sch-reservation", dblClickHandler);
		}

		var getResizedDates = function(oldStart, oldEnd, newStart, newEnd){
			var newTs = [];
			var delTs = [];

			if (oldStart < newStart) {
				while(oldStart < newStart) {
					delTs.push(new Date(oldStart));
					oldStart.addDays(1);
				}
			} else if (newStart < oldStart) {
				while(newStart < oldStart) {
					newTs.push(new Date(newStart));
					newStart.addDays(1);
				}
			}

			if (oldEnd < newEnd) {
				oldEnd.addDays(1);
				while(oldEnd <= newEnd) {
					newTs.push(new Date(oldEnd));
					oldEnd.addDays(1);
				}
			} else if (newEnd < oldEnd) {
				newEnd.addDays(1);
				while(newEnd <= oldEnd) {
					delTs.push(new Date(newEnd));
					newEnd.addDays(1);
				}
			}

			return {
				added: newTs,
				deleted: delTs
			};
		};

		var getDates = function(elem, clbk){
			elem = $(elem);
			var left = elem.position().left;
			var width = elem.width();
			var cols = Math.round(width / settings.timeslotWidth);
			width = cols * settings.timeslotWidth;
			elem.width(width - 10);

			elem.height(settings.timeslotHeight - 12); // 12 for border & padding

			left = Math.round(left / settings.timeslotWidth) * settings.timeslotWidth;

			if (left < 0) {
				return false;
			}

			elem.css({
				left: left
			});

			var start = new Date(settings.startDate).addDays(left / settings.timeslotWidth);
			var end = new Date(start).addDays(cols-1);

			if (typeof clbk === "function") {
				var tsheets = elem.data("tsdata").sheets;
				var iLen = ((end - start) / (1000*60*60*24)) + 1;
				for (var i=0; i<iLen; i++)
				{
					clbk(tsheets[i]);
				}
			}

			return {
				start: start,
				end: end
			};
		};

		var clearSelection = function(){
			$(".sch-reservation.selected").removeClass("selected");
			$(".sch-reservation-creating").remove();
		};

		// Create a new rsvn with mouse click and drag
		var createRsvn = {
			start: function (e) {
				var elem = $(e.currentTarget);

				// Middle Button
				if (e.button === 1)
				{
					var lPageX = e.pageX, lPageY = e.pageY;
					elem.on("mousemove.scrollevent", e, function(_e){
						rowContainer.scrollLeft(rowContainer.scrollLeft() + (lPageX - _e.pageX));
						rowContainer.scrollTop(rowContainer.scrollTop() + (lPageY - _e.pageY));
						lPageX = _e.pageX;
						lPageY = _e.pageY;
					});
					$(document).on("mouseup.scrollevent", e, function(_e){
						elem.off("mousemove.scrollevent");
						$(document).off("mouseup.scrollevent");
					});
				}

				// Allow only left click
				if (e.button != 0) {
					return true;
				}

				// sch-canvas-grid
				// var elem = $(e.currentTarget);

				// sch-body-group
				var parent = elem.parent();

				clearSelection();

				var $newRsvn,
					posX = e.originalEvent.offsetX,
					posY = e.originalEvent.offsetY,
					top = posY - (posY % settings.timeslotHeight),
					left = posX - (posX % settings.timeslotWidth),
					height = settings.timeslotHeight + 1,
					width = settings.timeslotWidth + 1,
					row = top / settings.timeslotHeight;

				var collisions = $(".sch-reservation", parent).filter(function(){
					return $(this).position().top == top && $(this).position().left == left;
				}).not($newRsvn);

				// var rowData = row.data("rowData");

				if (collisions.length == 0) {
					$newRsvn = $("<div/>")
					.addClass("sch-reservation sch-reservation-creating")
					.css({
						top: top,
						left: left,
						height: height,
						width: width
					});

					$("<span/>").addClass("icon icon-plus").appendTo($newRsvn);

					// console.log($newRsvn);
					$(".sch-rsvn-container", parent).append($newRsvn);
				}

				if (row == parent.attr("rows")) {
					$newRsvn.data("isNew", "1");
				}
				/*
				if ($(e.target).is(".sch-new-row .sch-cell")) {
					$newRsvn.data("isNew", "1");
				}
				*/

				if ($newRsvn != undefined)
				{
					var eventData = {
						rsvn: $newRsvn,
						left: left,
						parent: parent,
						row: row,
						boxData: [ left/settings.timeslotWidth, 1 ]
						// rowData: rowData
					};

					if (parent)
					{
						// eventData.start = new Date($(e.target).data("date"));
						// eventData.end = new Date($(e.target).data("date"));
						eventData.user_id = parent.attr("uid");
					}

					elem.on("mousemove.schevent", eventData, createRsvn.resize);
					$(document).on("mouseup.schevent", eventData, createRsvn.end);
				}
			},
			resize: function (e) {
				// var parent = $(e.currentTarget).parent();

				var $newRsvn = e.data.rsvn,
					posX = e.pageX - Math.round($(".sch-rsvn-container", e.data.parent).offset().left),
					remainder = posX % settings.timeslotWidth,
					left = e.data.left,
					start = posX > left ? left : posX - remainder,
					end = posX > left ? (remainder == 0 ? posX : posX + settings.timeslotWidth - remainder) : left + settings.timeslotWidth,
					width = end - start + 1;

				// Starting column, no-of-columns
				e.data.boxData = [
					start/settings.timeslotWidth,
					(end-start) / settings.timeslotWidth
				];

				$newRsvn.css({
					left: start,
					width: width
				});

				$(".sch-reservation", e.data.parent).filter(function(){
					return $(this).position().top == $newRsvn.position().top;
				}).not($newRsvn).each(function (i,elem) {
					if (overlaps(elem, $newRsvn) == true) {
						$newRsvn.addClass("sch-reservation-error");
						return false;
					} else {
						if ($newRsvn.hasClass("sch-reservation-error")) {
							$newRsvn.removeClass("sch-reservation-error");
						}
					}
				});
			},

			end: function (e) {
				var $newRsvn = e.data.rsvn;

				// e.data.end = new Date($(e.target).data("date"));
				if (e.data.boxData) {
					e.data.start = new Date(settings.startDate);
					e.data.start.addDays(e.data.boxData[0]);

					e.data.end = new Date(settings.startDate);
					e.data.end.addDays(e.data.boxData[0] + e.data.boxData[1] - 1);
				} else {
					e.data.end = new Date(e.data.start);
				}

				$newRsvn.data("schData", e.data);
				/*
				$newRsvn.data("dates", {
					start: e.data.start,
					end: e.data.end
				});
				*/

				if ($newRsvn.hasClass("sch-reservation-error")) {
					$newRsvn.remove();
				} else {
					// $newRsvn.removeClass("sch-reservation-creating");
					// $newRsvn.addClass("sch-reservation-final");
				}

				// eventData.start

				$(".sch-canvas-grid", e.data.parent).off("mousemove.schevent");
				$(document).off("mouseup.schevent");
/*
				if (typeof settings.onAdd === "function") {
					settings.onAdd(e.data, $newRsvn, function(respData){
						addNew(e.data, $newRsvn, respData);
					});
				} else {
					addNew(e.data, $newRsvn);
				}
*/
			}
		}

		var addNew = function(data, newRsvn, respData){

			if (newRsvn.data("isNew")) {
				// Create New Data & push.
				var row = data.row + 2;

				$(".sch-item[uid=" + data.user_id + "]").height(row * settings.timeslotHeight);
				var bodyGroup = $(".sch-body-group[uid=" + data.user_id + "]").get(0);
				bodyGroup = $(bodyGroup);
				bodyGroup.attr("rows", row-1);
				bodyGroup.height(row * settings.timeslotHeight);
			} else {
console.log("addNew : ", data);
				var cols = ((data.end.getTime() - data.start.getTime()) / (1000*60*60*24)) + 1;
	// text: respData.estimated_hours + ("cols > 1 ? "hr for " + cols + " days" : "hr"),
				drawDatas.push({
					start: data.start,
					end: data.end,
					row: data.row,
					cols: cols,
					text: "", // "cols > 1 ? "hr for " + cols + " days" : "hr",
					// bg_color: data.rowData.bg_color
				});

				console.log("New for existing : ", data, newRsvn);
			}

			// console.log("After Add New ", , data, newRsvn);
		};

		var getPos = function(elem) {
			var left,width;
			left = $(elem).position().left;
			width = $(elem).width();
			return [Math.round(left),Math.round(left + width)]
		};
		var comparePos = function(p1,p2) {
			var r1 = p1[0] < p2[0] ? p1 : p2,
				r2 = p1[0] < p2[0] ? p2 : p1;
			return r1[1] > r2[0];
		};

		// Checks whether two elements are overlapping on the x-axis
		var overlaps = function (a,b) {
			return comparePos(getPos(a), getPos(b));
		}

		// Sets the size of the scheduler timeslots
		var setSize = function (height,width) {
			height = height || settings.timeslotHeight;
			width = width || settings.timeslotWidth;
	/*
			$(".timeslot.cell").css({
				minHeight: height,
				minWidth: width,
				maxHeight: height,
				maxWidth: width
			});
	*/
			// $(".sch-row")

			$(".sch-timeslot.sch-day").css({
				minWidth: width,
				maxWidth: width
			});

			$(".sch-row-header.sch-cell").css({
				minHeight: height,
				minWidth: width * 3,
				maxHeight: height,
				maxWidth: width * 3
			});
			$(".sch-row-header.sch-day").css({
				minWidth: width * 3,
				maxWidth: width * 3
			});
		}

		var getDays = function(clbk){
			var days = [];
			var dt = new Date(settings.date);
			dt = new Date(settings.startDate);
			var dtEnd = new Date(settings.endDate);

			var format = "TT\nDD", pushData = null;
			while(dt <= dtEnd) {
				/*
				if (dt.getMonth() == 1) {
					format = "YYYY MMM DD, DDD";
				} else if (dt.getDate() == 1) {
					format = "MMM DD, DDD";
				} else {
					format = "DD, DDD";
				}*/
				pushData = {
					date: new Date(dt),
					text: dt.format(format)
				};
				days.push(pushData);

				if (typeof clbk === "function" && !clbk(pushData)) {
					break;
				}

				dt.addDays(1);
			}
			return days;
		};

		// Clears all reservations off of the calendar
		var clearCalendar = function () {
			$("#scheduler").find(".sch-reservation").remove();
		}

		_this.init = function(elem){
			drawDatas = [];
			var table = render.calendar(elem);
			table.height($("#main-container").height() - 10);

			setSize();
			$(".sch-date").text(new Date(settings.date).format('MMM, dd yyyy'));
			attachEventListeners();

			if (lastDay) {
				var diff = lastDay - new Date(settings.startDate);
				diff = diff / (1000*60*60*24);
				rowContainer.scrollLeft(diff * settings.timeslotWidth);
			}
			if (lastTop) {
				rowContainer.scrollTop(lastTop);
			}

			typeof settings.onReady === "function" && settings.onReady(_this);
		};

		_this.scrollToToday = function(){
			rowContainer.scrollLeft($(".sch-timeslot.sch-day.today").position().left - (settings.timeslotWidth * 3));
		};

		_this.update = function(data){

			if (data.settings) {
				var oldStartDate = new Date(settings.startDate);
				var oldEndDate = new Date(settings.endDate);
				var prependList = [],
					appendList = [];

				settings = $.extend(settings, data.settings);

				var days = getDays(function(obj){
					var timeslot = $("<div/>").addClass("sch-timeslot " + "sch-day").text(obj.text);

					if (obj.date < oldStartDate) {
						prependList.push(timeslot);
					} else if (obj.date > oldEndDate) {
						appendList.push(timeslot);
					}
					return true;
				});

				if (prependList.length > 0) {
					columnHeader.prepend(prependList);
				}

				if (appendList.length > 0) {
					columnHeader.append(appendList);
				}

				$("> div", columnHeader).css("minWidth", settings.timeslotWidth);

				$(".sch-body-group").width(rowContainer.get(0).scrollWidth);

				if (prependList.length > 0) {
					var scrollLeft = rowContainer.scrollLeft();
					$(".sch-rsvn-container .sch-reservation-final").each(function(){
						$(this).css({
							left: (prependList.length * settings.timeslotWidth) + $(this).position().left
						});
					});
					rowContainer.scrollLeft(scrollLeft + (prependList.length * settings.timeslotWidth));
				}
			}

console.log("Update Data : ", data);
		};
	}

}(jQuery));

