﻿(function (Otime) {

	Otime.Comments = new function Comments() {
		//		"use strict";

		var _this = this;

		_this.name = "comments";

		_this.model = "CommentsListModel";

		_this.language = null;

		_this.module = '';

		_this.appModel = null;

		_this.Types = {
			COMMENTS: 1,
			ACTIVITIES: 2,
			ATTACHMENTS: 4
		};

		//		_this.isSeparate	= false;

		//		_this.all_users	= {};

		/***********************************************************************
		 * Load & show all reply for an given comment id
		 * 
		 * @param task_id
		 * @returns {Function}
		 */
		var showReplies = function (module_type, module_id) {
			return function (item) {
				if (item.is_reply_list()) {
					item.is_reply_list(false);
					return;
				}
				Otime.app.loadData(new Otime.ContextModel({
					url: Otime.siteUrl + "/comments/listing/" + item.comment_id(),
					data: {
						module_type: module_type,
						module_id: module_id
					},
					global: false,
					callback: function (cont) {
						var resp = cont.response;
						var arrReply = [];
						var dt;
						resp.items.otvalues.setKeys(resp.items.otkeys, function (itm) {
							dt = Otime.stoj(itm.created_date, true);
							arrReply.push(new _this.TimeLineContent(itm, dt, null, item));
						});
						item.reply_list(arrReply);
						item.is_reply_list(true);
					}
				}), true);
			};
		};

		/***********************************************************************
		 * Move the attachments
		 */
		var moveAttachment = function (fileName, attachmentId, clbk) {
			var postData = {
				attachment_id: attachmentId,
				file_name: fileName
			};
			Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/attachment/move_attachments", postData, function (cont) {
				clbk && typeof clbk == "function" && clbk();
			}), true);
		};

		/***********************************************************************
		 * Prepend the newly posted comments to the task.timeline array.
		 */
		var prependNewComment = function (resp, self, parent) {
			if (resp.items && resp.items[0]) {
				var newData = resp.items[0];
				newData.timeline_type = "comments";
				var newItem = new _this.TimeLineContent(newData, Otime.stoj(resp.items[0].created_date, true), function () {
					if (resp.attachments) {
						return resp.attachments;
					}
				}, parent);

				parent.timeline.prependSingle(newItem);
				if (parent.isSeparate) {
					parent.comments.prependSingle(newItem);
				}

				calc_count(parent);

				typeof parent.onNewPost === "function" && parent.onNewPost();
			}
			self.cancel();
		};

		/***********************************************************************
		 * Prepend the newly added attachment to the task.timeline array.
		 */
		var prependNewDocument = function (resp, self, parent) {
			if (resp.attachment_id) {
				resp.timeline_type = "attach";

				var newItem = new _this.TimeLineContent(resp, Otime.stoj(resp.posted_date, true), null, parent);
				parent.timeline.prependSingle(newItem);
				if (parent.isSeparate) {
					parent.attachments.prependSingle(newItem);
				}

				calc_count(parent);

				typeof parent.onNewPost === "function" && parent.onNewPost();
			}
			self.cancel();
		};

		/***********************************************************************
		 * New Comment Save
		 */
		//		var saveComment = function(attach, savedFileName, self, parent, clbk){
		var saveComment = function (attachDetails, imgDatas, self, parent, clbk) {
			var postData = {
				comment_id: 0,
				message: self.message(),
				module_id: self.module_id,
				module_type: self.module_type,
				parent_comment_id: 0,
				attachments: (attachDetails && attachDetails.length > 0) ? 1 : 0,
				attachment_details: attachDetails || null,
				attachment_image: self.attachment_image(),
				get_item: 1
			};

			Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/comments/save", postData, function (cont) {
				var resp = cont.response;
				if (attachDetails && imgDatas && resp) {
					var cnt = 0;
					$.each(attachDetails, function (key, attach) {
						moveAttachment(imgDatas[attach.uid], resp.attachment_id[attach.uid], function () {
							cnt++;
							if (cnt == attachDetails.length) {
								prependNewComment(resp, self, parent);
								typeof clbk === 'function' && clbk();
							}
						});
					});
					return true;
				}

				prependNewComment(resp, self, parent);
				typeof clbk === 'function' && clbk();
				// CALL HERE
			}), true);
		};

		var saveReply = function (data) {
			if (!data.message().trim()) {
				return false;
			}
			var postData = {
				comment_id: 0,
				message: data.message(),
				module_id: data.module_id,
				module_type: data.module_type,
				parent_comment_id: data.commentItem.comment_id()
			};

			Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/comments/save", postData, function (cont) {
				var resp = cont.response;
				postData.comment_id = resp.comment_id;
				postData.create_data = resp.create_data;
				postData.created_by = Otime.userDetails.id;
				postData.timeline_type = "comments";
				postData.message = postData.message.escapeHtml();
				data.commentItem.reply_list.push(new _this.TimeLineContent(postData, Otime.stoj(postData.create_data, true), null, data.commentItem));
				data.commentItem.is_reply_list(true);
				data.message("");
			}), true);
		};

		//		_this.fileapi	= new FileAPI({
		//			dropZone : "#right-pane, #bottom-pane"
		//		});
		//		_this.fileapi.dropZoneSelector	= "#right-pane, #bottom-pane";
		//		_this.fileapi.url = Otime.siteUrl + '/attachment/image_upload';
		//		_this.fileapi.buttonValue = '<span class="icon icon-paper-clip"></span>&nbsp;&nbsp;Attach a File';
		//		_this.fileapi.buttonClass = "btn btn-default btn-sm";

		/***********************************************************************
		 * 
		 * @param data
		 * @param parent
		 */
		_this.NewActivityModel = function (data, parent) {
			var self = this;

			data = data || {};

			self.message = Otime.o("");
			self.chk_message = Otime.o("");
			self.chk_id = Otime.o(0);
			self.is_edit = Otime.o(false);
			self.order_no = Otime.o(0);
			self.is_closed = Otime.o(false);
			self.module_id = data.module_id;
			self.module_type = data.module_type;
			self.attachment_image = Otime.o("");

			self.show_controls = Otime.o(false);

			$("#right-pane, #bottom-pane").unbind("dragenter").unbind("dragleave").unbind("dragover").unbind("drop");
			self.fileapi = new FileAPI({
				dropZone: data.dropZone || "#timeline"// #right-pane, #bottom-pane
			});

			self.fileapi.url = Otime.siteUrl + '/attachment/image_upload';
			self.fileapi.buttonValue = data.buttonValue || '<span class="icon icon-paper-clip"></span>&nbsp;&nbsp;Attach a File';
			self.fileapi.buttonClass = data.buttonClass || "btn btn-default btn-sm";

			var computeShowControls = function () {
				if (!self.message() && !self.fileapi.fileQueue.length) {
					self.show_controls(false);
				}
				else {
					self.show_controls(true);
				}
			};
			self.message.subscribe(computeShowControls);
			self.fileapi.onCompleteAll = function () {
				self.fileapi.clearList();
			};
			self.fileapi.onAddAllFiles = function () {
				computeShowControls();
				typeof data.onAddFile === "function" && data.onAddFile(self);
			};
			self.fileapi.onRemoveFile = computeShowControls;

			// self.onBlur = function(){
			// computeShowControls();
			// };
			// self.onFocus = function(){
			// self.show_controls(true);
			// };

			var saveFlag = false;
			self.save = function () {
				if (saveFlag) {
					return false;
				}
				var queueLength = self.fileapi.fileQueue.length;

				// Post as comment with attachment.
				if (self.message().trim() != "") {
					if (queueLength > 0) {
						var finishedUploads = 0;
						var attachDetails = [];
						var img_datas = {};
						saveFlag = true;
						self.fileapi.onAfterUpload = function (img_data, fileObj) {
							finishedUploads++;

							if (img_data[0]) {
								var fileSize = fileObj.file.size;
								var filename = fileObj.file.name;
								var files = filename.split('.');
								var ext = files.pop();

								attachDetails.push({
									module_id: 0,
									module_type: "",
									uid: finishedUploads,
									file_type: ext,
									file_name: files.join('.'),
									file_path: img_data[2].file_name,
									file_size: fileSize,
									title: ""
								});
								saveFlag = false;

								img_datas[finishedUploads] = img_data[2].file_name.replace("." + ext, "");
								if (finishedUploads == queueLength) {
									saveFlag = true;
									saveComment(attachDetails, img_datas, self, parent, function () {
										saveFlag = false;
										parent && parent.has_comments && parent.has_comments(true);
									});
								}
							}
							else if (img_data[1]) {
								Otime.error_message(img_data[1], $("#alert_message"));
							}
						};
						self.fileapi.uploadQueue();
						return true;
					}
					else {
						saveFlag = true;
						saveComment(null, null, self, parent, function () {
							saveFlag = false;
							parent && parent.has_comments && parent.has_comments(true);
						});
					}
				}
				else if (queueLength > 0) // Post as attachments;
				{
					if (data.is_comment && parent.isSeparate) {
						return false;
					}
					saveFlag = true;
					self.fileapi.onAfterUpload = function (img_data, fileObj) {
						if (img_data[0]) {
							var fileSize = fileObj.file.size;
							var filename = fileObj.file.name;
							var files = filename.split('.');
							var ext = files.pop();

							saveFlag = false;

							var url = Otime.siteUrl + "/tasks/store/" + self.module_id + "/document";
							if (self.module_type == "P") {
								url = Otime.siteUrl + "/project/store/" + self.module_id + "/document";
							} else if (self.module_type == "M") {
								url = Otime.siteUrl + "/team/store/" + self.module_id + "/document";
							}

							var postData = {
								module_id: self.module_id,
								module_type: self.module_type,
								new_attachment: [{
									attachment_id: 0,
									file_size: fileSize,
									file_type: ext,
									file_name: files.join('.'),
									file_path: img_data[2].file_name,
									module_id: self.module_id,
									module_type: self.module_type,
									posted_by: 0
								}]
							};
							saveFlag = true;
							Otime.app.postData(new Otime.ContextModel(url, postData, function (cont) {
								var resp = cont.response;
								moveAttachment(img_data[2].file_name.replace("." + ext, ""), resp.attachment_id, function () {
									prependNewDocument(resp, self, parent);
								});
								saveFlag = false;
								parent && parent.has_attachments && parent.has_attachments(true);
							}), true);
						}
						else if (img_data[1]) {
							Otime.error_message(img_data[1], $("#alert_message"));
						}
					};
					self.fileapi.uploadQueue();
				}
			};

			self.cancel = function () {
				self.message("");
				self.attachment_image("");
				computeShowControls();
			};

			self.save_checklist = function (itm, e) {
				if (parent.sel_checklist() && parent.sel_checklist().is_edit) {
					parent.sel_checklist().is_edit(false);
					parent.sel_checklist(null);
				}

				var msg = self.chk_message().trim();
				var messages = [];

				if (!msg || !msg.match(/\S+/ig) || e.shiftKey || e.keyCode != 13) {
					return true;
				}

				msg = msg.split(/\r?\n/);

				$.each(msg, function (key, val) {
					if (val.trim()) {
						messages.push(val.trim());
					}
				});
				if (!messages) return true;

				var postData = {
					chk_id: self.chk_id(),
					message: messages,
					module_id: self.module_id,
					module_type: self.module_type,
					order_no: self.order_no()
				};

				Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/comments/save_checklist", postData, function (cont) {
					var resp = cont.response;
					if (resp.length > 0) {
						$.each(resp, function (key, val) {
							if (postData.message[key].trim()) {
								var newData = {};
								newData.chk_id = val;
								newData.message = postData.message[key].trim();
								newData.module_id = self.module_id;
								newData.module_type = self.module_type;
								newData.timeline_type = "checklist";
								var newItem = new _this.TimeLineContent(newData, Otime.stoj(new Date(), true), null, parent);

								parent.timeline.push(newItem);
								if (parent.isSeparate) {
									parent.checklist.push(newItem);
								}
							}
						});
						$('#chk_message').val('').change();
						$("#chklist").scrollTop($('#chklist')[0].scrollHeight);
					}
				}), true);
			}
		};

		_this.ImageBox = { imgbox: Otime.o(null) };

		var bindImageBox = function () {
			var img_box_container = $("#img-preview");
			if (!ko.dataFor(img_box_container.get(0))) {
				ko.applyBindings(_this.ImageBox, img_box_container.get(0));
				img_box_container.modal();
			}
			img_box_container.modal("show");
			return img_box_container;
		};

		var calc_count = function (parent) {
			var cnt = { comments: 0, attach: 0, activity: 0 };

			if (parent.all_timeline().length > 0) {
				$.each(parent.all_timeline(), function (key, val) {
					cnt[val.timeline_type()] = cnt[val.timeline_type()] + 1;
				});
			}
			if (parent.timeline().length > 0) {
				$.each(parent.timeline(), function (key, val) {
					cnt[val.timeline_type()] = cnt[val.timeline_type()] + 1;
				});
			}
			if (parent.comments().length > 0) {
				cnt.comments = cnt.comments + parent.comments().length;
			}
			if (parent.all_comments().length > 0) {
				cnt.comments = cnt.comments + parent.all_comments().length;
			}
			if (parent.attachments().length > 0) {
				cnt.attach = cnt.attach + parent.attachments().length;
			}
			if (parent.all_attachments().length > 0) {
				cnt.attach = cnt.attach + parent.all_attachments().length;
			}

			typeof parent.onUpdate === "function" && parent.onUpdate(cnt);

			return cnt;
		};

		_this.TimeLineContent = function (data, dt, getCommentAttachment, parent) {
			var self = this;

			data = data || {};

			// Common Variable.
			self.date = Otime.o(new Date(dt));

			self.timeline_type = Otime.o(data.timeline_type);
			//			self.getRoot = function(){
			//				return root;
			//			};

			// Comments variables
			self.user_name = Otime.o(data.user_name || "");
			self.user_image = Otime.o(Otime.USIP + (data.user_image || "noimgenc.jpg"));

			self.preview = function (item) {
				if (item.isNoImg()) {
					return true;
				}

				parent && parent.imgbox && parent.imgbox(item);
				_this.ImageBox.imgbox(item);
				bindImageBox();
				return false;
			};
			self.next_preview = function (item) {
				//				_this.ImageBox.imgbox(item);
				console.log(parent);
				//				bindImageBox();
				return false;
			};
			self.prev_preview = function (item) {
				//				_this.ImageBox.imgbox(item);
				console.log(parent);
				//				bindImageBox();
				return false;
			};

			if (self.timeline_type() != 'attach') {
				self.message = Otime.o(data.message || "");
				self.reply_count = Otime.o((data.reply_count || 0) - 0);
				self.a_mode = Otime.o(data.a_mode || "TE");
				self.comment_id = Otime.o(data.comment_id || 0);
				self.parent_comment_id = Otime.o(data.parent_comment_id || 0);
				self.can_delete = Otime.o(false);
				self.attachment_details = Otime.a([]);
				self.chk_id = Otime.o(data.chk_id || 0);
				self.order_no = Otime.o(data.order_no || 0);
				self.is_closed = Otime.o(!!(data.is_closed - 0) || false);
				self.is_edit = Otime.o(false);

				if (data.attachments - 0) {
					// self.attachment_details(new
					// Otime.AttachmentDetailModel(getCommentAttachment(self.comment_id())));
					var attachList = null;
					if (attachList = getCommentAttachment(self.comment_id())) {
						$.each(attachList, function (key, attachData) {
							attachData.timeline_type = "attach";
							self.attachment_details.push(new _this.TimeLineContent(attachData, dt, null, parent));
						});
					}
				}

				self.new_reply = Otime.o(null);
				self.is_reply_list = Otime.o();
				self.reply_list = Otime.a();

				var module_id = data.module_id;
				var module_type = data.module_type;
				if ((self.parent_comment_id() - 0) > 0) {
					self.delete_reply = function (comment) {
						return function (item, elem) {
							if (!confirm("Are you sure you want to delete this reply ?")) {
								return;
							}
							Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/comments/delete_reply_comment/" + item.comment_id(), {
								module_id: module_id,
								module_type: module_type
							}, function (cont) {
								comment.reply_list.remove(item);
								comment.reply_count(comment.reply_list().length);
							}), true);
						}
					};
				}
				else {
					self.delete_comment = function (item, elem) {
						if (!confirm("Are you sure you want to delete this comment ?")) {
							return;
						}
						Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/comments/delete/" + item.comment_id(), {
							module_id: module_id,
							module_type: module_type
						}, function () {
							parent.all_timeline.remove(item);
							parent.timeline.remove(item);
							if (parent.isSeparate) {
								parent.all_comments.remove(item);
								parent.comments.remove(item);
							}

							calc_count(parent);
						}), true);
					};
				}

				if (self.timeline_type() == 'checklist') {
					self.is_closed.subscribe(function (newVal) {
						console.log(newVal, 'newVal');
						Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/comments/toggle_status/" + self.chk_id(), {
							module_id: module_id,
							module_type: module_type
						}, function (cont) {
							parent.checklist.valueHasMutated();
						}), true);
					});

					self.delete_checklist = function (item) {
						if (!confirm("Are you sure delete this checklist?")) {
							return;
						}
						Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/comments/delete_checklist/" + item.chk_id(), {
							module_id: module_id,
							module_type: module_type
						}, function () {
							parent.all_timeline.remove(item);
							parent.timeline.remove(item);
							if (parent.isSeparate) {
								parent.all_checklist.remove(item);
								parent.checklist.remove(item);
							}
							//parent.sortDetail();
						}), true);
					};

					self.edit_checklist = function (item, e) {
						if (parent.sel_checklist() && parent.sel_checklist().is_edit) {
							parent.sel_checklist().is_edit(false);
							parent.sel_checklist(null);
						}
						item.is_edit(true);
						parent.sel_checklist(item);
						setTimeout(function () {
							$("#chkid" + item.chk_id() + " textarea.commentContent").focus();
						}, 200);
					};

					self.save_checklist = function (item, e) {
						var msg = item.message().trim();
						var messages = [];

						if (!msg || !msg.match(/\S+/ig) || e.shiftKey || e.keyCode != 13) {
							return true;
						}

						msg = msg.split(/\r?\n/);
						$.each(msg, function (key, val) {
							if (val.trim()) {
								messages.push(val.trim());
							}
						});
						if (!messages) return true;

						var postData = {
							chk_id: item.chk_id(),
							message: messages,
							module_id: module_id,
							module_type: module_type,
							order_no: item.order_no()
						};

						Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/comments/save_checklist", postData, function (cont) {
							var resp = cont.response;
							item.is_edit(false);
							parent.sel_checklist(null);
						}), true);
					}
				}

			}

			self.created_by = Otime.o(data.created_by || "");
			if (data.created_by && Object.keys(Otime.Details.all_users).length) {
				var createdBy = Otime.Details.all_users[data.created_by];
				self.user_name(createdBy.user_name);
				self.user_image = Otime.o(createdBy.user_image || "noimgenc.jpg");

				self.can_delete && self.can_delete(self.created_by() == Otime.UID);
			}

			if (data.posted_by) {
				self.user_name(data.posted_by)
			}

			if (self.timeline_type() == "attach") {
				self.attachment_id = Otime.o(data.attachment_id || 0);
				self.encrypt_key = Otime.o(data.encrypt_key || "");
				self.file_name = Otime.o(data.file_name || "");
				self.file_path = Otime.o(data.file_path || "");
				self.file_type = Otime.o(data.file_type || "");
				self.file_size = Otime.o(data.file_size || "");
				self.posted_by = Otime.o(data.posted_by || "");
				self.encrypted_url = Otime.o();
				self.download_url = Otime.o();
				self.tooltip = Otime.o();

				var tooltipContent = "";
				tooltipContent += self.file_name() + "." + self.file_type() + "\n";
				tooltipContent += "File Size :\t\t\t" + bytesToSize(self.file_size()) + "\n";
				tooltipContent += "Posted by :\t\t" + self.posted_by() + "\n";

				self.tooltip(tooltipContent);

				self.isNoImg = Otime.o(false);
				if ((["bmp", "jpg", "jpeg", "png", "svg", "gif"]).indexOf(self.file_type().toLowerCase()) < 0) {
					self.isNoImg(true);
					self.encrypted_url(Otime.baseUrl + "index.php/attachment/file/" + self.encrypt_key());
					self.download_url(Otime.baseUrl + "index.php/attachment/download/" + self.encrypt_key());
				}
				else {
					self.encrypted_url(Otime.attachUrl(self.file_path()));
					self.download_url(Otime.baseUrl + "index.php/attachment/download/" + self.encrypt_key());
				}
			}
		};

		_this.loadTimeLineData = function (objModule, params, clbk) {
			var module_type = params.module_type;
			var module_id = params.module_id;
			var parent = params.parent;

			if (params.close)
				objModule.close = params.close;

			objModule.newActivity(new _this.NewActivityModel({
				module_type: module_type,
				module_id: module_id,
				is_comment: true,
				dropZone: params.dropZone || null,
				//				buttonValue: params.fileApi_buttonValue || "",
				buttonValue: '<span class="icon icon-paper-clip blue"></span>',
				//				buttonClass: params.fileApi_buttonClass || ""
				buttonClass: "blue anchor"
			}, objModule, parent));

			objModule.newAttach(new _this.NewActivityModel({
				module_type: module_type,
				module_id: module_id,
				dropZone: "#attachment_list",
				buttonValue: '<span class="icon icon-paper-clip blue"></span>',
				buttonClass: "blue anchor",
				onAddFile: params.onAddFile
			}, objModule, parent));

			if (objModule.timeline() != null && objModule.timeline.locked) {
				return;
			}

			_this.loadMore(params, objModule);
		};

		var page = 0;
		_this.loadMore = function (params, objModule) {
			if (!params.module_id || !params.module_type)
			{
				return;
			}

			page++;

			var module_type = params.module_type;
			var module_id = params.module_id;
			var parent = params.parent;

			var filters = params.filters || {};
			var user_id = filters.user_id || 0;

			var postData = {
				filter: params.filter || "all",
				module_type: module_type,
				module_id: module_id,
				user_id: filters.user_id,
				page: page
			};

			//			filters && filters.user_id && (postData.user_id=filters.user_id);
			//			filters && (postData.filters=filters);
			typeof params.onBeforeLoad === "function" && params.onBeforeLoad(postData);
			Otime.app.loadData(new Otime.ContextModel({
				url: Otime.siteUrl + "/comments/timeline",
				data: postData,
				global: false,
				callback: function (cont) {
					var response = cont.response;
					var ret = {};
					var time, keydate, keytime;

					var dates = [], times = [];

					var fillData = function (date, val) {
						if (!date) {
							return;
						}
						time = Otime.stoj(date, true);
						if (!time) {
							return false;
						}

						keydate = time.format("YYYY-MM-DD");
						keytime = time.format("OO-NN-SS");

						if (!ret[keydate])
							ret[keydate] = {};
						if (!ret[keydate][keytime])
							ret[keydate][keytime] = [];

						if (dates.indexOf(keydate) < 0)
							dates.push(keydate);
						if (times.indexOf(time.getTime()) < 0)
							times.push(time.getTime());

						ret[keydate][keytime].push(val);
					};
					/*
										if (response.all_users && Object.keys(response.all_users).length > 0)
										{
											_this.all_users = response.all_users.otvalues.setKeys(response.all_users.otkeys, null, "user_id");
										}
					*/
					if (response.attachment && Object.keys(response.attachment).length > 0) {
						response.attachment.otvalues.setKeys(response.attachment.otkeys, function (itm) {
							itm.timeline_type = "attach";
							fillData(itm.posted_date, itm);
						});
					}
					if (response.task_detail && Object.keys(response.task_detail).length > 0) {
						response.task_detail = response.task_detail.otvalues.setKeys(response.task_detail.otkeys, null, 'task_id');
					}

					if (response.activity && Object.keys(response.activity).length > 0) {
						var td_len = 0;
						if (response.task_detail && (Otime.app.currentView.name == 'profile' || Otime.app.currentView.name == 'users')) {
							td_len = Object.keys(response.task_detail).length;
						}

						response.activity.otvalues.setKeys(response.activity.otkeys, function (itm) {
							itm.timeline_type = "activity";

							if (td_len && itm.module_type == 'T' && response.task_detail[itm.module_id]) {
								itm.message = Otime.Details.all_projects[response.task_detail[itm.module_id].project_id].project_name + ' #' + response.task_detail[itm.module_id].task_number + ' ' + itm.message;
							}
							fillData(itm.created_date, itm);
						});
					}

					if (response.comments && Object.keys(response.comments).length > 0) {
						response.comments.otvalues.setKeys(response.comments.otkeys, function (itm) {
							itm.timeline_type = "comments";
							fillData(itm.created_date, itm);
						});
					}
					if (response.comments_attachments && Object.keys(response.comments_attachments).length > 0) {
						var cmtAttach = {};
						response.comments_attachments = response.comments_attachments.otvalues.setKeys(response.comments_attachments.otkeys, function (item) {
							if (!cmtAttach[item.module_id])
								cmtAttach[item.module_id] = [];
							cmtAttach[item.module_id].push(item);
						});
						response.comments_attachments = cmtAttach;
					}

					if (response.checklist && Object.keys(response.checklist).length > 0) {
						response.checklist.otvalues.setKeys(response.checklist.otkeys, function (itm) {
							itm.timeline_type = "checklist";
							itm.created_date = new Date().format("YYYY-MM-DD OO:NN:SS");
							fillData(itm.created_date, itm);
						});

						// if (response.chkl_cnt) {
						// 	objModule.chkl_cnt(response.chkl_cnt);
						// }
					}

					if (response.tags && Object.keys(response.tags).length > 0) {
						response.tags = response.tags.otvalues.setKeys(response.tags.otkeys);
						if (objModule.all_tags) {
							var tags = [];
							$.each(response.tags, function (idx, val) {
								tags.push(val.id);
							});
							objModule.all_tags(tags);
						}
					}

					dates.mergeSort();
					times.mergeSort();
					if (!params.asc_order) {
						dates.reverse();
						times.reverse();
					}

					var getCommentAttachment = function (commentId) {
						return response.comments_attachments[commentId];
					};

					objModule.show_replies = showReplies(module_type, module_id);
					objModule.reply = function (commentItem) {
						if (commentItem.new_reply()) {
							commentItem.new_reply(null);
						}
						else {
							commentItem.new_reply({
								message: Otime.o(),
								onKeyPress: function (itm, e) {
									if (e.keyCode == 13) {
										saveReply({
											message: this.message,
											commentItem: commentItem,
											module_type: module_type,
											module_id: module_id
										});
										return false;
									}
									return true;
								}
							});
						}
					};

					var arrTimeLine = [],
						tmpModel = null,
						objTimeLine = { comments: [], activity: [], attach: [], checklist: [] };
					for (var i = 0, iLen = times.length, dt = null, timeList = []; i < iLen; i++) {
						dt = new Date(times[i]);
						timeList = ret[dt.format("YYYY-MM-DD")][dt.format("OO-NN-SS")];
						for (var j = 0, jLen = timeList.length; j < jLen; j++) {
							tmpModel = new _this.TimeLineContent(timeList[j], dt, getCommentAttachment, objModule, parent);
							arrTimeLine.push(tmpModel);
							if (objModule.isSeparate) {
								objTimeLine[tmpModel.timeline_type()].push(tmpModel);
							}
						}
					}

					objModule.all_timeline(arrTimeLine);
					objModule.timeline(objModule.all_timeline.splice(0, 10));

					if (objModule.isSeparate) {
						objModule.all_comments(objTimeLine.comments);
						objModule.comments(objModule.all_comments.splice(0, objModule.c_limit()));

						//objModule.all_checklist(objTimeLine.checklist);
						objModule.checklist(objTimeLine.checklist);

						// Begins Grouping activity by user & time.
						if (objTimeLine.activity && objTimeLine.activity.length > 1) {
							var prev = null;
							var remove = [];
							var ign_type = { LN: 1, LO: 1 };
							$.each(objTimeLine.activity, function (key, val) {
								if (prev && !ign_type[val.a_mode()] && val.created_by() == prev.created_by() && val.date().format("YYYY_MM_DD_OO_NN") == prev.date().format("YYYY_MM_DD_OO_NN")) {
									prev.message($.trim(val.message() + "\n" + prev.message()));
									remove.push(val);
								}
								else {
									prev = val;
								}
							});
							if (remove && remove.length > 0) {
								$.each(remove, function (key, val) {
									objTimeLine.activity.splice(objTimeLine.activity.indexOf(val), 1)
								});
							}
						}
						// End Grouping activity by user & time.

						objModule.all_activity(objTimeLine.activity);
						objModule.activity.append(objModule.all_activity.splice(0, objModule.c_limit()));

						objModule.all_attachments(objTimeLine.attach);
						objModule.attachments(objModule.all_attachments.splice(0, objModule.c_limit()));
					}

					objModule.timeline.locked = true;
					setTimeout(function () {
						objModule.timeline.locked = false;
					}, 300000);// 5 minutes (1000*60*5)

					typeof params.onAfterLoad === "function" && params.onAfterLoad(objModule, cont);
					typeof clbk === 'function' && clbk(objModule, cont);
				}
			}), true);
		};

		var RightPaneModel = function (params) {
			var self = this;

			var module_type = params.module_type;
			var module_id = params.module_id;

			self.module_type = module_type;
			self.newActivity = params.newActivity || Otime.o(null);
			self.newAttach = params.newAttach || Otime.o(null);
			self.checklist = params.checklist || Otime.a();
			self.comments = params.comments || Otime.a();
			self.activity = params.activity || Otime.a();
			self.attachments = params.attachments || Otime.a();
			self.timeline = params.timeline || Otime.a();

			self.all_checklist = params.all_checklist || Otime.a();
			self.all_comments = params.all_comments || Otime.a();
			self.all_activity = params.all_activity || Otime.a();
			self.all_attachments = params.all_attachments || Otime.a();
			self.all_timeline = params.all_timeline || Otime.a();
			self.all_tags = Otime.a(params.all_tags || []);
			self.sel_checklist = Otime.a();
			if (typeof params.onChangeCheckList === 'function') {
				self.checklist.subscribe(function (newVal) {
					params.onChangeCheckList(self);
				});
			}

			self.onNewTag = function (term, clbk) {
				term = term.trim();
				if (!term) {
					clbk && clbk();
					return false;
				}

				var postData = {
					module_id: module_id,
					module_type: module_type,
					tagName: term,
					action: "new"
				};

				Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/tag/save", postData, function (cont) {
					var resp = cont.response;
					if (resp && resp.tag_id) {
						var newItem = {
							id: resp.tag_id,
							tagName: term
						};

						typeof params.onAddTag === "function" && params.onAddTag(newItem);

						Otime.Details.tagsById[newItem.id] = {
							id: newItem.id,
							tagName: term
						};
						Otime.Details.tags.push(Otime.Details.tagsById[newItem.id]);

						self.all_tags.push(newItem.id);

						clbk && clbk();
					}
				}), true);
			};

			self.onTagsChange = function (evt, act) {
				if (!act) {
					return;
				}

				var postData = {
					module_id: module_id,
					module_type: module_type
				};

				if (act.selected) {
					postData.action = "add";
					postData.tag_id = act.selected;
				}
				else if (act.deselected) {
					postData.action = "remove";
					postData.tag_id = act.deselected;
				}

				Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/tag/save", postData, function (cont) {
					var resp = cont.response;
					typeof params.onTagUpdate === "function" && params.onTagUpdate(self.all_tags());
				}), true);

			};

			self.sortDetail = function (item) {
				var postData = [];
				$.each(self.checklist(), function (key, val) {
					if (key != val.order_no()) {
						val.order_no(key);
						postData.push({ chk_id: val.chk_id(), order_no: val.order_no() });
					}
				});
				Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/comments/reorder_checklist", { list: postData }, function (cont) {
					var resp = cont.response;
					console.log(resp);
				}), true);
			};

			self.chkl_cnt = Otime.c(function () {
				return self.checklist().filter(function (_itm) {
					//console.log(_itm);
					return _itm.is_closed();
				}).length;
			});

			self.is_cmt_min = Otime.o(true);
			self.is_att_min = Otime.o(true);
			self.is_act_min = Otime.o(true);
			self.is_chkl_min = Otime.o(true);
			self.is_tags_min = Otime.o(true);

			self.imgbox = Otime.o(null);

			self.onUpdate = params.onUpdate || null;

			self.paneTypes = {
				COMMENT: 1,
				DOCUMENT: 2,
				ACTIVITY: 4,
				CHECKLIST: 8,
				TAGS: 16,
				ALL: 31
			},
				self.paneType = Otime.o(7);

			self.is_comment = Otime.o(true); // 1,3,5,15
			self.is_comment.subscribe(function (newVal) {
				self.is_cmt_min(newVal ? false : true);

				//				self.newActivity(new _this.NewActivityModel({
				//					module_type : module_type,
				//					module_id : module_id,
				//					dropZone: params.dropZone || null,
				//					buttonValue: params.fileApi_buttonValue || "",
				//					buttonClass: params.fileApi_buttonClass || ""
				//				}, objModule, parent));

				//				self.newAttach(new _this.NewActivityModel({
				//					module_type : module_type,
				//					module_id : module_id,
				//					dropZone: "#attachment_list" || null,
				//					buttonValue: "&nbsp;",
				//					buttonClass: "dn",
				//					onAddFile: params.onAddFile
				//				}, objModule, parent));
			});
			self.is_document = Otime.o(true); // 2,3,6,15
			self.is_document.subscribe(function (newVal) {
				self.is_att_min(newVal ? false : true);
			});
			self.is_activity = Otime.o(true); // 4,5,6,15
			self.is_activity.subscribe(function (newVal) {
				self.is_act_min(newVal ? false : true);
			});
			self.is_checklist = Otime.o(true); // 8,15
			self.is_checklist.subscribe(function (newVal) {
				self.is_chkl_min(newVal ? false : true);
			});
			self.is_tags = Otime.o(true);
			self.is_tags.subscribe(function (newVal) {
				self.is_tags_min(newVal ? false : true);
			});
			self.is_all = Otime.o(true);

			self.attachDoc = function (item, elem) {
				var parent = $(elem.delegateTarget).parents(".attachment-group");
				$("#newFileAttach", parent).trigger("click");
			};

			self.deleteAttachment = function (item) {
				var attachment_id = item.attachment_id();
				if (!attachment_id) {
					return false;
				}

				if (!confirm("Are you sure to delete this attachment ?\n\n" + (item.file_name() + '.' + item.file_type()))) {
					return false;
				}

				Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/attachment/delete_attachment/" + attachment_id, {
					module_id: module_id,
					module_type: module_type
				}, function (cont) {
					var resp = cont.response;
					if (resp && resp[0]) {
						self.all_timeline.remove(item);
						self.timeline.remove(item);
						self.attachments.remove(item);
						self.all_attachments.remove(item);

						calc_count(self);
					}
				}), true);
			};

			self.onChangePane = function (paneType) {
				if (!paneType) {
					return function (item, elem) {
						var elem = $(elem.delegateTarget);
						self.paneType(elem.is(".active") ? 7 : 0);
						// 7 means self.paneTypes.ALL
					};
				}
				return function () {
					self.paneType(paneType);
					self.is_chkl_min(!self.is_checklist());
					self.is_cmt_min(!self.is_comment());
					self.is_att_min(!self.is_document());
					self.is_act_min(!self.is_activity());
					self.is_tags_min(!self.is_tags());

				};
			};
			self.paneType.subscribe(function (newVal) {
				self.is_comment(newVal == self.paneTypes.ALL || newVal == self.paneTypes.COMMENT);
				self.is_document(newVal == self.paneTypes.ALL || newVal == self.paneTypes.DOCUMENT);
				self.is_activity(newVal == self.paneTypes.ALL || newVal == self.paneTypes.ACTIVITY);
				self.is_checklist(newVal == self.paneTypes.ALL || newVal == self.paneTypes.CHECKLIST);
				self.is_tags(newVal == self.paneTypes.ALL || newVal == self.paneTypes.TAGS);
				self.is_all(newVal == self.paneTypes.ALL);

				//				self.is_comment([ 1, 3, 5, 7 ].indexOf(newVal) < 0 ? false : true);
				//				self.is_document([ 2, 3, 6, 7 ].indexOf(newVal) < 0 ? false : true);
				//				self.is_activity([ 4, 5, 6, 7 ].indexOf(newVal) < 0 ? false : true);

				//				Otime.Storage.set("rp_paneType", newVal);

				typeof params.onPaneChange === "function" && params.onPaneChange(newVal);
			});

			// Otime.Storage.set("rp_paneType", newVal);
			// Otime.Storage.set("rp_min_view", newVal-0);

			self.isSeparate = params.isSeparate || false;
			self.c_limit = Otime.o(params.c_limit || (params.isSeparate ? 3 : 10));	// Item per page.

			self.load_more = function (type) {
				// Need to do Load from ajax.
				switch (type) {
					case "comments":
						return function () {
							self.comments.append(self.all_comments.splice(0, self.c_limit()));
							//							0 <= self.model.all_comments.length && $(".comments_load_more").hide();
						};
						break;
					case "activity":
						return function () {
							if (params.filter && params.filter == "activity") {
								_this.loadMore(params, self);
								return;
							}

							self.activity.append(self.all_activity.splice(0, self.c_limit()));
							//							0 <= self.model.all_activity.length && $(".activity_load_more").hide();
						};
						break;
					case "attach":
						return function () {
							if (params.filter == "attach") {
								console.log("Called;");
								return;
							}
							self.attachments.append(self.all_attachments.splice(0, self.c_limit()));
							//							0 <= self.model.all_attachments.length && $(".attach_load_more").hide();
						};
						break;
					default:
						return function () {
							//if (!self.model.isSeparate)
							//{
							self.timeline.append(self.all_timeline.splice(0, 10));
							//								0 <= self.model.all_timeline.length && $(".timeline_load_more").hide();
							//}
						};
						break;
				}
			};

			self.isAttExpand = Otime.o(!!(Otime.Storage.get("isAttExpand", 1) - 0));
			self.isActExpand = Otime.o(!!(Otime.Storage.get("isActExpand", 1) - 0));
			self.isCmtExpand = Otime.o(!!(Otime.Storage.get("isCmtExpand", 1) - 0));
			self.isChklExpand = Otime.o(!!(Otime.Storage.get("isChklExpand", 1) - 0));
			self.isTagExpand = Otime.o(!!(Otime.Storage.get("isTagExpand", 1) - 0));
			self.expand = function (type) {
				switch (type) {
					case 'att':
						return function () {
							self.isAttExpand(!self.isAttExpand());
							Otime.Storage.set("isAttExpand", self.isAttExpand() ? 1 : 0);
						};
						break;
					case 'act':
						return function () {
							self.isActExpand(!self.isActExpand());
							Otime.Storage.set("isActExpand", self.isActExpand() ? 1 : 0);
						};
						break;
					case 'cmt':
						return function () {
							self.isCmtExpand(!self.isCmtExpand());
							Otime.Storage.set("isCmtExpand", self.isCmtExpand() ? 1 : 0);
						};
						break;
					case 'chkl':
						return function () {
							self.isChklExpand(!self.isChklExpand());
							Otime.Storage.set("isChklExpand", self.isChklExpand() ? 1 : 0);
						};
						break;
					case 'tags':
						return function () {
							self.isTagExpand(!self.isTagExpand());
							Otime.Storage.set("isTagExpand", self.isTagExpand() ? 1 : 0);
						};
						break;
				}
			};
			self.checkAndSetExpand = function (type, datalength) {
				switch (type) {
					case 'att':
						return function () {
							var count = calc_count(self);
							datalength = count.attach;
							if (datalength > 0) {
								self.isAttExpand(true);
								Otime.Storage.set("isAttExpand", self.isAttExpand() ? 1 : 0);
							} else {
								self.isAttExpand(false);
								Otime.Storage.set("isAttExpand", self.isAttExpand() ? 1 : 0);
							}
						};
					case 'act':
						return function () {
							self.isActExpand(false);
							Otime.Storage.set("isActExpand", self.isActExpand() ? 1 : 0);
						};
						break;
					case 'cmt':
						return function () {
							var count = calc_count(self);
							datalength = count.comments;
							if (datalength > 0) {
								self.isCmtExpand(true);
								Otime.Storage.set("isCmtExpand", self.isCmtExpand() ? 1 : 0);
							} else {
								self.isCmtExpand(false);
								Otime.Storage.set("isCmtExpand", self.isCmtExpand() ? 1 : 0);
							}
						};

						break;
					case 'chkl':
						return function () {
							if (datalength > 0) {
								self.isChklExpand(true);
								Otime.Storage.set("isChklExpand", self.isChklExpand() ? 1 : 0);
							} else {
								self.isChklExpand(false);
								Otime.Storage.set("isChklExpand", self.isChklExpand() ? 1 : 0);
							}
						};
						break;
					case 'tags':
						return function () {
							if (datalength > 0) {
								self.isTagExpand(true);
								Otime.Storage.set("isTagExpand", self.isTagExpand() ? 1 : 0);
							} else {
								self.isTagExpand(false);
								Otime.Storage.set("isTagExpand", self.isTagExpand() ? 1 : 0);
							}
						};
						break;
				}
			};

			self.toggleMinimize = function (type) {
				switch (type) {
					case "cmt":
						return function () {
							// if we not clear this list it will not render the list div while maximize | minimize.
							self.paneType(self.paneTypes.COMMENT);
							self.is_cmt_min(!self.is_cmt_min());
							if (typeof params.onToggleMinimize === "function") {
								params.onToggleMinimize(self.is_cmt_min());
							}
						};
						break;
					case "chkl":
						return function () {
							// if we not clear this list it will not render the list div while maximize | minimize.
							self.paneType(self.paneTypes.CHECKLIST);
							self.is_chkl_min(!self.is_chkl_min());
							if (typeof params.onToggleMinimize === "function") {
								params.onToggleMinimize(self.is_chkl_min());
							}
						};
						break;
					case "att":
						return function () {
							self.paneType(self.paneTypes.DOCUMENT);
							self.is_att_min(!self.is_att_min());
							if (typeof params.onToggleMinimize === "function") {
								params.onToggleMinimize(self.is_att_min());
							}
						};
						break;
					case "act":
						return function () {
							self.paneType(self.paneTypes.ACTIVITY);
							self.is_act_min(!self.is_act_min());
							if (typeof params.onToggleMinimize === "function") {
								params.onToggleMinimize(self.is_act_min());
							}
						};
						break;
					case "tags":
						return function () {
							// if we not clear this list it will not render the list div while maximize | minimize.
							self.paneType(self.paneTypes.TAGS);
							self.is_tags_min(!self.is_tags_min());
							if (typeof params.onToggleMinimize === "function") {
								params.onToggleMinimize(self.is_tags_min());
							}
						};
						break;
				}
			};

			params && params.parent && params.parent.rp_min_view(true);
			self.paneType(self.paneTypes.ALL);
			//			self.paneType(Otime.Storage.get("rp_paneType", self.paneTypes.ALL));
		};

		_this.init = function (params) {
			var self = this;

			Otime.unbind();

			_this.edit_container = $('#add-new-container');

			self.container = params.elem || null;

			self.model = params.model || {};

			if (self.model.isApplied) {
				return false;
			}
			self.model.isApplied = true;

			if (typeof self.model.rp !== "function") {
				self.model.rp = Otime.o();
			}

			if (self.model.rp() && self.model.rp().timeline && self.model.rp().timeline.locked) {
				var tmp = self.model.rp();
				tmp.isActExpand(!!(Otime.Storage.get("isActExpand", 1) - 0));
				// Already loaded.
				return false;
			}

			self.model.rp(new RightPaneModel(params));

			// new _this.TimelineModel(params);
			_this.loadTimeLineData(self.model.rp(), params, params.clbk);

			if (self.container && !params.noBind) {
				ko.applyBindings(self.model.rp(), self.container.get(0));
			}

			// self.model.loadInfo();

			if (self.container) {
				return self;
			}

			return self.model;
		};
	};
}(window.Otime));
