﻿(function(Otime){

	Otime.Profile	= new function Profile(){
//		"use strict";

		var _this	= this;

		_this.name	= "profile";

		_this.model	= "ProfileContentModel";

		_this.language	= null;
		
		_this.user_id	= null;

		_this.fileApi	= null;

		_this.proj_page	= null;

		_this.proj_finish	= null;

		_this.ProfileContentModel	= function(data){
			var self	= this;

			data	= data || {};

			self.user_id			= Otime.o(data.user_id || 0);
			self.first_name			= Otime.o(data.first_name || "").extend({required:true});
			self.last_name			= Otime.o(data.last_name || "");
			self.user_role			= Otime.o(data.user_role || "");
			self.user_roles	= data.user_roles || {};
			self.user_role_disp		= Otime.o(self.user_roles[data.user_role] || "");
			self.email				= Otime.o(data.email || "").extend({required:true, email:true});
			self.time_zone_code		= Otime.o(data.time_zone_code || 0);
			self.user_image			= Otime.o(data.user_image || "");
			self.user_image_path	= Otime.o((data.user_image) ? Otime.UMIP + data.user_image : (Otime.baseUrl + '/files/photo/no_User.png'));
			self.oldImage			= Otime.o((data.user_image) ? Otime.UMIP + data.user_image : '');
			self.is_active			= Otime.o(data.is_active || 1);
			self.old_password		= Otime.o("");
			self.password			= Otime.o("");
			self.confirm_password	= Otime.o("");
			self.profile_image		= Otime.o("");
			self.cropData	= Otime.o("");
			
			if (data.dob) {
				data.dob =  Otime.stoj(data.dob);
			}
			if (data.doj) {
				data.doj =  Otime.stoj(data.doj);
			}
			self.dob				= Otime.o(data.dob || '');
			self.doj				= Otime.o(data.doj || new Date());
			
			// self.is_weekly_mail	= Otime.o(false);
			self.rp	= Otime.o();
			self._info	= {};
			self._info.char_length		= Otime.o(false);
			self._info.is_edit_password	= Otime.o(false);
			self._info.hasCaps	= Otime.o(false);
			self._info.hasSmall	= Otime.o(false);
			self._info.is_comment_mode	= Otime.o(false);			

			self.onPassFocus	= function(){
				$("#valid_popover").toggle();
			};
			self._info.hasNumber	= Otime.o(false);

			self.password.subscribe(function(newVal){
				self._info.char_length(newVal.length<9?false:true);
				self._info.hasCaps(newVal.match(/[A-Z]/) !== null);
				self._info.hasSmall(newVal.match(/[a-z]/) !== null);
				self._info.hasNumber(newVal.match(/[0-9]/) !== null || newVal.match(/[^\w]/) !== null);
			});
			self.enable_notification	= Otime.o(!!(Otime.Storage.get("enable_notification", 1)-0));
			
			self.new_tasks				= Otime.o(false);
			self.is_daily_digest		= Otime.o(false);
			self.is_weekly_summary_mail	= Otime.o(false);
			self.my_tasks				= Otime.o(false);
			self.my_tasks_status		= Otime.o('C');
			self.follow_tasks			= Otime.o(false);
			self.follow_tasks_status	= Otime.o('C');

			var isTimeZoneChanged	= false;
			self.time_zone_code.subscribe(function(){
				isTimeZoneChanged	= true;
			});

			self.enable_notification.subscribe(function(newVal){
				Otime.Storage.set("enable_notification",newVal-0)
			});

			self._project			=	{
				total_projects: Otime.o(0),
				active_projects: Otime.o(0),
				in_active_projects: Otime.o(0),
				total_hours: Otime.o(0),
				billable: Otime.o(0),
				items: Otime.a([]),
				view_more: Otime.o(true),
				loading: Otime.o(false)
			};
			self.ActivityHandler	= Otime.o(null);
			var initCommentsActivity	= function(item, elem){
				var rp	= item.rp();
				if (!rp)
				{
					self.ActivityHandler(Otime.Comments.init({
						module: "users",
						module_type: "P,T,I,LN,LO",
						filters: {
							user_id: item.user_id()
						},
						filter: "activity",
						model: item,
						isSeparate: true,
						c_limit:10,
						noBind: true,
						close: function(){ 
							self.show_activity(item, elem);
						}
					}));
					rp	= item.rp();
				}
				rp.paneType(rp.paneTypes.ACTIVITY);
			};
			
			self.show_activity	= function(item, elem){
//				item	= self.selectedItem();
				if (self._info.is_comment_mode())
				{
					self._info.is_comment_mode(false);
					$('#comment_layout').addClass('closed').removeClass('opened');
					return true;
				}
				initCommentsActivity(item, elem);
				self._info.is_comment_mode(true);
				$('#comment_layout').addClass('opened').removeClass('closed');
			};

			self.load_more_projects	= function(){
				Otime.app.listing.load_more_projects();
			};

			_this.fileApi.buttonClass	= "dn";

			self.uploadDialog	= function(){
				$("#profile_image").trigger("click");
			};

			self.load	= function(context){
				var data	= context.response || {};
				if (data)
				{
					self.user_id(data.user_id || self.user_id());
					self.first_name(data.first_name || self.first_name());
					self.last_name(data.last_name || self.last_name());

					self.user_role(data.user_role || self.user_role());
					self.user_roles	= data.user_roles || self.user_roles;
					self.user_role_disp(self.user_roles[self.user_role()] || "");

					self.email(data.email || self.email());
					self.time_zone_code(data.time_zone_code || self.time_zone_code());
					self.user_image(data.user_image || self.user_image());
					self.user_image_path((data.user_image) ? Otime.UMIP + data.user_image : self.user_image());
					self.oldImage((data.user_image) ? Otime.UMIP + data.user_image :  self.user_image());
					self.is_active(data.is_active || self.is_active());
					if (data.dob) {
						data.dob =  Otime.stoj(data.dob);
					}
					if (data.doj) {
						data.doj =  Otime.stoj(data.doj);
					}
					self.dob(data.dob || self.dob());
					self.doj(data.doj || self.doj());

					if (data.mail_subscription && data.mail_subscription.otvalues)
					{
						var mails	= data.mail_subscription.otvalues.setKeys(data.mail_subscription.otkeys);
						var mail_types = (mails[0] && mails[0].mail_type)?mails[0].mail_type.split(','):[];

						/*if (mails['W'])
						{
							self.is_weekly_mail(!!(mails['W']["is_subscribed"]-0));
						}*/
						console.log(mail_types);
						if (mail_types.indexOf('WS')>=0)
						{
							self.is_weekly_summary_mail(1);
						}
						if (mail_types.indexOf('NT')>=0)
						{
							self.new_tasks(1);
						}
						if (mail_types.indexOf('DD')>=0)
						{
							self.is_daily_digest(1);
						}
						if (mail_types.indexOf('ATA')>=0)
						{
							self.my_tasks(1);
							self.my_tasks_status('A');
						}
						if (mail_types.indexOf('ATC')>=0)
						{
							self.my_tasks(1);
							self.my_tasks_status('C');
						}
						if (mail_types.indexOf('FTA')>=0)
						{
							self.follow_tasks(1);
							self.follow_tasks_status('A');
						}
						if (mail_types.indexOf('FTC')>=0)
						{
							self.follow_tasks(1);
							self.follow_tasks_status('C');
						}
					}
				}

				if (data.projects_info)
				{
					if(data.projects_info.items.length!=0) 
						data.projects_info.items	= data.projects_info.items.otvalues.setKeys(data.projects_info.items.otkeys);

					self._project.active_projects(data.projects_info.active_projects || 0);
					self._project.total_hours((parseFloat(data.projects_info.total_hours || 0).toFixed(2)) || 0);
					self._project.billable(data.projects_info.billable || 0);
					self._project.in_active_projects(data.projects_info.in_active_projects || 0);
					self._project.total_projects(data.projects_info.total_projects || 0);
					self._project.in_active_projects(data.projects_info.in_active_projects || 0);
					self._project.view_more(data.projects_info.view_more || false);

					self._project.items([]);
					$.each(data.projects_info.items, function(key, item){
						self._project.items.push(new _this.ProjectsInfoModel(item));
					});
				}

				if (context.mode == "EDIT")
				{
					_this.user_id(self.user_id());
				}
			};

			self.edit = function(){
				ko.editable(self);
				self.beginEdit();
				Otime.app.listing.is_edit_mode(true);
			};

			self.is_valid	= function(){
				return (self.first_name.isValid() && self.email.isValid());
			};
			
			self.removeImage = function(item) {
				item.profile_image('')
				item.user_image('');
				item.user_image_path(Otime.baseUrl + '/files/photo/no_User.png');
				item.oldImage(Otime.baseUrl + '/files/photo/no_User.png');
				$('#removeImage').attr('style','display:none');
			};

			self.save	= function(item){
				var saveCallback	= function(){
					var postData	= self.prepareData();
					if (!postData)
					{
						return false;
					}

					Otime.app.postData(new Otime.ContextModel("save", postData, function(cont){
						var response	= cont.response;
						self.old_password('');
						self.password('');
						self.confirm_password('');
						if(response.user_id)
						{
							if (self.user_id() <= 0)
								self.user_id(response.user_id);

							Otime.success_message(_this.language['PROFILE_SAVE_SUCCESS'], $('#alert_message'));
							if (isTimeZoneChanged)
							{
								var tzCode	= self.time_zone_code()?self.time_zone_code():Otime.server_time_zone;
								// Otime.etzc	= tzCode;
								Otime.time_zone_code	= tzCode;
								Date.timeZoneValue	= Otime.get_timezone_value(tzCode);
								Otime.timeZoneValue	= Date.timeZoneValue;
							}

							// Reload page to home page after save.
							if (Otime.Referer)
							{
								window.location.href	= Otime.Referer;
								return;
							}
							else
							{
								Otime.Menu.loadURL("");
							}
						}
					}));
				};

				if(self.is_valid() == true)
				{
					var comp_image	= self.profile_image();
					if(comp_image != '')
					{
//						_this.fileApi.url	= Otime.siteUrl+'/attachment/profile_image_upload';
						_this.fileApi.url	= Otime.siteUrl+'/attachment/users_image_upload?cropData=' + JSON.stringify(self.cropData());
						_this.fileApi.onAfterUpload = function(data){
							if (data && !data[0])
							{
								// alert(data[1]);
								Otime.error_message(data[1], $("#alert_message"));
								return;
							}
							$("#target-prof-img").css({
								width: '100%',
								height: '100%',
								marginLeft: '0px',
								marginTop: '0px'
							});
							self.oldImage(Otime.UMIP + data[2].file_name + "?" + new Date().getTime());
							self.user_image(data[2].file_name);
							self.user_image_path(Otime.UMIP + data[2].file_name);
							saveCallback();
						};
						_this.fileApi.uploadQueue();
					}
					else
					{
						saveCallback();
					}
				}
				else
				{
					alert("Invalid");
					return false;
				}
				return true;
			};

			self.prepareData	= function(){
/*
				var data	= JSON.parse(ko.toJSON(this));
				delete data._info;
				delete data._project;
				delete data.hasChanges;
				delete data.cropData;

				if (!data.password)
				{
					delete data.password;
					delete data.confirm_password;
				}

				delete data._info;
				delete data.user_id;
				delete data.user_role;
				delete data.user_roles;
				delete data.user_role_disp;
				delete data.oldImage;
				delete data.is_active;

				data.is_weekly_summary_mail -= 0;
				// data.is_weekly_mail -= 0;
*/
				var data	= {};
				var fields	= ["first_name", "last_name", "email", "old_password", "password", "confirm_password", "profile_image", "time_zone_code", "user_image", "user_image_path", "enable_notification", "is_weekly_summary_mail","my_tasks","my_tasks_status","follow_tasks","follow_tasks_status","is_daily_digest","new_tasks"];
				for( var i=0,iLen=fields.length; i<iLen; i++)
				{
					data[fields[i]]	= self[fields[i]]();
				}
				if(self.dob()) {
					data.dob = new Date(self.dob()).format('YYYY-MM-DD')
				}
				if(self.doj()) {
					data.doj = new Date(self.doj()).format('YYYY-MM-DD')
				}
				data.new_tasks -= 0;
				data.is_daily_digest -= 0;
				data.is_weekly_summary_mail -= 0;
				data.enable_notification -= 0;
				data.my_tasks -= 0;
				data.follow_tasks -= 0;
				
				if (!data.password)
				{
					delete data.password;
					delete data.confirm_password;
				}

				return data;
			};

			self.cancel	= function(){
				window.location.href = Otime.siteUrl;
			};

			self.load_more_projects	= function(){
				var page = _this.proj_page();
				page++;
				_this.proj_page(page);
				Otime.app.loadData(new Otime.ContextModel("get_projects/" + _this.user_id() + "/" + _this.proj_page(), null, function(cont){
					_this.proj_finish(cont.response.finish || false);
					if (cont.response.items && cont.response.items.otvalues && Object.keys(cont.response.items.otvalues).length > 0)
					{
						cont.response.items	= cont.response.items.otvalues.setKeys(cont.response.items.otkeys, function(item){
							self._project.items.push(new _this.ProjectsInfoModel(item))
						});
					}
					
					if (cont.response.finish == true)
					{
						self._project.view_more(false);
					}
				}));
			};

			var _cropObj	= null;

			self.cropApply	= function(){
				self.cropData(_cropObj.getCropData());
			};

			self.refresh	= function(){
				var context	= new Otime.ContextModel('edit', null, self.load);
				context.mode	= "EDIT";
				Otime.app.loadData(context);

				_this.fileApi	= new FileAPI({
					imageOnly: true
				});
				_this.fileApi.fileField	= $("#profile_image", _this.edit_container).get(0);
				_this.fileApi.init();
				_this.fileApi.url	= Otime.siteUrl+'/attachment/profile_image_upload';
				_this.fileApi.onAddFile	= function(param){
					if (typeof FileReader === "undefined")
					{
						return;
					}

					var reader = new FileReader();
					reader.onload = function(e){
						self.user_image_path(e.target.result);
						$("#crop_image").modal({
							backdrop: "static",
							show: true
						});
						$('#crop_image').on('hidden.bs.modal', function(){
							self.profile_image("");

							self.user_image_path(self.oldImage() || (Otime.baseUrl + '/files/photo/no_User.png'));
							self.oldImage(self.oldImage() || (Otime.baseUrl + '/files/photo/no_User.png'));
						});
						_cropObj	= new Otime.Users.CropImage();
						_cropObj.init();
					};
					reader.readAsDataURL(_this.fileApi.fileQueue[0].file);
				};
				_this.fileApi.onRemoveFile	= function(){
					_this.appModel.user_image_path(_this.appModel.oldImage());
				};
			};
		};

		_this.ProjectsInfoModel	= function(data){
			var self	= this;

			data	= data || {};
            
			self.project_id		= data.project_id;			
			self.project_name	= data.project_name;			
			self.client_name	= data.client_name;			
			self.hours		= (parseFloat(data.hours).toFixed(2));
			self.date			=  (new Date(data.date).format(Otime.dateFormat || "MMM dd, yyyy"));
			self.is_active		= data.is_active;
		};

		_this.init	= function(){
			_this.list_container	= $("#list-container");
			_this.edit_container	= $("#profile-container");

			Otime.unbind();

			_this.user_id	= Otime.o("0");
			_this.proj_page	= Otime.o(1);
			_this.proj_finish	= Otime.o(false);
			_this.fileApi	= new FileAPI({
				imageOnly: true
			});

			if (this.language == null)
			{
				alert(_this.language['ERR_PRIMARY_DATA_MISSING']);
				return false;
			}

			_this.appModel	= new _this.ProfileContentModel();

			ko.applyBindings(_this.appModel, _this.edit_container.get(0));
			_this.appModel.refresh();
		};
	};
}(window.Otime));
