(function (Otime) {

	var colgroups = "";
	var thead_tr = "";
	var tbody_tr = "";
	var tbody_tmpl = "";

	var taskCols = {
		ttype: function (language) {
			colgroups += '<col for="ttype" style="width:180px;">';

			thead_tr += '<th class="pr ttype" target="ttype">';
			thead_tr += '	<span class="dib fw pr cp b" data-bind="click:sort(\'task_type_name\')">' + (language["TASK_TYPE"] || "Task Type") + '</span>';
			thead_tr += '	<span class="column_filter" data-bind="click:filter_column.task_type">';
			thead_tr += '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.task_type_id}"></i>';
			thead_tr += '	</span>';
			thead_tr += '</th>';

			tbody_tr += '<td class="ttype" target="ttype">';
			tbody_tr += '	<span class="ttype" data-bind="hidden:form.is_parent, text:form.task_type_name"></span>';
			tbody_tr += '</td>';
		},
		duration: function (language) {
			colgroups += '<col for="duration" style="width:70px;">';

			thead_tr += '<th class="pr ac duration" target="duration">';
			thead_tr += '	<span class="dib fw pr cp b" data-bind="click:sort(\'duration\')">' + (language["DURATION"] || "Duration") + '</span>';
			thead_tr += '</th>';

			tbody_tr += '<td class="duration" target="duration">';
			tbody_tr += '	<span class="duration" data-bind="vtext:form.duration"></span>';
			tbody_tr += '</td>';
		},
		sdate: function (language) {
			colgroups += '<col for="sdate" style="width:90px;">';

			thead_tr += '<th class="pr ac sdate" target="sdate">';
			thead_tr += '	<span class="dib fw pr cp b" data-bind="click:sort(\'start_date\')">' + (language["START_DATE"] || "Start Date") + '</span>';
			thead_tr += '</th>';

			tbody_tr += '<td class="sdate" target="sdate" data-bind="date:{date:form.start_date, fi:form.name().length>0||form.task_id()>0}">';
			tbody_tr += '</td>';
		},
		fdate: function (language) {
			colgroups += '<col for="fdate" style="width:90px;">';

			thead_tr += '<th class="pr ac fdate" target="fdate">';
			thead_tr += '	<span class="dib fw pr cp b" data-bind="click:sort(\'finish_date\')">' + (language["FINISH_DATE"] || "Finish Date") + '</span>';
			thead_tr += '</th>';

			tbody_tr += '<td class="fdate" target="fdate" data-bind="date:{date:form.finish_date}">';
			tbody_tr += '</td>';
		},
		esthrs: function (language) {
			colgroups += '<col for="esthrs" style="width:70px;">';

			thead_tr += '<th class="pr ac esthrs" target="esthrs">';
			thead_tr += '	<span class="dib fw pr cp b" data-bind="click:sort(\'estimated_hours\')">' + (language["ESTIMATED_HOURS"] || "Estimated Hours") + '</span>';
			thead_tr += '</th>';

			tbody_tr += '<td class="esthrs" target="esthrs" data-bind="text:form.estimated_hours">';
			tbody_tr += '</td>';
		},
		acthrs: function (language) {
			colgroups += '<col for="acthrs" style="width:70px;">';

			thead_tr += '<th class="pr ac acthrs" target="acthrs">';
			thead_tr += '	<span class="dib fw pr cp b" data-bind="click:sort(\'worked_hours\')">' + (language["ACTUAL_HOURS"] || "Actual Hours") + '</span>';
			thead_tr += '</th>';

			tbody_tr += '<td class="acthrs" target="acthrs" data-bind="css:{\'txt-danger\':is_crossed_estimates}, hours:{val:form.worked_hours}">';
			tbody_tr += '</td>';
		},
		status: function (language) {
			colgroups += '<col for="status" style="width:100px;">';

			thead_tr += '<th class="pr status" target="status">';
			thead_tr += '	<span class="dib fw pr cp b" data-bind="click:sort(\'status\')">' + (language["STATUS"] || "Status") + '</span>';
			thead_tr += '	<span class="column_filter" data-bind="click:filter_column.task_status">';
			thead_tr += '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.task_status_id()>0}"></i>';
			thead_tr += '	</span>';
			thead_tr += '</th>';

			tbody_tr += '<td class="status" target="status" data-bind="with:status">';
			tbody_tr += '	<span class="label status" data-bind="text:name, hidden:($parent.form.is_parent() || (!$parent.form.name() && !$parent.form.task_id())), style:{backgroundColor:bg_color, color:text_color}"></span>';
			tbody_tr += '</td>';
		},
		assignee: function (language) {
			colgroups += '<col for="assignee" style="width:85px;">';

			thead_tr += '<th class="pr assignee" target="assignee">';
			thead_tr += '	<span class="dib fw pr b">' + (language["ASSIGNEE"] || "Assignee") + '</span>';
			thead_tr += '	<span class="column_filter" data-bind="click:filter_column.assignee_id">';
			thead_tr += '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.task_assignee_id}"></i>';
			thead_tr += '	</span>';
			thead_tr += '</th>';

			tbody_tr += '<td class="assignee" target="assignee">';
			tbody_tr += '	<span class="assignee" data-bind="hidden:(form.is_parent() || (!form.name() && !form.task_id())), text:form._info.assignee_disp"></span>';
			tbody_tr += '</td>';
		},
		followers: function (language) {
			colgroups += '<col for="followers" style="width:150px;">';

			thead_tr += '<th class="pr followers" target="followers">';
			thead_tr += '	<span class="dib fw pr b">' + (language["FOLLOWERS"] || "Followers") + '</span>';
			thead_tr += '</th>';

			tbody_tr += '<td class="followers" target="followers">';
			tbody_tr += '	<span class="assignee" data-bind="hidden:((!form.name() && !form.task_id())), text:form._info.followers_disp"></span>';
			tbody_tr += '</td>';
		},
		predec: function (language) {
			colgroups += '<col for="predec" style="width:100px;">';

			thead_tr += '<th class="pr ac predec" targt="predec">';
			thead_tr += '	<span class="dib fw pr b">' + (language["PREDECESSORS"] || "Predecessors") + '</span>';
			thead_tr += '</th>';

			tbody_tr += '<td class="predec" target="predec" data-bind="text:form.predecessors">';
			tbody_tr += '</td>';
		},
		sprint: function (language) {
			//console.log("********sprint",filter_column);
			colgroups += '<col for="sprint" style="width:180px;">';

			thead_tr += '<th class="pr sprint" target="sprint">';
			thead_tr += '	<span class="dib fw pr cp b" data-bind="click:sort(\'sprint_name\')">' + (language["SPRINT"] || "Sprint") + '</span>';
			thead_tr += '	<span class="column_filter" data-bind="click:filter_column.sprint">';
			thead_tr += '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.sprint_id}"></i>';
			thead_tr += '	</span>';
			thead_tr += '</th>';

			tbody_tr += '<td class="sprint" target="sprint">';
			tbody_tr += '	<span class="sprint" data-bind="hidden:form.is_parent, text:form.sprint_name"></span>';
			tbody_tr += '</td>';
		}
	};

	var fieldCols = {
		text: function (field) {
			return function () {
				var key = "cf_" + field.id;

				colgroups += '<col for="' + key + '" style="width:100px;">';

				thead_tr += '<th class="pr ac">';
				thead_tr += '	<span class="dib fw pr b" data-bind="click:sort(\'' + key + '\', true)">' + field.fName + '</span>';
				/*
								thead_tr += '	<span class="column_filter" data-bind="click:filter_column.' + key  + '">';
								thead_tr += '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.field_filter[\'' + key + '\']}"></i>';
								thead_tr += '	</span>';
				*/
				thead_tr += '</th>';

				tbody_tr += '<td class="cftext ' + key + '" target="' + key + '" data-bind="text:form.custom_values.' + key + '">';
				tbody_tr += '</td>';
			};
		},
		number: function (field) {
			return function () {
				var key = "cf_" + field.id;

				colgroups += '<col for="' + key + '" style="width:70px;">';

				thead_tr += '<th class="pr ac ' + key + '" target="' + key + '">';
				thead_tr += '	<span class="dib fw pr cp b" data-bind="click:sort(\'' + key + '\', true)">' + field.fName + '</span>';
				/*
								thead_tr += '	<span class="column_filter" data-bind="click:filter_column.' + key  + '">';
								thead_tr += '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.field_filter[\'' + key + '\']}"></i>';
								thead_tr += '	</span>';
				*/
				thead_tr += '</th>';

				tbody_tr += '<td class="cfnumber ' + key + '" target="' + key + '">';
				tbody_tr += '	<span class="' + key + '" data-bind="vtext:form.custom_values.' + key + '"></span>';
				tbody_tr += '</td>';
			};
		},
		select: function (field) {
			return function () {
				var key = "cf_" + field.id;

				colgroups += '<col for="' + key + '" style="width:100px;">';

				thead_tr += '<th class="pr ' + key + '" target="' + key + '">';
				thead_tr += '	<span class="dib fw pr cp b" data-bind="click:sort(\'' + key + '\', true)">' + field.fName + '</span>';
				/*
								thead_tr += '	<span class="column_filter" data-bind="click:filter_column.' + key  + '">';
								thead_tr += '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.field_filter[\'' + key + '\']}"></i>';
								thead_tr += '	</span>';
				*/
				thead_tr += '</th>';

				tbody_tr += '<td class="cfselect ' + key + '" target="' + key + '" data-bind="">';
				tbody_tr += '	<span class="label ' + key + '" data-bind="text:form.custom_values.' + key + ', style:{backgroundColor:form.cvObj.' + key + '}"></span>';
				tbody_tr += '</td>';
			};
		},
		date: function (field) {
			return function () {
				var key = "cf_" + field.id;

				colgroups += '<col for="' + key + '" style="width:90px;">';

				thead_tr += '<th class="pr ac ' + key + '" target="' + key + '">';
				thead_tr += '	<span class="dib fw pr cp b" data-bind="click:sort(\'' + key + '\', true)">' + field.fName + '</span>';
				/*
								thead_tr += '	<span class="column_filter" data-bind="click:filter_column.' + key  + '">';
								thead_tr += '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.field_filter[\'' + key + '\']}"></i>';
								thead_tr += '	</span>';
				*/
				thead_tr += '</th>';

				tbody_tr += '<td class="cfdate ' + key + '" target="' + key + '" data-bind="date:{date:form.custom_values.' + key + ', fi:form.name().length>0||form.task_id()>0}">';
				tbody_tr += '</td>';
			};
		},
		hours: function (field) {
			return function () {
				var key = "cf_" + field.id;

				colgroups += '<col for="' + key + '" style="width:70px;">';

				thead_tr += '<th class="pr ac ' + key + '" target="' + key + '">';
				thead_tr += '	<span class="dib fw pr cp b" data-bind="click:sort(\'' + key + '\', true)">' + field.fName + '</span>';
				/*
								thead_tr += '	<span class="column_filter" data-bind="click:filter_column.' + key  + '">';
								thead_tr += '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.field_filter[\'' + key + '\']}"></i>';
								thead_tr += '	</span>';
				*/
				thead_tr += '</th>';

				tbody_tr += '<td class="cfhours ' + key + '" target="' + key + '" data-bind="text:form.custom_values.' + key + '">';
				tbody_tr += '</td>';
			};
		},
		user: function (field) {
			return function () {
				var key = "cf_" + field.id;

				colgroups += '<col for="' + key + '" style="width:85px;">';

				thead_tr += '<th class="pr ' + key + '" target="' + key + '">';
				thead_tr += '	<span class="dib fw pr b" data-bind="click:sort(\'' + key + '\', true)">' + field.fName + '</span>';
				/*
								thead_tr += '	<span class="column_filter" data-bind="click:filter_column.' + key  + '">';
								thead_tr += '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.field_filter[\'' + key + '\']}"></i>';
								thead_tr += '	</span>';
				*/
				thead_tr += '</th>';

				tbody_tr += '<td class="cfuser ' + key + '" target="' + key + '">';
				tbody_tr += '	<span class="' + key + '" data-bind="hidden:(form.is_parent() || (!form.name() && !form.task_id())), text:form._info.' + key + '"></span>';
				tbody_tr += '</td>';
			};
		},
		users: function (field) {
			return function () {
				var key = "cf_" + field.id;

				colgroups += '<col for="' + key + '" style="width:150px;">';

				thead_tr += '<th class="pr ' + key + '" target="' + key + '">';
				thead_tr += '	<span class="dib fw pr b" data-bind="click:sort(\'' + key + '\', true)">' + field.fName + '</span>';
				/*
								thead_tr += '	<span class="column_filter" data-bind="click:filter_column.' + key  + '">';
								thead_tr += '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.field_filter[\'' + key + '\']}"></i>';
								thead_tr += '	</span>';
				*/
				thead_tr += '</th>';

				tbody_tr += '<td class="cfusers ' + key + '" target="' + key + '">';
				tbody_tr += '	<span class="' + key + '" data-bind="hidden:((!form.name() && !form.task_id())), text:form._info.' + key + '"></span>';
				tbody_tr += '</td>';
			};
		}
	};

	var box2head = '';
	//box2head	+= '<!-- ko ifnot:$root.is_gantt -->';
	box2head += '<div id="box2-head" class="container np pr pull-left" style="width:80%;left:-1px;">';
	box2head += '	<table class="table table-bordered dt nm">';
	box2head += '		<colgroup></colgroup>';
	box2head += '		<thead>';
	box2head += '			<tr class="unselectable"></tr>';
	box2head += '		</thead>';
	box2head += '	</table>';
	box2head += '</div>';
	//box2head	+= '<!-- /ko -->';

	var box2body = '';
	//box2body	+= '<!-- ko ifnot:$root.is_gantt -->';
	box2body += '<div class="container np pr cont top1" id="box2-body" style="width:80%;left:-1px;">';
	box2body += '<table id="task-table2" class="task-tbl table table-bordered dt nm">';
	box2body += '	<colgroup></colgroup>';
	box2body += '	<tbody class="editable" id="tasks2" data-bind="template:{name:\'mainTmpl2\', foreach:items}"></tbody>';
	box2body += '</table>';
	box2body += '<span class="cell-top"></span>';
	box2body += '<span class="cell-right"></span>';
	box2body += '<span class="cell-bottom"></span>';
	box2body += '<span class="cell-left"></span>';
	box2body += '<div class="hidder pa" id="hidder1" style="border: none !important" >';
	box2body += '	<input type="text" id="txt-normal" style="padding-left:4px;" class="nb" onfocus="var a=this.value;this.value=\'\';this.value=a;" />';
	box2body += '	<input type="text" id="txt-duration" style="padding-left:4px;" class="nb" maxlength="5" value="0" data-bind="numberOnly:{keyCodes:[58]}" />';
	box2body += '	<div id="task_type_box" class="" ><select data-bind="options:$root.task_types, optionsValue:\'id\', optionsText:\'label\', value:0" class="form-control input-sm"></select></div>';
	box2body += '	<div id="followers_box" class=""><select multiple="multiple" data-bind="foreach:$root.followers, selectedOptions:[]" class="form-control input-sm"><option data-bind="value:user_id, text:first_name, attr:{\'data-img-src\':user_image}"></option></select></div>';
	box2body += '	<div id="assignee_box" class=""><select data-bind="foreach:$root.users_sort()" class="form-control input-sm"><option data-bind="value:user_id, text:first_name, attr:{\'data-img-src\':user_image}"></option></select></div>';
	box2body += '	<div id="status_box" class=""><select data-bind="options:$root.task_status, optionsText:\'name\', optionsValue:\'task_status_id\'" class="form-control input-sm"></select></div>';
	box2body += '	<div id="sprint_box" class=""><select data-bind="options:$root.sprint, optionsText:\'name\', optionsValue:\'sprint_id\'" class="form-control input-sm"></select></div>';
	box2body += '	<div id="date-picker" class="ac cp"><h6 style="padding:4px 6px;" class="wnw pull-left fw nm"></h6><input type="text" class="dtpicker cp pa fw fh" /></div>';
	box2body += '</div>';
	box2body += '</div>';
	//box2body	+= '<!-- /ko -->';

	var scr2 = '';
	//scr2	+= '<!-- ko ifnot:$root.is_gantt -->';
	scr2 += '<div id="scr2" class="scr pull-left nb nm np">';
	scr2 += '	<div class="bar"></div>';
	scr2 += '</div>';
	//scr2	+= '<!-- /ko -->';

	Otime.getTaskTmpl = function (parent_elem, language, customFields) {
		colgroups = "";
		thead_tr = "";
		tbody_tr = "";
		tbody_tmpl = '<script type="text/html" id="mainTmpl2">';

		var columns = Otime.Storage.get("tasks_columns");
		if (columns == "none") {
			tbody_tmpl = '';
			$("#box2-head, #box2-body", parent_elem).hide();
			return;
		}
		if (!columns) {
			columns = "ttype,duration,sdate,fdate,esthrs,status,assignee,followers,acthrs";
			Otime.Storage.set("tasks_columns", columns);
		}

		$(box2head).insertAfter("#box1-head");
		$(box2body).insertAfter("#box1-body");
		$(scr2).insertAfter("#scr1");

		var selectedCols = columns.split(",");

		if (customFields) {
			var customHtmls = '';
			selectedCols = [];
			$.each(customFields, function (key, val) {
				if (!(val.fEnable - 0)) {
					return true;
				}

				selectedCols.push(val.colName || val.fCode);

				if (fieldCols[val.fType]) {
					taskCols[val.fCode] = fieldCols[val.fType](val);
				}

				if (val.fType == "select") {
					customHtmls += '<div id="' + val.fCode + '" class="cfselect"><select data-bind="foreach:$root.custom_options[\'' + val.fCode + '\']" class="form-control input-sm"><option data-bind="value:val, text:val"></option></select></div>';
				}
			});

			customHtmls && $("#box2-body #hidder1").append(customHtmls);
		}

		tbody_tmpl += '<!-- ko if:is_visible -->';
		tbody_tmpl += '<tr class="" data-bind="cls:\'task_\'+uniqueId()+\' num_\'+form.task_number(), css:{\'ne\':!is_editable(), \'over-due\':is_over_due, \'closed\':is_closed}">';

		for (var i = 0, iLen = selectedCols.length; i < iLen; i++) {
			if (taskCols[selectedCols[i]]) {
				taskCols[selectedCols[i]](language);
			}
		}

		tbody_tmpl += tbody_tr;
		tbody_tmpl += '</tr>';
		tbody_tmpl += '<!-- ko template:{name:\'mainTmpl2\', foreach:children, if:show_child} --><!-- /ko -->';
		tbody_tmpl += '<!-- /ko -->';
		tbody_tmpl += '</script>';

		parent_elem.append(tbody_tmpl);
		$("#box2-head table colgroup", parent_elem).html(colgroups);
		$("#box2-body #task-table2 colgroup", parent_elem).html(colgroups);
		$("#box2-head table thead tr", parent_elem).html(thead_tr);
	};
	/*
		var mytasks_colgroups	= "";
		var mytasks_thead_tr	= "";
		var mytasks_tbody_tr	= "";
		var mytasks_tbody_tmpl	= "";
	
		var myTasksCols	= {
			
			status:function(){
				mytasks_colgroups	+= '<col for="status" style="width:77px;">';
	
				mytasks_thead_tr	+= '<th class="pr">';
				mytasks_thead_tr	+= '	<span class="dib fw pr cp" data-bind="click:sort(\'status\')">Status</span>';
				mytasks_thead_tr	+= '	<span class="column_filter" data-bind="click:filter_column.task_status">';
				mytasks_thead_tr	+= '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.task_status_id()>0}"></i>';
				mytasks_thead_tr	+= '	</span>';
				mytasks_thead_tr	+= '</th>';
	
				mytasks_tbody_tr	+= '<td class="status" target="status" data-bind="with:status">';
				mytasks_tbody_tr	+= '	<span class="label status" data-bind="text:name, hidden:$parent.form.is_parent, style:{backgroundColor:bg_color, color:text_color}"></span>';
				mytasks_tbody_tr	+= '</td>';
			},
			assignee:function(){
				mytasks_colgroups	+= '<col for="assignee" style="width:85px;">';
	
				mytasks_thead_tr	+= '<th class="pr">';
				mytasks_thead_tr	+= '	<span class="dib fw pr">Assignee</span>';
				mytasks_thead_tr	+= '	<span class="column_filter" data-bind="click:filter_column.assignee_id">';
				mytasks_thead_tr	+= '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.task_assignee_id}"></i>';
				mytasks_thead_tr	+= '	</span>';
				mytasks_thead_tr	+= '</th>';
	
				mytasks_tbody_tr	+= '<td class="assignee" target="assignee">';
				mytasks_tbody_tr	+= '	<span class="assignee" data-bind="visible:(form.name() && !form.is_parent()), text:form._info.assignee_disp"></span>';
				mytasks_tbody_tr	+= '</td>';
			},
		};
	
		Otime.getMyTasksTmpl	= function(parent_elem){
			mytasks_colgroups	= "";
			mytasks_thead_tr	= "";
			mytasks_tbody_tr	= "";
			mytasks_tbody_tmpl	= '<script type="text/html" id="mainTmpl1">';
	
			var columns	= Otime.Storage.get("mytasks_columns");
			if (!columns)
			{
				columns	= "status,assignee";
				Otime.Storage.set("mytasks_columns", columns);
			}
			var selectedCols	= columns.split(",");
	
			mytasks_tbody_tmpl	+= '<!-- ko if:is_visible -->';
			mytasks_tbody_tmpl	+= '<tr class="" data-bind="cls:\'task_\'+uniqueId()+\' num_\'+form.task_number(), css:{\'ne\':!is_editable(), \'over-due\':is_over_due, \'closed\':is_closed}">';
	
			for (var i=0,iLen=selectedCols.length; i<iLen; i++)
			{
				myTasksCols[selectedCols[i]]();
			}
	
			mytasks_tbody_tmpl	+= mytasks_tbody_tr;
			mytasks_tbody_tmpl	+= '</tr>';
			mytasks_tbody_tmpl	+= '<!-- ko template:{name:\'mainTmpl1\', foreach:children, if:show_child} --><!-- /ko -->';
			mytasks_tbody_tmpl	+= '<!-- /ko -->';
			mytasks_tbody_tmpl	+= '</script>';
	
			parent_elem.append(mytasks_tbody_tmpl);
			$("#box2-head table colgroup", parent_elem).html(colgroups);
			$("#box2-body #task-table2 colgroup", parent_elem).html(colgroups);
			$("#box2-head table thead tr", parent_elem).html(thead_tr);
		};
	*/
}(window.Otime));
