-- Adminer 4.8.1 MySQL 5.5.5-10.4.21-MariaDB dump

SET NAMES utf8;
SET time_zone = '+00:00';
SET foreign_key_checks = 0;
SET sql_mode = 'NO_AUTO_VALUE_ON_ZERO';

DROP TABLE IF EXISTS `ot_address`;
CREATE TABLE `ot_address` (
  `address_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `address1` varchar(200) NOT NULL,
  `address2` varchar(200) NOT NULL,
  `city` varchar(50) NOT NULL,
  `state` varchar(20) NOT NULL,
  `country_code` varchar(2) NOT NULL,
  `zip` varchar(20) NOT NULL,
  `workphone` varchar(30) NOT NULL,
  `homephone` varchar(30) NOT NULL,
  `mobile` varchar(20) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  `email` varchar(80) NOT NULL,
  PRIMARY KEY (`address_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_apps`;
CREATE TABLE `ot_apps` (
  `app_id` int(11) NOT NULL AUTO_INCREMENT,
  `app_name` varchar(60) DEFAULT NULL,
  `auth_key_name` varchar(100) NOT NULL,
  `developed_by` varchar(60) DEFAULT NULL,
  `app_description` varchar(1000) DEFAULT NULL,
  `is_internal` tinyint(1) DEFAULT NULL,
  `is_active` tinyint(1) DEFAULT NULL,
  `config_fields` varchar(1000) DEFAULT NULL,
  `category_code` char(2) DEFAULT NULL COMMENT 'DT - Developer Tools\\nFI - Finance\\nHD - Help Desk\\nCS - Customer Support\\nIM - Instant Messaging\\nLG - Lead Generation\\nCM - CMS\\nCR - CRM\\nMA - Marketing\\nFM - File Management\\nEM - Event Management',
  `app_image` varchar(250) NOT NULL DEFAULT '',
  `allow_user_event` tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`app_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_apps` (`app_id`, `app_name`, `auth_key_name`, `developed_by`, `app_description`, `is_internal`, `is_active`, `config_fields`, `category_code`, `app_image`, `allow_user_event`) VALUES
(1,	'Output Messenger',	'API-Key',	'srimax',	'Private and Secure Instant Messenger for Office',	1,	1,	NULL,	'DT',	'outputmessenger.png',	0),
(2,	'Output Time Notifications',	'',	'Srimax',	'Output Time notification.',	1,	1,	NULL,	'DT',	'ot_notification.png',	0),
(3,	'QuickBooks',	'',	'Srimax',	'Export your invoices to QuickBooks.',	1,	1,	NULL,	'FI',	'quickbooks.png',	0),
(4,	'Output Wall',	'API-Key',	'srimax',	'Private wall',	1,	1,	NULL,	'DT',	'outputwall.png',	0);

DROP TABLE IF EXISTS `ot_apps_entity`;
CREATE TABLE `ot_apps_entity` (
  `entity_id` int(11) NOT NULL,
  `app_id` int(11) NOT NULL,
  `auth_key_value` varchar(1024) DEFAULT NULL,
  `config_value` varchar(1000) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `server_name` varchar(1000) NOT NULL DEFAULT '',
  `is_enabled` tinyint(1) NOT NULL DEFAULT 0,
  `active_events` varchar(500) NOT NULL,
  PRIMARY KEY (`entity_id`,`app_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_apps_entity` (`entity_id`, `app_id`, `auth_key_value`, `config_value`, `server_name`, `is_enabled`, `active_events`) VALUES
(1,	3,	NULL,	NULL,	'',	1,	''),
(1,	4,	NULL,	NULL,	'',	1,	'');

DROP TABLE IF EXISTS `ot_apps_user_event`;
CREATE TABLE `ot_apps_user_event` (
  `user_id` int(11) NOT NULL,
  `app_id` int(11) NOT NULL,
  `event_codes` varchar(100) DEFAULT NULL,
  `entity_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`user_id`,`app_id`),
  KEY `ix_entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_apps_webhooks`;
CREATE TABLE `ot_apps_webhooks` (
  `app_id` int(11) NOT NULL,
  `event_code` char(2) NOT NULL COMMENT 'IP - Invoice Past Due Date PA - Project Assigned PB - Project Budget Alert TA - Task Assigned TS - Task Status Changed TD - Task Due Date Changed TT - Task Due Date Today TP - Task Past Due Date CO - Project / Task Comments AT - Project / Task Attachments',
  `call_back_url` varchar(1000) DEFAULT NULL,
  `content` text DEFAULT NULL,
  `event_name` varchar(500) NOT NULL,
  PRIMARY KEY (`app_id`,`event_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_apps_webhooks` (`app_id`, `event_code`, `call_back_url`, `content`, `event_name`) VALUES
(1,	'AT',	'http://{{server_name}}/api/notify?room=&from={{from_email}}&to={{to_email}}&message={{content}}&context=success&otr=1¬ify=1',	'New attachment : <a href=\'{{url}}\'>{{task_name}}</a>',	'Task new attachment'),
(1,	'CO',	'http://{{server_name}}/api/notify?room=&from={{from_email}}&to={{to_email}}&message={{content}}&context=success&otr=1¬ify=1',	'<a href=\'{{url}}\'>{{name}}</a><br>New Comment : {{comment}}',	'Task new comment'),
(1,	'TA',	'http://{{server_name}}/api/notify?room=&from={{from_email}}&to={{to_email}}&message={{content}}&context=success&otr=1¬ify=1',	'New task :<a href=\'{{task_url}}\'>{{task_name}}</a>',	'New task'),
(1,	'TD',	'http://{{server_name}}/api/notify?room=&from={{from_email}}&to={{to_email}}&message={{content}}&context=success&otr=1¬ify=1',	'Task : <a href=\'{{task_url}}\'>{{task_name}}</a> due date changed to <b>{{finish_date}}</b>.',	'Task date modified'),
(1,	'TP',	'http://{{server_name}}/api/notify?room=&from={{from_email}}&to={{to_email}}&message={{content}}&context=success&otr=1¬ify=1',	'Task : <a href=\'{{task_url}}\'>{{task_name}}</a> priority changed from {{from_priority}} to {{to_priority}}.',	'Task prioirty change'),
(1,	'TS',	'http://{{server_name}}/api/notify?room=&from={{from_email}}&to={{to_email}}&message={{content}}&context=success&otr=1¬ify=1',	'Task : <a href=\'{{task_url}}\'>{{task_name}}</a> status changed from {{from_status}} to {{to_status}}.',	'Task status change'),
(1,	'TT',	'http://{{server_name}}/api/users/{{from_email}}?message={{content}}',	'{{task_name}}{{cur_time}}',	'Task in progress'),
(2,	'AT',	'',	'',	'Task new attachment'),
(2,	'CO',	'',	'',	'Task new comment'),
(2,	'ES',	'',	'',	'Expenses Approval'),
(2,	'HS',	'',	'',	'Timesheet Approval'),
(2,	'TA',	'',	'',	'New Task'),
(2,	'TD',	'',	'',	'Task date modified'),
(2,	'TS',	'',	'',	'Task status change');

DROP TABLE IF EXISTS `ot_attachment`;
CREATE TABLE `ot_attachment` (
  `attachment_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `file_type` varchar(4) NOT NULL,
  `file_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `module_type` char(1) NOT NULL COMMENT 'module_type=\nP(Project), \nT(Task),\nI(Invoice),\nC(Comments),\nE(Expense),\nR(Invoice Payment Receipt)',
  `module_id` int(11) NOT NULL,
  `file_path` varchar(100) NOT NULL,
  `file_size` float(9,3) NOT NULL,
  `title` varchar(100) NOT NULL,
  `checkedout_by` int(11) NOT NULL COMMENT 'if  > 0, Checked in by the user',
  `checkedout_date` datetime NOT NULL,
  `version` int(11) NOT NULL,
  `posted_by` int(11) NOT NULL,
  `posted_date` datetime NOT NULL,
  PRIMARY KEY (`attachment_id`),
  KEY `ix_entity_module_type_module_id` (`entity_id`,`module_type`,`module_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_attachment_version`;
CREATE TABLE `ot_attachment_version` (
  `attachment_version_id` int(11) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `attachment_id` int(11) NOT NULL,
  `version` mediumint(9) NOT NULL,
  `version_comments` varchar(1000) NOT NULL,
  `posted_by` int(11) NOT NULL,
  `posted_date` datetime NOT NULL,
  PRIMARY KEY (`attachment_version_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_bookmarks`;
CREATE TABLE `ot_bookmarks` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `name` text NOT NULL,
  `filters` text NOT NULL,
  `type` text NOT NULL,
  `url` text NOT NULL,
  `user_id` int(11) NOT NULL,
  `view` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ix_entity_user_id` (`entity_id`,`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_check_list`;
CREATE TABLE `ot_check_list` (
  `chk_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `module_type` char(1) DEFAULT NULL COMMENT 'module_type=\nP(Project), \nT(Task),\nI(Invoice),\nE(Estimate),\nU(User),\nX(Expense),\nR(Invoice Payment Receipt),\nA(Attachment)',
  `module_id` int(11) DEFAULT NULL,
  `order_no` int(11) NOT NULL DEFAULT 1,
  `message` mediumtext DEFAULT NULL,
  `is_closed` tinyint(1) DEFAULT 0,
  `created_by` int(11) DEFAULT NULL,
  `created_date` datetime NOT NULL,
  PRIMARY KEY (`chk_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_client`;
CREATE TABLE `ot_client` (
  `client_id` int(11) NOT NULL AUTO_INCREMENT,
  `client_name` varchar(80) NOT NULL,
  `client_code` varchar(12) DEFAULT NULL,
  `is_active` tinyint(1) NOT NULL DEFAULT 1,
  `is_archive` tinyint(1) NOT NULL,
  `address` varchar(500) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `bg_color` varchar(7) NOT NULL DEFAULT '',
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`client_id`),
  KEY `ix_entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_client_contact`;
CREATE TABLE `ot_client_contact` (
  `client_contact_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `client_id` int(11) NOT NULL,
  `name` varchar(60) NOT NULL,
  `title` varchar(45) NOT NULL,
  `status_mail` varchar(2) NOT NULL,
  `address_id` int(11) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  PRIMARY KEY (`client_contact_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_comments`;
CREATE TABLE `ot_comments` (
  `comment_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `parent_comment_id` int(11) NOT NULL,
  `reply_count` smallint(6) NOT NULL,
  `module_type` char(1) NOT NULL COMMENT 'module_type=\nP(Project), \nT(Task),\nI(Invoice),\nE(Estimate),\nU(User),\nX(Expense),\nR(Invoice Payment Receipt),\nA(Attachment)',
  `module_id` int(11) NOT NULL,
  `message` text DEFAULT NULL,
  `attachments` tinyint(1) NOT NULL,
  `is_protected` tinyint(1) NOT NULL,
  `like_count` smallint(5) NOT NULL DEFAULT 0,
  `liked` text NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  `progress_status` varchar(1) NOT NULL COMMENT 'G-On Track, O-Off Track, R-at Risk',
  PRIMARY KEY (`comment_id`),
  KEY `ix_entity_module_type_module_id` (`entity_id`,`module_type`,`module_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_country`;
CREATE TABLE `ot_country` (
  `country_code` varchar(2) NOT NULL,
  `country_name` varchar(20) NOT NULL,
  `currency_code` varchar(4) NOT NULL,
  `time_zone_code` varchar(4) NOT NULL,
  PRIMARY KEY (`country_code`),
  UNIQUE KEY `name` (`country_name`),
  UNIQUE KEY `code_UNIQUE` (`country_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_country` (`country_code`, `country_name`, `currency_code`, `time_zone_code`) VALUES
('AD',	'Andorra',	' UP1',	'8364'),
('AE',	'United Arab Emirates',	' UP4',	'1583'),
('AF',	'Afghanistan',	' UP4',	'1547'),
('AG',	'Antigua and Barbuda',	' UM4',	'36'),
('AI',	'Anguilla',	' UM4',	'36'),
('AL',	'Albania',	' UP1',	'76'),
('AM',	'Armenia',	' UP4',	'1380'),
('AO',	'Angola',	' UP1',	'75'),
('AQ',	'Antarctica',	' UTC',	''),
('AR',	'Argentina',	' UM3',	'36'),
('AS',	'American Samoa',	' UM1',	''),
('AT',	'Austria',	' UP1',	'8364'),
('AU',	'Australia',	' UP7',	'36'),
('AW',	'Aruba',	' UM4',	'402'),
('AX',	'Ã…land Islands',	' UTC',	'8364'),
('AZ',	'Azerbaijan',	' UP4',	''),
('BA',	'Bosnia and Herzegovi',	' UP1',	'1050'),
('BB',	'Barbados',	' UM4',	'36'),
('BD',	'Bangladesh',	' UP6',	'2547'),
('BE',	'Belgium',	' UP1',	'8364'),
('BF',	'Burkina Faso',	' UTC',	'70'),
('BG',	'Bulgaria',	' UP2',	'1083'),
('BH',	'Bahrain',	' UP3',	'46'),
('BI',	'Burundi',	' UP2',	'70'),
('BJ',	'Benin',	' UP1',	'70'),
('BL',	'Saint BarthÃ©lemy',	' UM4',	'8364'),
('BM',	'Bermuda',	' UM4',	'36'),
('BN',	'Brunei',	' UP8',	'36'),
('BO',	'Bolivia',	' UM4',	'66'),
('BQ',	'Bonaire',	' UTC',	'36'),
('BR',	'Brazil',	' UM5',	'82'),
('BS',	'Bahamas',	' UM5',	'36'),
('BT',	'Bhutan',	' UP5',	'78'),
('BV',	'Bouvet Island',	' UTC',	''),
('BW',	'Botswana',	' UP2',	'80'),
('BY',	'Belarus',	' UP3',	'66'),
('BZ',	'Belize',	' UM6',	'36'),
('CA',	'Canada',	' UM8',	'36'),
('CC',	'Cocos (Keeling) Isla',	' UP6',	'36'),
('CF',	'Central African Repu',	' UP1',	'70'),
('CG',	'Congo',	' UP1',	'70'),
('CH',	'Switzerland',	' UP1',	'70'),
('CI',	'CÃ´te d\'Ivoire',	' UTC',	'70'),
('CK',	'Cook Islands',	' UM1',	'36'),
('CL',	'Chile',	' UM4',	'36'),
('CM',	'Cameroon',	' UP1',	'70'),
('CN',	'China',	' UP8',	'2080'),
('CO',	'Colombia',	' UM5',	'36'),
('CR',	'Costa Rica',	' UM6',	'8353'),
('CU',	'Cuba',	' UM3',	'36'),
('CV',	'Cape Verde',	' UM1',	'36'),
('CW',	'CuraÃ§ao',	' UTC',	'402'),
('CX',	'Christmas Island',	' UP7',	'36'),
('CY',	'Cyprus',	' UP2',	'8364'),
('CZ',	'Czech Republic',	' UP1',	'75'),
('DE',	'Germany',	' UP1',	'8364'),
('DJ',	'Djibouti',	' UP3',	'70'),
('DK',	'Denmark',	' UP1',	'107'),
('DM',	'Dominica',	' UM4',	'36'),
('DO',	'Dominican Republic',	' UM4',	'36'),
('DZ',	'Algeria',	' UTC',	'1583'),
('EC',	'Ecuador',	' UM5',	'36'),
('EE',	'Estonia',	' UP3',	'8364'),
('EG',	'Egypt',	' UP2',	'1580'),
('EH',	'Western Sahara',	' UTC',	'1583'),
('ER',	'Eritrea',	' UP3',	'78'),
('ES',	'Spain',	' UP1',	'8364'),
('ET',	'Ethiopia',	' UP3',	'66'),
('FI',	'Finland',	' UP2',	'8364'),
('FJ',	'Fiji',	' UP1',	'36'),
('FK',	'Falkland Islands (Ma',	' UM4',	'163'),
('FM',	'Micronesia',	' UP1',	'36'),
('FO',	'Faroe Islands',	' UTC',	'107'),
('FR',	'France',	' UP1',	'8364'),
('GA',	'Gabon',	' UP1',	'70'),
('GB',	'United Kingdom',	' UTC',	'163'),
('GD',	'Grenada',	' UM4',	'36'),
('GE',	'Georgia',	' UP4',	'4314'),
('GF',	'French Guiana',	' UM1',	''),
('GG',	'Guernsey',	' UTC',	'163'),
('GH',	'Ghana',	' UTC',	'8373'),
('GI',	'Gibraltar',	' UP1',	'163'),
('GL',	'Greenland',	' UM3',	'107'),
('GM',	'Gambia',	' UTC',	'68'),
('GN',	'Guinea',	' UTC',	'70'),
('GP',	'Guadeloupe',	' UM4',	''),
('GQ',	'Equatorial Guinea',	' UP1',	'70'),
('GR',	'Greece',	' UP2',	'8364'),
('GS',	'South Georgia and th',	' UM2',	'163'),
('GT',	'Guatemala',	' UM6',	'81'),
('GU',	'Guam',	' UP1',	'36'),
('GW',	'Guinea-Bissau',	' UTC',	'70'),
('GY',	'Guyana',	' UM3',	'36'),
('HK',	'Hong Kong',	' UP8',	'36'),
('HM',	'Heard Island and McD',	' UP5',	''),
('HN',	'Honduras',	' UM6',	'76'),
('HR',	'Croatia',	' UP1',	'107'),
('HT',	'Haiti',	' UM5',	'71'),
('HU',	'Hungary',	' UP1',	'70'),
('ID',	'Indonesia',	' UP7',	'82'),
('IE',	'Ireland',	' UTC',	'8364'),
('IL',	'Israel',	' UP2',	'8362'),
('IM',	'Isle of Man',	' UTC',	'163'),
('IN',	'India',	' UP5',	'8377'),
('IO',	'British Indian Ocean',	' UP6',	'36'),
('IQ',	'Iraq',	' UP3',	'1593'),
('IR',	'Iran',	' UP3',	'6502'),
('IS',	'Iceland',	' UTC',	'107'),
('IT',	'Italy',	' UP1',	'8364'),
('JE',	'Jersey',	' UTC',	'163'),
('JM',	'Jamaica',	' UM5',	'36'),
('JO',	'Jordan',	' UP2',	'1583'),
('JP',	'Japan',	' UP9',	'165'),
('KE',	'Kenya',	' UP3',	'83'),
('KG',	'Kyrgyzstan',	' UP6',	'1083'),
('KH',	'Cambodia',	' UP7',	'6107'),
('KI',	'Kiribati',	' UP1',	'36'),
('KM',	'Comoros',	' UP3',	'70'),
('KN',	'Saint Kitts and Nevi',	' UM4',	'36'),
('KP',	'North Korea',	' UP9',	'8361'),
('KR',	'South Korea',	' UP9',	'8361'),
('KW',	'Kuwait',	' UP3',	'1583'),
('KY',	'Cayman Islands',	' UM5',	'36'),
('KZ',	'Kazakhstan',	' UP6',	'8376'),
('LA',	'Laos',	' UP7',	'8365'),
('LB',	'Lebanon',	' UP2',	'1604'),
('LC',	'Saint Lucia',	' UM4',	'36'),
('LI',	'Liechtenstein',	' UP1',	'70'),
('LK',	'Sri Lanka',	' UP5',	'82'),
('LR',	'Liberia',	' UTC',	'36'),
('LS',	'Lesotho',	' UP2',	'76'),
('LT',	'Lithuania',	' UP2',	'76'),
('LU',	'Luxembourg',	' UP1',	'8364'),
('LV',	'Latvia',	' UP3',	'76'),
('LY',	'Libya',	' UP2',	'1604'),
('MA',	'Morocco',	' UTC',	'1583'),
('MC',	'Monaco',	' UP1',	'8364'),
('MD',	'Moldova',	' UP3',	'76'),
('ME',	'Montenegro',	' UP1',	'8364'),
('MF',	'Saint Martin (French',	' UM4',	'8364'),
('MG',	'Madagascar',	' UP3',	'65'),
('MH',	'Marshall Islands',	' UP1',	'36'),
('MK',	'Macedonia',	' UP1',	'1076'),
('ML',	'Mali',	' UTC',	'70'),
('MM',	'Myanmar (Burma)',	' UP6',	'75'),
('MN',	'Mongolia',	' UP8',	'8366'),
('MO',	'Macau',	' UP8',	'80'),
('MP',	'Northern Mariana Isl',	' UP1',	'36'),
('MQ',	'Martinique',	' UM4',	''),
('MR',	'Mauritania',	' UTC',	'85'),
('MS',	'Montserrat',	' UM4',	'36'),
('MT',	'Malta',	' UP1',	'8364'),
('MU',	'Mauritius',	' UP4',	'8360'),
('MV',	'Maldives',	' UP5',	'1923'),
('MW',	'Malawi',	' UP2',	'77'),
('MX',	'Mexico',	' UM8',	'36'),
('MY',	'Malaysia',	' UP8',	'82'),
('MZ',	'Mozambique',	' UP2',	'77'),
('NA',	'Namibia',	' UP2',	'36'),
('NC',	'New Caledonia',	' UP1',	'70'),
('NE',	'Niger',	' UP1',	'70'),
('NF',	'Norfolk Island',	' UP1',	'36'),
('NG',	'Nigeria',	' UP1',	'8358'),
('NI',	'Nicaragua',	' UM6',	'67'),
('NL',	'Netherlands',	' UP1',	'8364'),
('NO',	'Norway',	' UP1',	'107'),
('NP',	'Nepal',	' UP5',	'8360'),
('NR',	'Nauru',	' UP1',	'36'),
('NU',	'Niue',	' UM1',	'36'),
('NZ',	'New Zealand',	' UP1',	'36'),
('OM',	'Oman',	' UP4',	'1585'),
('PA',	'Panama',	' UM5',	'66'),
('PE',	'Peru',	' UM5',	'83'),
('PF',	'French Polynesia',	' UM1',	'70'),
('PG',	'Papua New Guinea',	' UP1',	'75'),
('PH',	'Philippines',	' UP8',	'8369'),
('PK',	'Pakistan',	' UP5',	'8360'),
('PL',	'Poland',	' UP1',	'122'),
('PM',	'Saint Pierre and Miq',	' UM3',	'8364'),
('PN',	'Pitcairn',	' UM8',	'36'),
('PR',	'Puerto Rico',	' UM4',	'36'),
('PS',	'Palestinian Territor',	' UP2',	''),
('PT',	'Portugal',	' UP1',	'8364'),
('PW',	'Palau',	' UP9',	'36'),
('PY',	'Paraguay',	' UM4',	'8370'),
('QA',	'Qatar',	' UP3',	'1585'),
('RE',	'RÃ©union',	' UP4',	''),
('RO',	'Romania',	' UP2',	'76'),
('RS',	'Serbia',	' UP1',	'100'),
('RU',	'Russia',	' UP3',	'1088'),
('RW',	'Rwanda',	' UP2',	'70'),
('SA',	'Saudi Arabia',	' UP3',	'1585'),
('SB',	'Solomon Islands',	' UP1',	'36'),
('SC',	'Seychelles',	' UP4',	'8360'),
('SD',	'Sudan',	' UP2',	'163'),
('SE',	'Sweden',	' UP1',	'107'),
('SG',	'Singapore',	' UP8',	'36'),
('SH',	'Saint Helena',	' UTC',	'163'),
('SI',	'Slovenia',	' UP1',	'8364'),
('SJ',	'Svalbard and Jan May',	' UTC',	''),
('SK',	'Slovakia',	' UP1',	'8364'),
('SL',	'Sierra Leone',	' UTC',	'76'),
('SM',	'San Marino',	' UP1',	'8364'),
('SN',	'Senegal',	' UTC',	'70'),
('SO',	'Somalia',	' UP3',	'83'),
('SR',	'Suriname',	' UM3',	'36'),
('ST',	'SÃ&#163;o TomÃ© and ',	' UTC',	'68'),
('SV',	'El Salvador',	' UM6',	'8353'),
('SX',	'Sint Maarten',	' UTC',	'402'),
('SY',	'Syrian Arab Republic',	' UP2',	'1604'),
('SZ',	'Swaziland',	' UP2',	'76'),
('TC',	'Turks and Caicos Isl',	' UM5',	'36'),
('TD',	'Chad',	' UP1',	'70'),
('TF',	'French Southern Terr',	' UTC',	'8364'),
('TG',	'Togo',	' UTC',	'70'),
('TH',	'Thailand',	' UP7',	'3647'),
('TJ',	'Tajikistan',	' UP6',	'1029'),
('TK',	'Tokelau',	' UM1',	'36'),
('TL',	'East Timor',	' UP9',	'36'),
('TM',	'Turkmenistan',	' UP5',	'109'),
('TN',	'Tunisia',	' UP1',	'1583'),
('TO',	'Tonga',	' UP1',	'84'),
('TR',	'Turkey',	' UP2',	'84'),
('TT',	'Trinidad and Tobago',	' UM4',	'36'),
('TV',	'Tuvalu',	' UP1',	'36'),
('TW',	'Taiwan',	' UP8',	'36'),
('TZ',	'Tanzania',	' UP3',	'83'),
('UA',	'Ukraine',	' UP3',	'8372'),
('UG',	'Uganda',	' UP3',	'83'),
('UM',	'United States Minor ',	' UTC',	'36'),
('US',	'United States',	' UM1',	'36'),
('UY',	'Uruguay',	' UM3',	'36'),
('UZ',	'Uzbekistan',	' UP6',	'1083'),
('VA',	'Vatican City',	' UP1',	'8364'),
('VC',	'Saint Vincent and th',	' UM4',	'36'),
('VE',	'Venezuela',	' UM4',	'70'),
('VG',	'Virgin Islands',	' UM4',	'36'),
('VN',	'Vietnam',	' UP7',	'8363'),
('VU',	'Vanuatu',	' UP1',	'86'),
('WF',	'Wallis and Futuna',	' UP1',	'70'),
('WS',	'Samoa',	' UM1',	'84'),
('YE',	'Yemen',	' UP3',	'6502'),
('YT',	'Mayotte',	' UP3',	'8364'),
('ZA',	'South Africa',	' UP2',	'82'),
('ZM',	'Zambia',	' UP2',	'90'),
('ZW',	'Zimbabwe',	' UP2',	'80');

DROP TABLE IF EXISTS `ot_currency`;
CREATE TABLE `ot_currency` (
  `currency_code` varchar(4) NOT NULL,
  `description` varchar(60) NOT NULL,
  `currency_symbol` varchar(20) NOT NULL,
  PRIMARY KEY (`currency_code`),
  UNIQUE KEY `currency_code_UNIQUE` (`currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_currency` (`currency_code`, `description`, `currency_symbol`) VALUES
('AED',	'United Arab Emirates dirham',	'&#62f;'),
('AFN',	'Afghan afghani',	'&#1547;'),
('ALL',	'Albanian lek',	'Lek'),
('AMD',	'Armenian dram',	'&#1423;'),
('ANG',	'Netherlands Antillean gulden',	'&#402;'),
('AOA',	'Angolan kwanza',	'Kz'),
('ARS',	'Argentine peso',	'$'),
('AUD',	'Australian dollar',	'$'),
('AWG',	'Aruban florin',	'&#402;'),
('AZN',	'Azerbaijani manat',	'&#1084;'),
('BAM',	'Bosnia and Herzegovina convert',	'KM'),
('BBD',	'Barbadian dollar',	'$'),
('BDT',	'Bangladeshi taka',	'Tk'),
('BGN',	'Bulgarian lev',	'&#1083;'),
('BHD',	'Bahraini dinar',	'BD'),
('BIF',	'Burundian franc',	'Fr'),
('BMD',	'Bermudian dollar',	'$'),
('BND',	'Brunei dollar',	'$'),
('BOB',	'Bolivian boliviano',	'$b'),
('BOV',	'Mvdol',	'BOV'),
('BRL',	'Brazilian real',	'R$'),
('BSD',	'Bahamian dollar',	'$'),
('BTN',	'Bhutanese ngultrum',	'BTN'),
('BWP',	'Botswana pula',	'P'),
('BYN',	'Belarusian ruble',	'Br'),
('BZD',	'Belize dollar',	'BZ$'),
('CAD',	'Canadian dollar',	'$'),
('CDF',	'Congolese franc',	'Fr'),
('CHE',	'WIR Euro',	'&#8364;'),
('CHF',	'Swiss franc',	'CHF'),
('CHW',	'WIR Franc',	'CHW'),
('CLF',	'Unidad de Fomento',	'CLF'),
('CLP',	'Chilean peso',	'$'),
('CNY',	'Chinese renminbi yuan',	'&#165;'),
('COP',	'Colombian peso',	'$'),
('COU',	'Unidad de Valor Real',	'COU'),
('CRC',	'Costa Rican colón',	'&#8353;'),
('CUP',	'Cuban peso',	'&#8369;'),
('CVE',	'Cape Verdean escudo',	'$'),
('CZK',	'Czech koruna',	'Kč'),
('DJF',	'Djiboutian franc',	'Fr'),
('DKK',	'Danish krone',	'kr'),
('DOP',	'Dominican peso',	'RD$'),
('DZD',	'Algerian dinar',	'DZD'),
('EGP',	'Egyptian pound',	'&#163;'),
('ERN',	'Eritrean nakfa',	'Nfk'),
('ETB',	'Ethiopian birr',	'ETB'),
('EUR',	'Euro',	'&#8364;'),
('FJD',	'Fijian dollar',	'$'),
('FKP',	'Falkland pound',	'&#163;'),
('GBP',	'British pound',	'&#163;'),
('GEL',	'Georgian lari',	'GEL'),
('GHS',	'Ghanaian cedi',	'&#162;'),
('GIP',	'Gibraltar pound',	'&#163;'),
('GMD',	'Gambian dalasi',	'D'),
('GNF',	'Guinean franc',	'Fr'),
('GTQ',	'Guatemalan quetzal',	'Q'),
('GYD',	'Guyanese dollar',	'$'),
('HKD',	'Hong Kong dollar',	'&#36;'),
('HNL',	'Honduran lempira',	'L'),
('HRK',	'Croatian kuna',	'kn'),
('HTG',	'Haitian gourde',	'G'),
('HUF',	'Hungarian forint',	'Ft'),
('IDR',	'Indonesian rupiah',	'Rp'),
('ILS',	'Israeli new sheqel',	'&#8362;'),
('INR',	'Indian rupee',	'&#8377;'),
('IQD',	'Iraqi dinar',	'IQD'),
('IRR',	'Iranian rial',	'&#65020;'),
('ISK',	'Icelandic króna',	'kr'),
('JMD',	'Jamaican dollar',	'J$'),
('JOD',	'Jordanian dinar',	'JOD'),
('JPY',	'Japanese yen',	'¥'),
('KES',	'Kenyan shilling',	'Sh'),
('KGS',	'Kyrgyzstani som',	'&#1083;'),
('KHR',	'Cambodian riel',	'&#6107;'),
('KMF',	'Comorian franc',	'Fr'),
('KPW',	'North Korean won',	'&#8361;'),
('KRW',	'South Korean won',	'&#8361;'),
('KWD',	'Kuwaiti dinar',	'K.D'),
('KYD',	'Cayman Islands dollar',	'$'),
('KZT',	'Kazakhstani tenge',	'&#1083;'),
('LAK',	'Lao kip',	'&#8365;'),
('LBP',	'Lebanese pound',	'&#163;'),
('LKR',	'Sri Lankan rupee',	'&#8360;'),
('LRD',	'Liberian dollar',	'$'),
('LSL',	'Lesotho loti',	'L'),
('LTL',	'Lithuanian litas',	'Lt'),
('LVL',	'Latvian lats',	'Ls'),
('LYD',	'Libyan dinar',	'LD'),
('MAD',	'Moroccan dirham',	'MAD'),
('MDL',	'Moldovan leu',	'L'),
('MGA',	'Malagasy ariary',	'MGA'),
('MKD',	'Macedonian denar',	'&#1076;'),
('MMK',	'Myanmar kyat',	'K'),
('MNT',	'Mongolian tögrög',	'&#8366;'),
('MOP',	'Macanese pataca',	'P'),
('MRO',	'Mauritanian ouguiya',	'UM'),
('MUR',	'Mauritian rupee',	'&#8360;'),
('MVR',	'Maldivian rufiyaa',	'MVR'),
('MWK',	'Malawian kwacha',	'MK'),
('MXN',	'Mexican peso',	'$'),
('MXV',	'Mexican Unid',	'MXV'),
('MYR',	'Malaysian ringgit',	'RM'),
('MZN',	'Mozambican metical',	'MT'),
('NAD',	'Namibian dollar',	'$'),
('NGN',	'Nigerian naira',	'&#8358;'),
('NIO',	'Nicaraguan córdoba',	'C$'),
('NOK',	'Norwegian krone',	'kr'),
('NPR',	'Nepalese rupee',	'&#8360;'),
('NZD',	'New Zealand dollar',	'$'),
('OMR',	'Omani rial',	'&#65020;'),
('PAB',	'Panamanian balboa',	'B/.'),
('PEN',	'Peruvian nuevo sol',	'S/.'),
('PGK',	'Papua New Guinean kina',	'K'),
('PHP',	'Philippine peso',	'&#8369;'),
('PKR',	'Pakistani rupee',	'&#8360;'),
('PLN',	'Poland Zloty',	'&#122;'),
('PYG',	'Paraguayan guaraní',	'&#115;'),
('QAR',	'Qatari riyal',	'&#65020;'),
('RON',	'Romanian leu',	'lei'),
('RSD',	'Serbian dinar',	'&#1044;'),
('RUB',	'Russian ruble',	'&#1088;'),
('RWF',	'Rwandan franc',	'Fr'),
('SAR',	'Saudi riyal',	'&#65020;'),
('SBD',	'Solomon Islands dollar',	'$'),
('SCR',	'Seychellois rupee',	'&#8360;'),
('SDG',	'Sudanese pound',	'&#163;'),
('SEK',	'Swedish krona',	'kr'),
('SGD',	'Singapore dollar',	'$'),
('SHP',	'Saint Helenian pound',	'&#163;'),
('SLL',	'Sierra Leonean leone',	'Le'),
('SOS',	'Somali shilling',	'S'),
('SRD',	'Surinamese dollar',	'$'),
('STD',	'São Tomé and Príncipe dobra',	'Db'),
('SVC',	'Salvadoran colón',	'$'),
('SYP',	'Syrian pound',	'&#163;'),
('SZL',	'Swazi lilangeni',	'L'),
('THB',	'Thai baht',	'&#3647;'),
('TJS',	'Tajikistani somoni',	'TJS'),
('TND',	'Tunisian dinar',	'TND'),
('TOP',	'Tongan pa?anga',	'T$'),
('TRY',	'Turkish new lira',	'TL'),
('TTD',	'Trinidad and Tobago dollar',	'TT$'),
('TWD',	'New Taiwan dollar',	'NT$'),
('TZS',	'Tanzanian shilling',	'Sh'),
('UAH',	'Ukrainian hryvnia',	'&#8372;'),
('UGX',	'Ugandan shilling',	'Sh'),
('USD',	'United States dollar',	'$'),
('UYI',	'Uruguay Peso',	'UYI'),
('UYU',	'Uruguayan peso',	'$'),
('UZS',	'Uzbekistani som',	'&#1083;'),
('VEF',	'Venezuelan bolívar',	'Bs'),
('VND',	'Vietnamese Dong',	'&#8363;'),
('VUV',	'Vanuatu vatu',	'Vt'),
('WST',	'Samoan tala',	'T'),
('XAF',	'Central African CFA franc',	'Fr'),
('XCD',	'East Caribbean dollar',	'$'),
('XOF',	'West African CFA franc',	'Fr'),
('XPF',	'CFP franc',	'Fr'),
('YER',	'Yemeni rial',	'&#65020;'),
('ZAR',	'South African rand',	'R'),
('ZMK',	'Zambian kwacha',	'ZK'),
('ZWD',	'Zimbabwean dollar',	'Z$');

DROP TABLE IF EXISTS `ot_custom_fields`;
CREATE TABLE `ot_custom_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `mType` char(1) NOT NULL COMMENT 'P(Project), T(Task), I(Invoice), C(Comments), E(Expense), R(Invoice Payment Receipt',
  `fName` varchar(50) NOT NULL,
  `fType` varchar(10) NOT NULL DEFAULT 'text' COMMENT 'text, number, select, date, hours, user, users',
  `fOptions` text NOT NULL,
  `isSys` tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `ot_custom_mod`;
CREATE TABLE `ot_custom_mod` (
  `entity_id` int(11) NOT NULL,
  `mType` char(1) NOT NULL COMMENT 'P(Project), T(Task), I(Invoice), C(Comments), E(Expense), R(Invoice Payment Receipt',
  `mId` int(11) NOT NULL,
  `fId` varchar(11) NOT NULL,
  `fCode` varchar(2) NOT NULL,
  `ordNo` tinyint(2) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `ot_custom_values`;
CREATE TABLE `ot_custom_values` (
  `entity_id` int(11) NOT NULL,
  `mType` char(1) NOT NULL COMMENT 'P(Project), T(Task), I(Invoice), C(Comments), E(Expense), R(Invoice Payment Receipt',
  `mId` int(11) NOT NULL,
  `fId` int(11) NOT NULL,
  `fValue` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `ot_email_template`;
CREATE TABLE `ot_email_template` (
  `email_template_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `name` varchar(20) NOT NULL,
  `smtp_setting_id` int(11) NOT NULL,
  `subject` varchar(50) NOT NULL,
  `body` text DEFAULT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  PRIMARY KEY (`email_template_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_entity`;
CREATE TABLE `ot_entity` (
  `entity_id` int(11) NOT NULL,
  `name` varchar(60) NOT NULL,
  `domain_name` varchar(40) NOT NULL,
  `is_active` tinyint(1) NOT NULL,
  `address_id` int(11) NOT NULL,
  `entity_logo` varchar(100) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `name` (`name`),
  UNIQUE KEY `subdomain_UNIQUE` (`domain_name`),
  UNIQUE KEY `entity_id_UNIQUE` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_entity` (`entity_id`, `name`, `domain_name`, `is_active`, `address_id`, `entity_logo`, `created_by`, `created_date`, `last_updated_by`, `last_updated_date`) VALUES
(1,	'New company',	'admin',	1,	0,	'',	1,	'2013-02-08 10:46:30',	0,	'0000-00-00 00:00:00');

DROP TABLE IF EXISTS `ot_entity_accounts`;
CREATE TABLE `ot_entity_accounts` (
  `entity_id` int(11) NOT NULL AUTO_INCREMENT,
  `company_name` varchar(60) NOT NULL,
  `domain_url` text DEFAULT NULL,
  `user_name` varchar(80) NOT NULL,
  `register_date` datetime NOT NULL,
  `email` varchar(200) NOT NULL,
  `password` varchar(100) NOT NULL,
  `db_string` varchar(500) NOT NULL,
  `is_active` tinyint(1) NOT NULL,
  `exp_date` datetime NOT NULL,
  `max_users` int(11) NOT NULL,
  `plan` varchar(4) DEFAULT '',
  `license_key` varchar(250) DEFAULT '',
  `gdomain` varchar(250) DEFAULT '',
  `type` varchar(1) NOT NULL,
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `entity_id_UNIQUE` (`entity_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_entity_accounts` (`entity_id`, `company_name`, `domain_url`, `user_name`, `register_date`, `email`, `password`, `db_string`, `is_active`, `exp_date`, `max_users`, `plan`, `license_key`, `gdomain`, `type`) VALUES
(1,	'New company',	'admin.otime.com',	'admin',	'2013-02-08 10:46:30',	'admin@gmail.com',	'38f078a81a2b033d197497af5b77f95b50bfcfb8',	'',	1,	'2030-02-19 06:23:42',	0,	'',	'',	'',	'');

DROP TABLE IF EXISTS `ot_entity_daysoff`;
CREATE TABLE `ot_entity_daysoff` (
  `entity_dayoff_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `dayoff_date` datetime NOT NULL,
  `description` varchar(100) NOT NULL,
  `repeat` tinyint(1) NOT NULL,
  PRIMARY KEY (`entity_dayoff_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_entity_daysoff` (`entity_dayoff_id`, `entity_id`, `dayoff_date`, `description`, `repeat`) VALUES
(1,	1,	'2015-01-01 00:00:00',	'New Year\'s Day',	1),
(2,	1,	'2015-09-07 00:00:00',	'Labor Day',	1),
(3,	1,	'2015-10-12 00:00:00',	'Columbus Day',	1),
(4,	1,	'2015-11-26 00:00:00',	'Thanksgiving Day',	1),
(5,	1,	'2015-12-25 00:00:00',	'Christmas Day',	1);

DROP TABLE IF EXISTS `ot_entity_setting`;
CREATE TABLE `ot_entity_setting` (
  `entity_setting_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `account_owner_id` int(11) NOT NULL,
  `time_zone_code` varchar(4) NOT NULL,
  `fiscal_year_month` tinyint(4) NOT NULL,
  `non_working_days` varchar(20) NOT NULL COMMENT 'SA,SU',
  `start_week_on` varchar(2) NOT NULL,
  `skip_daysoff` tinyint(1) NOT NULL,
  `date_format` varchar(12) NOT NULL COMMENT 'dd/MM/yyyyMM/dd/yyyyMMM dd, yyyyyyyy-MM-dd',
  `time_format` tinyint(1) NOT NULL COMMENT 'True-24 hour formatFalse-12 hour format',
  `period_format` tinyint(1) NOT NULL,
  `time_stamp_req` tinyint(1) NOT NULL COMMENT 'Required to enter worked hours based on Time',
  `task_required` tinyint(1) NOT NULL DEFAULT 0,
  `allow_future_time` tinyint(1) NOT NULL DEFAULT 0,
  `time_sheet_approval` tinyint(1) NOT NULL,
  `hours_per_day` int(2) NOT NULL DEFAULT 0 COMMENT 'Hours per day for timesheet.',
  `modify_billable` tinyint(1) NOT NULL,
  `time_round_to` varchar(1) NOT NULL COMMENT 'Round up for Invoice\nN- No roundup\nH- Yes, round to half an hour\nF- Yes, round to full hour',
  `currency_code` varchar(4) NOT NULL,
  `number_format` varchar(10) NOT NULL COMMENT 'N-123,456.78\nF-123 456,78\nI-1,23,456.78\n',
  `theme` varchar(20) NOT NULL,
  `language` char(2) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  `inv_template` varchar(20) NOT NULL DEFAULT '',
  `version_checked` date NOT NULL,
  `has_update` tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`entity_setting_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_entity_setting` (`entity_setting_id`, `entity_id`, `account_owner_id`, `time_zone_code`, `fiscal_year_month`, `non_working_days`, `start_week_on`, `skip_daysoff`, `date_format`, `time_format`, `period_format`, `time_stamp_req`, `task_required`, `allow_future_time`, `time_sheet_approval`, `hours_per_day`, `modify_billable`, `time_round_to`, `currency_code`, `number_format`, `theme`, `language`, `created_by`, `created_date`, `last_updated_by`, `last_updated_date`, `inv_template`, `version_checked`, `has_update`) VALUES
(1,	1,	1,	'',	1,	'SA,SU',	'MO',	0,	'MM/dd/yyyy',	1,	0,	0,	0,	0,	0,	8,	1,	'0',	'USD',	'I',	'',	'EN',	1,	'2013-02-08 10:46:30',	0,	'0000-00-00 00:00:00',	'',	'0000-00-00',	0);

DROP TABLE IF EXISTS `ot_entity_users`;
CREATE TABLE `ot_entity_users` (
  `user_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `email` varchar(80) NOT NULL,
  `password` varchar(100) NOT NULL,
  `first_name` varchar(30) NOT NULL,
  `last_name` varchar(30) NOT NULL,
  `user_role` char(1) NOT NULL COMMENT 'A - Administrator\nF - Project Manager with Finance\nP - Project Manager\nM - Member',
  `hourly_rate` float NOT NULL,
  `hourly_cost` float NOT NULL,
  `dob` date NOT NULL,
  `doj` date NOT NULL,
  `user_code` varchar(20) NOT NULL,
  `address_id` int(11) NOT NULL,
  `user_image` varchar(250) NOT NULL,
  `department` int(11) NOT NULL,
  `time_zone_code` varchar(4) NOT NULL DEFAULT 'UTC',
  `auth_token` varchar(50) NOT NULL,
  `is_active` tinyint(1) DEFAULT 0,
  `last_login` datetime NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  `activation` varchar(100) NOT NULL,
  `login_attempts` int(11) NOT NULL DEFAULT 0,
  `lock_until` datetime DEFAULT NULL,
  PRIMARY KEY (`user_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_entity_users` (`user_id`, `entity_id`, `email`, `password`, `first_name`, `last_name`, `user_role`, `hourly_rate`, `hourly_cost`, `dob`, `doj`, `user_code`, `address_id`, `user_image`, `department`, `time_zone_code`, `auth_token`, `is_active`, `last_login`, `created_by`, `created_date`, `last_updated_by`, `last_updated_date`, `activation`, `login_attempts`, `lock_until`) VALUES
(1,	1,	'admin@gmail.com',	'38f078a81a2b033d197497af5b77f95b50bfcfb8',	'admin',	'',	'A',	0,	0,	'0000-00-00',	'0000-00-00',	'',	0,	'',	0,	'',	'',	1,	'2013-05-17 06:50:26',	-1,	'2013-02-08 10:46:30',	0,	'0000-00-00 00:00:00',	'',	0,	NULL);

DROP TABLE IF EXISTS `ot_estimate`;
CREATE TABLE `ot_estimate` (
  `estimate_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `client_id` int(11) NOT NULL,
  `client_contact_id` int(11) NOT NULL,
  `address` varchar(500) NOT NULL,
  `estimate_number` varchar(16) NOT NULL,
  `estimate_date` datetime NOT NULL,
  `status` char(1) NOT NULL COMMENT 'd - draft\ns - sent\ni - invoiced\na - accepted\nr - rejected\ne - expired',
  `subject` varchar(255) NOT NULL,
  `notes` varchar(1000) NOT NULL,
  `discount_percentage` float NOT NULL,
  `discount_amount` float NOT NULL,
  `tax1_name` varchar(30) NOT NULL,
  `tax1_percentage` float NOT NULL,
  `tax1_amount` float NOT NULL,
  `tax2_name` varchar(30) NOT NULL,
  `tax2_percentage` float NOT NULL,
  `tax2_amount` float NOT NULL,
  `tax2_tax1_iscom` tinyint(1) NOT NULL,
  `tax3_name` varchar(30) NOT NULL,
  `tax3_percentage` float NOT NULL,
  `tax3_amount` float NOT NULL,
  `tax3_tax1_iscom` tinyint(1) NOT NULL,
  `tax3_tax2_iscom` tinyint(1) NOT NULL,
  `amount` float NOT NULL,
  `currency_code` varchar(4) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  PRIMARY KEY (`estimate_id`),
  UNIQUE KEY `estimate_id_UNIQUE` (`estimate_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_estimate_items`;
CREATE TABLE `ot_estimate_items` (
  `estimate_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `estimate_id` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `description` varchar(1000) NOT NULL,
  `quantity` float NOT NULL,
  `rate` float NOT NULL,
  `amount` float NOT NULL,
  `is_tax1` tinyint(1) NOT NULL,
  `is_tax2` tinyint(1) NOT NULL,
  `is_tax3` tinyint(1) NOT NULL,
  `serial_no` smallint(6) NOT NULL,
  PRIMARY KEY (`estimate_item_id`),
  KEY `ix_entity_estimate_id` (`entity_id`,`estimate_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_expense_type`;
CREATE TABLE `ot_expense_type` (
  `expense_type_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `unit_price` float(9,2) NOT NULL,
  `units` varchar(45) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  PRIMARY KEY (`expense_type_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_expense_type` (`expense_type_id`, `entity_id`, `name`, `unit_price`, `units`, `created_by`, `created_date`, `last_updated_by`, `last_updated_date`) VALUES
(1,	1,	'Accommodations',	50.00,	'day',	0,	'0000-00-00 00:00:00',	0,	'0000-00-00 00:00:00'),
(2,	1,	'Advertising',	0.00,	'',	0,	'0000-00-00 00:00:00',	0,	'0000-00-00 00:00:00'),
(3,	1,	'Administration',	0.00,	'',	0,	'0000-00-00 00:00:00',	0,	'0000-00-00 00:00:00'),
(4,	1,	'Meals',	0.00,	'',	0,	'0000-00-00 00:00:00',	0,	'0000-00-00 00:00:00'),
(5,	1,	'Mileage',	0.00,	'',	0,	'0000-00-00 00:00:00',	0,	'0000-00-00 00:00:00'),
(6,	1,	'Repairs',	0.00,	'',	0,	'0000-00-00 00:00:00',	0,	'0000-00-00 00:00:00'),
(7,	1,	'Office supplies',	0.00,	'',	0,	'0000-00-00 00:00:00',	0,	'0000-00-00 00:00:00'),
(8,	1,	'Postage',	0.00,	'',	0,	'0000-00-00 00:00:00',	0,	'0000-00-00 00:00:00'),
(9,	1,	'Stationery',	0.00,	'',	0,	'0000-00-00 00:00:00',	0,	'0000-00-00 00:00:00'),
(10,	1,	'Others',	0.00,	'',	0,	'0000-00-00 00:00:00',	0,	'0000-00-00 00:00:00');

DROP TABLE IF EXISTS `ot_file_type`;
CREATE TABLE `ot_file_type` (
  `file_type` varchar(4) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `name` varchar(20) NOT NULL,
  `extensions` varchar(255) NOT NULL,
  PRIMARY KEY (`file_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_finance_activity`;
CREATE TABLE `ot_finance_activity` (
  `finance_activity_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `invoice_id` int(11) NOT NULL,
  `a_date` datetime NOT NULL,
  `a_mode` char(2) NOT NULL COMMENT 'IN - Invoice New\nIU - Invoice Update\nID - Invoice Delete\nIS - Invoice Status Change\nPA - Payment Added\nPU - Payment Updated\nPD - Payment Deleted\n',
  `a_id` int(11) NOT NULL,
  `a_notes` varchar(255) NOT NULL,
  `user_ip` varchar(20) NOT NULL,
  PRIMARY KEY (`finance_activity_id`),
  UNIQUE KEY `user_activity_id_UNIQUE` (`finance_activity_id`),
  KEY `ix_entity_invoice_id` (`entity_id`,`invoice_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_invoice`;
CREATE TABLE `ot_invoice` (
  `invoice_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `client_id` int(11) NOT NULL,
  `invoice_number` varchar(16) NOT NULL,
  `invoice_date` date NOT NULL,
  `estimate_id` int(11) NOT NULL,
  `status` char(1) NOT NULL COMMENT 'd - draft\ns - sent\no- overdue\np-paid\nb-partial\n',
  `subject` varchar(255) NOT NULL,
  `notes` varchar(1000) NOT NULL,
  `discount_percentage` float NOT NULL,
  `discount_amount` float NOT NULL,
  `tax1_name` varchar(30) NOT NULL,
  `tax1_percentage` float NOT NULL,
  `tax1_amount` float NOT NULL,
  `tax2_name` varchar(30) NOT NULL,
  `tax2_percentage` float NOT NULL,
  `tax2_amount` float NOT NULL,
  `tax2_tax1_iscom` tinyint(1) NOT NULL,
  `tax3_name` varchar(30) NOT NULL,
  `tax3_percentage` float NOT NULL,
  `tax3_amount` float NOT NULL,
  `tax3_tax1_iscom` tinyint(1) NOT NULL,
  `tax3_tax2_iscom` tinyint(1) NOT NULL,
  `amount` float NOT NULL,
  `currency_code` varchar(4) NOT NULL,
  `due_date_mode` varchar(3) NOT NULL COMMENT 'D0 - Same as the invoice date\nD7 - 7 days after the invoice\nD14 - 2 weeks after the invoice\nD15 - 15 days after the invoice\nM1 - 1 month after the invoice\nM2 - 2 months after the invoice\nM3 - 3 months after the invoice\nC - custom',
  `due_date` date NOT NULL,
  `recurring_mode` varchar(3) NOT NULL COMMENT '[blank] - No Recurring\nD7 - Every Week\nD14 - Every 2 Weeks\nD15 - Every 15 Days\nM1 - Every 1 month\nM2 - Every 2 months\nM3 - Every 3 months\nM4 - Every 4 months\nM6 - Every 6 months\nM12 - Every Year\nEMF - First Day of each month\nEML - Last Day of each month\nC /* comment truncated */ /* - custom*/',
  `recurring_next_inv_date` datetime NOT NULL,
  `recurring_auto` tinyint(1) NOT NULL,
  `payment_amount` float DEFAULT 0,
  `is_deposit` tinyint(1) NOT NULL,
  `deposit_balance` float NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  `is_archive` tinyint(1) NOT NULL DEFAULT 0,
  `client_contact_id` int(11) NOT NULL,
  `address` varchar(500) NOT NULL,
  `date_filter_type` varchar(5) NOT NULL,
  `from_date` date NOT NULL,
  `to_date` date NOT NULL,
  `import_config` varchar(500) NOT NULL,
  PRIMARY KEY (`invoice_id`),
  UNIQUE KEY `estimate_id_UNIQUE` (`invoice_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_invoice_items`;
CREATE TABLE `ot_invoice_items` (
  `invoice_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `invoice_id` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `description` varchar(1000) NOT NULL,
  `quantity` float NOT NULL,
  `rate` float NOT NULL,
  `amount` float NOT NULL,
  `is_tax1` tinyint(1) NOT NULL,
  `is_tax2` tinyint(1) NOT NULL,
  `is_tax3` tinyint(1) NOT NULL,
  `serial_no` smallint(6) NOT NULL,
  PRIMARY KEY (`invoice_item_id`),
  KEY `ix_entity_invoice_id` (`entity_id`,`invoice_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_invoice_payment`;
CREATE TABLE `ot_invoice_payment` (
  `invoice_payment_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `invoice_id` int(11) NOT NULL,
  `payment_number` varchar(16) NOT NULL,
  `payment_date` date NOT NULL,
  `description` varchar(500) NOT NULL,
  `deposit_invoice_id` int(11) NOT NULL COMMENT 'C - Cash\n',
  `amount` decimal(10,2) NOT NULL COMMENT 'Cash\nCheck\nBank Transfer\nCredit Card\nDebit Card\nPaypal\nOther',
  PRIMARY KEY (`invoice_payment_id`),
  KEY `ix_entity_invoice_id` (`entity_id`,`invoice_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_notification`;
CREATE TABLE `ot_notification` (
  `notification_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `task_id` int(11) NOT NULL,
  `type` char(3) DEFAULT NULL COMMENT 'TS-TimeSheet Started, TO-TimeSheet Stoped, TA-New Task Added, TD-Task date updated, TP-Task Priority Updated, TS-Task Status Updated, TU-Task updated, CO-Comment posted, AT-Attachment posted,',
  `message` varchar(1000) DEFAULT NULL,
  `count` int(4) NOT NULL,
  `is_read` tinyint(1) NOT NULL DEFAULT 0,
  `updated_date` datetime NOT NULL,
  `created_date` datetime NOT NULL,
  PRIMARY KEY (`notification_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_oauth`;
CREATE TABLE `ot_oauth` (
  `oauth_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `application` varchar(24) NOT NULL COMMENT 'quickbooks,google,harvest,dropbox',
  `email` varchar(80) DEFAULT NULL COMMENT 'Linked Email ID',
  `consumer_key` varchar(255) NOT NULL,
  `consumer_secret` varchar(255) NOT NULL,
  `oauth_token` varchar(255) NOT NULL,
  `oauth_secret` varchar(255) NOT NULL,
  `params` mediumtext NOT NULL,
  `updated_date` datetime DEFAULT NULL,
  PRIMARY KEY (`oauth_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_oauth_access_tokens`;
CREATE TABLE `ot_oauth_access_tokens` (
  `access_token` varchar(40) NOT NULL,
  `client_id` varchar(80) NOT NULL,
  `user_id` varchar(255) DEFAULT NULL,
  `expires` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `scope` varchar(2000) DEFAULT NULL,
  PRIMARY KEY (`access_token`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_oauth_authorization_codes`;
CREATE TABLE `ot_oauth_authorization_codes` (
  `authorization_code` varchar(40) NOT NULL,
  `client_id` varchar(80) NOT NULL,
  `user_id` varchar(255) DEFAULT NULL,
  `redirect_uri` varchar(2000) DEFAULT NULL,
  `expires` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `scope` varchar(2000) DEFAULT NULL,
  PRIMARY KEY (`authorization_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_oauth_clients`;
CREATE TABLE `ot_oauth_clients` (
  `client_id` varchar(80) NOT NULL,
  `client_secret` varchar(80) NOT NULL,
  `redirect_uri` varchar(2000) NOT NULL,
  `grant_types` varchar(80) DEFAULT NULL,
  `user_id` varchar(80) DEFAULT NULL,
  `title` varchar(255) NOT NULL,
  `description` text NOT NULL,
  PRIMARY KEY (`client_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_oauth_jwt`;
CREATE TABLE `ot_oauth_jwt` (
  `client_id` varchar(80) NOT NULL,
  `subject` varchar(80) DEFAULT NULL,
  `public_key` varchar(2000) DEFAULT NULL,
  PRIMARY KEY (`client_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_oauth_refresh_tokens`;
CREATE TABLE `ot_oauth_refresh_tokens` (
  `refresh_token` varchar(40) NOT NULL,
  `client_id` varchar(80) NOT NULL,
  `user_id` varchar(255) DEFAULT NULL,
  `expires` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `scope` varchar(2000) DEFAULT NULL,
  PRIMARY KEY (`refresh_token`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_oauth_scopes`;
CREATE TABLE `ot_oauth_scopes` (
  `type` varchar(255) NOT NULL DEFAULT 'supported',
  `scope` varchar(2000) DEFAULT NULL,
  `client_id` varchar(80) DEFAULT NULL,
  `is_default` tinyint(1) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_project`;
CREATE TABLE `ot_project` (
  `project_id` int(11) NOT NULL AUTO_INCREMENT,
  `project_number` int(11) NOT NULL DEFAULT 0,
  `client_id` int(11) NOT NULL,
  `project_name` varchar(80) NOT NULL,
  `project_code` varchar(15) DEFAULT NULL,
  `is_active` tinyint(1) NOT NULL,
  `description` text DEFAULT NULL,
  `entity_id` int(11) NOT NULL,
  `invoice_type` char(1) NOT NULL COMMENT 'N - Non Billable\nA - Project All Hours\nT - Task Hourly Rate\nP - Person Hourly Rate',
  `budget_type` char(2) NOT NULL COMMENT 'HA - Total Project Hours\nHT - Hours based on Task Type\nHP - Hours based on Person\nAA - Total Project Amount\nAT - Amount based on Task Type Hours\nAP -  Amount based on Person Hours',
  `budget_value` float NOT NULL DEFAULT 0,
  `budget_alert_percent` smallint(6) NOT NULL DEFAULT 0,
  `actual_value` float NOT NULL DEFAULT 0 COMMENT 'Updated when Task Hours Approved / Deleted',
  `members_count` smallint(6) NOT NULL,
  `all_users` tinyint(1) NOT NULL,
  `uninvoiced_hours` float(9,2) NOT NULL DEFAULT 0.00,
  `bg_color` varchar(7) NOT NULL DEFAULT '',
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  `task_settings` varchar(1000) NOT NULL COMMENT 'columns: tn, na, du , st, sd etc\nview: Assignees only can view - Boolean',
  `hourly_rate` int(11) NOT NULL DEFAULT 0,
  `estimated_hours` int(11) NOT NULL,
  `start_date` date NOT NULL,
  `target_date` date NOT NULL,
  `status_id` int(11) NOT NULL,
  `team_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`project_id`),
  KEY `ix_entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_project_activity`;
CREATE TABLE `ot_project_activity` (
  `project_activity_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `task_id` int(11) NOT NULL,
  `a_date` datetime NOT NULL,
  `a_mode` char(2) NOT NULL COMMENT 'PN - Project Create\nPU - Project Update\nPD - Project Delete\nTN - Task New\nTC - Task Closed\nTU - Task Update\nTD - Task Delete\nTS - Task Status Update\nUA - User Assigned\nUR - User Removed',
  `a_id` int(11) NOT NULL,
  `a_notes` varchar(255) NOT NULL,
  `user_ip` varchar(20) NOT NULL,
  PRIMARY KEY (`project_activity_id`,`user_ip`),
  UNIQUE KEY `user_activity_id_UNIQUE` (`project_activity_id`),
  KEY `ix_entity_project_id` (`entity_id`,`project_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_project_discussion`;
CREATE TABLE `ot_project_discussion` (
  `project_discussion_id` int(11) NOT NULL AUTO_INCREMENT,
  `project_id` int(11) NOT NULL,
  `discussion_date` int(11) NOT NULL,
  `message` text DEFAULT NULL,
  `entity_id` int(11) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  PRIMARY KEY (`project_discussion_id`),
  KEY `ix_entity_project_id` (`entity_id`,`project_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_project_discussion_comment`;
CREATE TABLE `ot_project_discussion_comment` (
  `project_discussion_comment_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `project_discussion_id` int(11) NOT NULL,
  `comment_id` int(11) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  PRIMARY KEY (`project_discussion_comment_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_project_expense`;
CREATE TABLE `ot_project_expense` (
  `expense_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `expense_date` date NOT NULL,
  `amount` decimal(10,2) NOT NULL,
  `expense_type_id` int(11) NOT NULL,
  `notes` text DEFAULT NULL,
  `approved_by` int(11) NOT NULL,
  `invoice_id` int(11) NOT NULL DEFAULT 0,
  `quantity` float(9,2) NOT NULL,
  `unit_price` float(9,2) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  PRIMARY KEY (`expense_id`),
  KEY `ix_entity_expense_date` (`entity_id`,`expense_date`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_project_expense_types`;
CREATE TABLE `ot_project_expense_types` (
  `project_expense_type_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `expense_type_id` int(11) NOT NULL,
  `estimated` float(9,2) DEFAULT NULL,
  `actual` float(9,2) DEFAULT 0.00,
  `created_by` int(11) DEFAULT NULL,
  `created_date` datetime DEFAULT NULL,
  `last_updated_by` int(11) DEFAULT NULL,
  `last_updated_date` datetime DEFAULT NULL,
  PRIMARY KEY (`project_expense_type_id`),
  KEY `ix_entity_project_id` (`entity_id`,`project_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_project_status`;
CREATE TABLE `ot_project_status` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `name` varchar(60) NOT NULL,
  `is_default` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_project_status` (`id`, `entity_id`, `name`, `is_default`) VALUES
(1,	1,	'Active',	1),
(2,	1,	'Completed',	0),
(3,	1,	'Not Started',	0),
(4,	1,	'On Hold',	0);

DROP TABLE IF EXISTS `ot_project_task`;
CREATE TABLE `ot_project_task` (
  `task_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `task_type_id` int(11) NOT NULL,
  `task_number` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `duration` varchar(10) NOT NULL,
  `task_status_id` int(11) NOT NULL,
  `start_date` datetime NOT NULL,
  `finish_date` datetime NOT NULL,
  `estimated_hours` varchar(10) DEFAULT '0',
  `predecessors` varchar(50) NOT NULL,
  `is_milestone` tinyint(1) DEFAULT 0,
  `is_closed` tinyint(1) DEFAULT 0,
  `is_archived` tinyint(1) NOT NULL DEFAULT 0,
  `parent_task_id` int(11) DEFAULT 0,
  `percentage_complete` smallint(6) DEFAULT 0,
  `notes` varchar(1000) NOT NULL,
  `actual_start_date` datetime DEFAULT '0000-00-00 00:00:00',
  `actual_finish_date` datetime DEFAULT '0000-00-00 00:00:00',
  `deviance` int(11) NOT NULL,
  `worked_hours` float(9,2) NOT NULL DEFAULT 0.00 COMMENT 'Linked with TS',
  `is_parent` tinyint(1) DEFAULT 0,
  `has_comments` tinyint(1) DEFAULT 0,
  `has_attachments` tinyint(1) DEFAULT 0,
  `chkl_count` int(11) NOT NULL DEFAULT 0,
  `created_by` int(11) NOT NULL,
  `created_date` datetime DEFAULT '0000-00-00 00:00:00',
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime DEFAULT '0000-00-00 00:00:00',
  `status_date` timestamp NULL DEFAULT '0000-00-00 00:00:00',
  `order_id` int(11) NOT NULL DEFAULT 0,
  `task_priority` tinyint(1) NOT NULL DEFAULT 2,
  `assignee_id` int(11) NOT NULL,
  `is_repeat` varchar(3) NOT NULL,
  `repeat_on` varchar(2) NOT NULL,
  PRIMARY KEY (`task_id`),
  KEY `ix_entity_project_id` (`entity_id`,`project_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_project_task_revision`;
CREATE TABLE `ot_project_task_revision` (
  `revision_id` int(11) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `revision_date` datetime NOT NULL,
  `project_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `task_id` int(11) NOT NULL,
  `field_code` varchar(2) NOT NULL COMMENT 'tn - task_number\nna - name\ndu - duration\nst - task_status_id\nsd - start_date\nfd - finish_date\npr - predecessors\nbi - is_billable\nmi - is_milestone\npt - parent_task_id\npc - percentage_complete\nco - comments\nas - actual_start_date\naf - actual_finish_date\nD  /* comment truncated */ /*- delete task*/',
  `field_old_value` varchar(1000) NOT NULL,
  `field_new_value` varchar(1000) NOT NULL,
  PRIMARY KEY (`revision_id`),
  UNIQUE KEY `revision_id_UNIQUE` (`revision_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_project_task_settings`;
CREATE TABLE `ot_project_task_settings` (
  `project_task_settings_id` int(11) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `settings` varchar(1000) NOT NULL,
  PRIMARY KEY (`project_task_settings_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_project_task_types`;
CREATE TABLE `ot_project_task_types` (
  `project_task_type_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `task_type_id` int(11) NOT NULL,
  `is_billable` tinyint(1) NOT NULL DEFAULT 0,
  `estimated_hours` float(9,2) NOT NULL DEFAULT 0.00,
  `hourly_rate` float NOT NULL DEFAULT 0,
  `actual_hours` float(9,2) NOT NULL DEFAULT 0.00 COMMENT 'Updated when Task Hours Approved / Deleted based on project budget type',
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  PRIMARY KEY (`project_task_type_id`),
  KEY `ix_entity_project_id` (`entity_id`,`project_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_project_task_users`;
CREATE TABLE `ot_project_task_users` (
  `project_task_user_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `task_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `is_new` tinyint(1) NOT NULL,
  `new_comments` int(11) NOT NULL,
  `modType` varchar(2) NOT NULL,
  PRIMARY KEY (`project_task_user_id`),
  KEY `ix_entity_task_id` (`entity_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_project_users`;
CREATE TABLE `ot_project_users` (
  `project_user_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `user_role` char(1) NOT NULL COMMENT 'A - Administrator\nF - Project Manager with Finance\nP - Project Manager\nM - Member',
  `is_billable` tinyint(1) NOT NULL DEFAULT 0,
  `estimated_hours` int(11) NOT NULL DEFAULT 0,
  `hourly_rate` float NOT NULL DEFAULT 0,
  `actual_hours` float(9,2) NOT NULL DEFAULT 0.00 COMMENT 'Updated when Task Hours Approved / Deleted based on project budget type',
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  `new_attachments` int(11) NOT NULL,
  `new_comments` int(11) NOT NULL,
  PRIMARY KEY (`project_user_id`),
  KEY `ix_entity_project_id` (`entity_id`,`project_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


SET NAMES utf8mb4;

DROP TABLE IF EXISTS `ot_score`;
CREATE TABLE `ot_score` (
  `score_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `entry_date` datetime NOT NULL,
  `acode` varchar(5) NOT NULL COMMENT 'actual_code',
  `score` int(11) NOT NULL,
  `real_score` int(11) NOT NULL,
  `description` text NOT NULL,
  `status` varchar(5) NOT NULL,
  `comments` text NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  PRIMARY KEY (`score_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


DROP TABLE IF EXISTS `ot_sessions`;
CREATE TABLE `ot_sessions` (
  `id` varchar(40) NOT NULL,
  `ip_address` varchar(45) NOT NULL,
  `timestamp` int(10) unsigned NOT NULL DEFAULT 0,
  `data` blob NOT NULL,
  KEY `ot_sessions_timestamp` (`timestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_setting`;
CREATE TABLE `ot_setting` (
  `setting_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `name` varchar(50) NOT NULL,
  `value` varchar(500) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  PRIMARY KEY (`setting_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_smtp_setting`;
CREATE TABLE `ot_smtp_setting` (
  `smtp_setting_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `server_name` varchar(20) NOT NULL,
  `user_name` varchar(20) NOT NULL,
  `password` varchar(100) NOT NULL,
  `from_name` varchar(20) NOT NULL,
  `from_email` varchar(20) NOT NULL,
  `port` int(11) NOT NULL,
  `is_ssl` int(11) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL,
  PRIMARY KEY (`smtp_setting_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_tags`;
CREATE TABLE `ot_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `tagName` varchar(60) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_tasks_delete_users`;
CREATE TABLE `ot_tasks_delete_users` (
  `entity_id` int(11) NOT NULL,
  `task_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `last_updated_date` datetime NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_task_status`;
CREATE TABLE `ot_task_status` (
  `task_status_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `name` varchar(60) NOT NULL,
  `is_default` tinyint(1) NOT NULL,
  `system_defined` varchar(1) DEFAULT '',
  `is_closed` tinyint(1) DEFAULT 0,
  `text_color` varchar(7) NOT NULL,
  `bg_color` varchar(7) NOT NULL,
  `sort_order` int(11) NOT NULL,
  PRIMARY KEY (`task_status_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_task_status` (`task_status_id`, `entity_id`, `name`, `is_default`, `system_defined`, `is_closed`, `text_color`, `bg_color`, `sort_order`) VALUES
(1,	1,	'Open',	1,	'O',	0,	'#ffffff',	'#20b717',	1),
(2,	1,	'In progress',	0,	'',	0,	'#ffffff',	'#2390ff',	2),
(3,	1,	'Need Details',	0,	'',	0,	'#ffffff',	'#fd6c01',	3),
(4,	1,	'Reassigned',	0,	'',	0,	'#ffffff',	'#496100',	4),
(5,	1,	'Review',	0,	'',	0,	'#ffffff',	'#f9f001',	5),
(6,	1,	'Closed',	0,	'C',	1,	'#ffffff',	'#535352',	6),
(7,	1,	'Hold',	0,	'H',	0,	'#ffffff',	'#cdcdcd',	7);

DROP TABLE IF EXISTS `ot_task_tags`;
CREATE TABLE `ot_task_tags` (
  `entity_id` int(11) NOT NULL,
  `tag_id` int(11) NOT NULL,
  `task_id` int(11) NOT NULL,
  PRIMARY KEY (`tag_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_task_tmpl`;
CREATE TABLE `ot_task_tmpl` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `tasks` text NOT NULL,
  `created_by` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `entity_id` (`entity_id`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `ot_task_type`;
CREATE TABLE `ot_task_type` (
  `task_type_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `name` varchar(60) NOT NULL,
  `hourly_rate` float NOT NULL,
  `is_common` tinyint(1) NOT NULL,
  `is_billable` tinyint(1) DEFAULT 0,
  `sort_order` int(11) NOT NULL,
  PRIMARY KEY (`task_type_id`),
  UNIQUE KEY `task_type_id_UNIQUE` (`task_type_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_task_type` (`task_type_id`, `entity_id`, `name`, `hourly_rate`, `is_common`, `is_billable`, `sort_order`) VALUES
(1,	1,	'Design',	0,	1,	0,	2),
(2,	1,	'Engineering / Development',	0,	1,	0,	3),
(3,	1,	'Project Management',	0,	1,	0,	5),
(4,	1,	'Quality Assurance',	0,	1,	0,	6),
(5,	1,	'Sales / Biz Dev',	0,	1,	0,	7),
(6,	1,	'System Administration',	0,	1,	0,	9);

DROP TABLE IF EXISTS `ot_team`;
CREATE TABLE `ot_team` (
  `team_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `team_name` varchar(64) NOT NULL,
  `isActive` tinyint(1) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  PRIMARY KEY (`team_id`),
  UNIQUE KEY `team_id` (`team_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `ot_team_users`;
CREATE TABLE `ot_team_users` (
  `team_user_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `team_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `user_role` char(1) DEFAULT NULL COMMENT 'A - Administrator\nF - Project Manager with Finance\nP - Project Manager\nM - Member',
  `is_billable` tinyint(1) DEFAULT NULL,
  `estimated_hours` int(11) DEFAULT NULL,
  `hourly_rate` float DEFAULT NULL,
  `actual_hours` float(9,2) DEFAULT 0.00 COMMENT 'Updated when Task Hours Approved / Deleted based on project budget type',
  `created_by` int(11) DEFAULT NULL,
  `created_date` datetime DEFAULT NULL,
  `last_updated_by` int(11) DEFAULT NULL,
  `last_updated_date` datetime DEFAULT NULL,
  `new_attachments` int(11) NOT NULL,
  `new_comments` int(11) NOT NULL,
  PRIMARY KEY (`team_user_id`),
  KEY `ix_entity_team_id` (`entity_id`,`team_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_time_sheet`;
CREATE TABLE `ot_time_sheet` (
  `time_sheet_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `task_type_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `project_task_id` int(11) NOT NULL,
  `entry_date` date NOT NULL,
  `hours` float(6,4) NOT NULL,
  `estimated_hours` float(4,2) NOT NULL,
  `created_by` int(11) NOT NULL,
  `notes` varchar(500) NOT NULL,
  `is_archive` tinyint(1) NOT NULL,
  `is_billable` tinyint(1) NOT NULL,
  `is_progress` tinyint(1) NOT NULL,
  `is_basedontime` bit(1) NOT NULL COMMENT '1 - If the entries are based on Start & End Time of Time Sheet Detail.\nEditing the hours directly should reset the flag.',
  `invoice_id` int(11) NOT NULL COMMENT 'if > 0 means, it is invoiced.',
  `approval_status` char(1) NOT NULL COMMENT 'S - Submitted\nA - Accepted\nEmpty - Editable',
  `approved_by` int(11) NOT NULL,
  `approved_date` timestamp NULL DEFAULT NULL,
  `last_updated_by` int(11) NOT NULL,
  `last_updated_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activity_name` varchar(255) NOT NULL,
  PRIMARY KEY (`time_sheet_id`),
  KEY `ix_entity_entry_date_project_id` (`entity_id`,`entry_date`,`project_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_time_sheet_detail`;
CREATE TABLE `ot_time_sheet_detail` (
  `time_sheet_detail_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `time_sheet_id` int(11) NOT NULL,
  `from_time` time NOT NULL,
  `to_time` time NOT NULL,
  `hours` float(9,2) NOT NULL,
  `is_progress` tinyint(1) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `updated_by` int(11) NOT NULL,
  `updated_date` datetime NOT NULL,
  PRIMARY KEY (`time_sheet_detail_id`),
  KEY `ix_entity_time_sheet_id` (`entity_id`,`time_sheet_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_users_auth_tokens`;
CREATE TABLE `ot_users_auth_tokens` (
  `token_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `auth_token` varchar(250) NOT NULL,
  `expiry_date` datetime NOT NULL,
  PRIMARY KEY (`token_id`),
  KEY `ix_entity_auth_token` (`entity_id`,`auth_token`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_user_activity`;
CREATE TABLE `ot_user_activity` (
  `user_activity_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `a_date` datetime NOT NULL,
  `a_mode` char(2) NOT NULL COMMENT 'LN - Login\nLO - Logout\nTU - Time Sheet Update\nCU - Comments Update\n\n',
  `a_id` int(11) NOT NULL,
  `a_notes` varchar(255) NOT NULL,
  `user_ip` varchar(20) NOT NULL,
  PRIMARY KEY (`user_activity_id`),
  UNIQUE KEY `user_activity_id_UNIQUE` (`user_activity_id`),
  KEY `ix_entity_user_id` (`entity_id`,`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_user_department`;
CREATE TABLE `ot_user_department` (
  `user_dept_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `department` varchar(40) NOT NULL,
  `task_types` varchar(250) NOT NULL,
  PRIMARY KEY (`user_dept_id`),
  UNIQUE KEY `user_dept_id_UNIQUE` (`user_dept_id`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ot_user_department` (`user_dept_id`, `entity_id`, `department`, `task_types`) VALUES
(1,	1,	'Accounting',	''),
(2,	1,	'Administration',	''),
(3,	1,	'Finance',	''),
(4,	1,	'Human Resources',	''),
(5,	1,	'Marketing',	''),
(6,	1,	'Sales',	'');

DROP TABLE IF EXISTS `ot_user_mails`;
CREATE TABLE `ot_user_mails` (
  `user_mails_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `mail_type` varchar(250) NOT NULL DEFAULT 'W' COMMENT 'W-Weekly,M-Monthly,D-Daily,WS-weekly,DD-daily digest,AT(A|C) assigned task status, FT(A|C) following task status',
  `is_subscribed` tinyint(1) NOT NULL DEFAULT 1,
  PRIMARY KEY (`user_mails_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


DROP TABLE IF EXISTS `ot_user_notifications`;
CREATE TABLE `ot_user_notifications` (
  `notification_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `module_type` char(1) NOT NULL COMMENT 'P/T/I/W/C',
  `module_id` int(11) NOT NULL,
  `module_action` char(2) NOT NULL,
  `post_by` text NOT NULL,
  `is_read` tinyint(1) NOT NULL DEFAULT 0,
  `posted_on` int(11) NOT NULL,
  `notes` text NOT NULL,
  `type` char(1) NOT NULL COMMENT 'T/W',
  PRIMARY KEY (`notification_id`),
  KEY `user_date` (`user_id`,`posted_on`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_user_notification_read`;
CREATE TABLE `ot_user_notification_read` (
  `user_id` int(11) NOT NULL,
  `notific_last_read` int(11) NOT NULL,
  `post_id` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_user_report_settings`;
CREATE TABLE `ot_user_report_settings` (
  `rpt_setting_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `report_code` varchar(2) NOT NULL COMMENT 'TS - Time Summary\\nTD - Time Detail\\nTK - Task\\nES - Expense Summary\\nED - Expense Detail\\nIS - Invoice Summary\\nID - Invoice Detail\\nIA - Invoice Aging\\nIO - Invoice Outstanding\\nIU - Invoice Uninvoiced\\nBU - Budget',
  `report_columns` text DEFAULT NULL,
  `date_filter_type` varchar(2) NOT NULL,
  `sort_by` varchar(2) NOT NULL,
  PRIMARY KEY (`rpt_setting_id`),
  KEY `ix_entity_user_id` (`entity_id`,`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_wall_activity`;
CREATE TABLE `ot_wall_activity` (
  `activity_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `to_type` char(1) NOT NULL COMMENT 'U-User/P-Project/E-Every One/M-Project Manager/F-Project Finance/A-Administrator',
  `to_id` int(11) NOT NULL COMMENT 'User_Id or Project_id or 0',
  `module_type` char(1) NOT NULL COMMENT 'P(Project), T(Task),I(Invoice),E(Estimate),U(User),X(Expense),R(Invoice Payment Receipt),A(Attachment), O(post)',
  `module_id` int(11) NOT NULL,
  `last_updated` int(11) NOT NULL,
  PRIMARY KEY (`activity_id`),
  UNIQUE KEY `IX_to` (`to_type`,`to_id`,`last_updated`),
  KEY `IX_Activity` (`module_type`,`module_id`,`to_type`,`to_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_wall_favorite`;
CREATE TABLE `ot_wall_favorite` (
  `post_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  UNIQUE KEY `user_post_id` (`user_id`,`post_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_wall_notification`;
CREATE TABLE `ot_wall_notification` (
  `notification_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `module_type` char(1) NOT NULL COMMENT 'P/T/I/W/C',
  `module_id` int(11) NOT NULL,
  `module_action` char(1) NOT NULL,
  `post_by` text NOT NULL,
  `is_read` tinyint(1) NOT NULL DEFAULT 0,
  `posted_on` int(11) NOT NULL,
  PRIMARY KEY (`notification_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_wall_posts`;
CREATE TABLE `ot_wall_posts` (
  `post_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `post_date` int(11) NOT NULL DEFAULT 0 COMMENT 'Timestamp',
  `post_by` int(11) NOT NULL,
  `post_to` text NOT NULL,
  `post_type` char(1) NOT NULL COMMENT 'M-Message / E-Event / P-Poll / A-Announcement',
  `post_subject` varchar(255) NOT NULL DEFAULT '',
  `post_message` text NOT NULL,
  `post_content` text NOT NULL,
  `post_input` text NOT NULL,
  `followers` text NOT NULL COMMENT 'User_id comma delimiter',
  `unfollow` text NOT NULL COMMENT 'User_id comma delimiter',
  `like_count` smallint(5) unsigned NOT NULL,
  `liked` text NOT NULL COMMENT 'User_id comma delimiter',
  `ack_count` smallint(5) unsigned NOT NULL,
  `ack` text NOT NULL COMMENT 'User_id comma delimiter',
  `keep_ontop_till` int(11) NOT NULL COMMENT 'Timestamp',
  `comments_count` int(11) NOT NULL,
  PRIMARY KEY (`post_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_wall_tagmessages`;
CREATE TABLE `ot_wall_tagmessages` (
  `tag_id` int(11) NOT NULL,
  `message_id` int(11) NOT NULL,
  PRIMARY KEY (`tag_id`,`message_id`),
  KEY `message_id` (`message_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_wall_tags`;
CREATE TABLE `ot_wall_tags` (
  `tag_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) NOT NULL,
  `entity_id` int(11) NOT NULL,
  PRIMARY KEY (`tag_id`),
  UNIQUE KEY `entity_tagname` (`entity_id`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_wall_tokens`;
CREATE TABLE `ot_wall_tokens` (
  `token_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `first_name` varchar(30) NOT NULL,
  `email` varchar(50) NOT NULL,
  `user_role` varchar(1) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `auth_token` varchar(250) NOT NULL,
  `expiry_date` datetime NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ot_wall_usermessages`;
CREATE TABLE `ot_wall_usermessages` (
  `user_id` int(11) NOT NULL,
  `message_id` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


-- 2022-09-28 12:19:56

DROP TABLE IF EXISTS `ot_captcha`;
CREATE TABLE `ot_captcha` (
	`captcha_id` bigint(13) unsigned NOT NULL AUTO_INCREMENT,
	`captcha_time` int(10) unsigned NOT NULL,
	`ip_address` varchar(45) NOT NULL,
	`word` varchar(20) NOT NULL,
	PRIMARY KEY (`captcha_id`),
	KEY `word` (`word`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 2023-11-20 12:57:56

-- Sprint Queries Begins

CREATE TABLE `ot_sprint` (
  `sprint_id` int(11) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `duration` varchar(20) NOT NULL,
  `start_date` datetime DEFAULT NULL,
  `end_date` datetime DEFAULT NULL,
  `created_by` int(11) DEFAULT NULL,
  `created_date` datetime DEFAULT NULL,
  `last_updated_by` int(11) DEFAULT NULL,
  `last_updated_date` datetime DEFAULT NULL,
  `is_complete` tinyint(1) DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

ALTER TABLE `ot_sprint` ADD PRIMARY KEY (`sprint_id`), ADD KEY `entity_id` (`entity_id`);
ALTER TABLE `ot_sprint` MODIFY `sprint_id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `ot_project_task` ADD `sprint_id` INT(11) NOT NULL DEFAULT '0' AFTER `repeat_on`;
ALTER TABLE `ot_project_task` ADD `story_point` INT(11) NULL DEFAULT '0' AFTER `sprint_id`;
ALTER TABLE `ot_entity_setting` ADD `release_mail` TINYINT(1) NOT NULL DEFAULT '1' AFTER `has_update`;
ALTER TABLE `ot_entity_setting` ADD `sprint_required` TINYINT(1) NOT NULL DEFAULT '0' AFTER `release_mail`;
ALTER TABLE `ot_entity_setting` ADD `daily_progress_report_required` TINYINT(1) NOT NULL DEFAULT '0' AFTER `sprint_required`;
ALTER TABLE `ot_entity_setting` ADD `preschedule_min_hours_per_day` int NOT NULL AFTER `daily_progress_report_required`;
ALTER TABLE `ot_entity_setting` ADD `user_depts` VARCHAR(255) NOT NULL AFTER `preschedule_min_hours_per_day`;
ALTER TABLE `ot_entity_setting` ADD `daily_progress_user_depts` VARCHAR(255) NOT NULL AFTER `user_depts`;

CREATE TABLE `ot_user_setting` (
  `setting_id` int(11) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `setting_code` varchar(8) NOT NULL,
  `setting_value` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
ALTER TABLE `ot_user_setting` ADD PRIMARY KEY (`setting_id`), ADD UNIQUE KEY `IX_eus` (`entity_id`,`user_id`,`setting_code`);
ALTER TABLE `ot_user_setting` MODIFY `setting_id` int(11) NOT NULL AUTO_INCREMENT;

-- Sprint Queries Ends

