String.prototype.ucfirst = function() {
    return this.charAt(0).toUpperCase() + this.slice(1);
}
Array.prototype.quickSort	= function(customSort) {
	customSort	= customSort || function(a, b){
		return a > b; // if true, place value as "greater"
	};

	var arr	= this;

	if (arr.length === 0)
	{
		return [];
	}

	var left	= [];
	var right	= [];
	var pivot	= arr[0];

	// go through each element in array
	for (var i=1, iLen=arr.length; i<iLen; i++)
	{
		if (customSort(arr[i], pivot))
		{
			right.push(arr[i]);
		}
		else
		{
			left.push(arr[i]);
		}
	}
	return left.quickSort(customSort).concat(pivot, right.quickSort(customSort));
};
String.prototype.hexEncode = function(){
	var hex, result	= "";
	for (var i=0, iLen=this.length; i<iLen; i++)
	{
		hex	= this.charCodeAt(i).toString(16);
		result += "\\u" + ("000"+hex).slice(-4).toUpperCase();
	}
	return result;
};
String.prototype.hexDecode	= function(){
	var hexes	= this.match(/.{1,4}/g) || [];
	var back	= "";
	for(var j=0, jLen=hexes.length; j<jLen; j++)
	{
		back += String.fromCharCode(parseInt(hexes[j], 16));
	}

	return back;
}
function SMXIcons(options)
{
	var _this	= this;

	// empty Gif file / blank image.
	_this.bi = 'data:image/gif;base64,R0lGODlhAQABAJH/AP///wAAAMDAwAAAACH5BAEAAAIALAAAAAABAAEAAAICVAEAOw==';

	var reversemap	= {};
	var unicodes	= [];
	var rx_codes	= '';

	options	= options || {};
	if (!options.config)
	{
		return false;
	}

	var config	= options.config;

	config.mapping	= {};

	var getById	= function(id){
		return document.getElementById(id);
	};
	var newElem	= function(tag, id, className){
		var ret = document.createElement(tag);

		if (id && typeof id === "object")
		{
			for (key in id)
			{
				ret.setAttribute(key, id[key]);
			}
/*
			var keys = Object.keys(id);
			for (var k=0,kLen=keys.length; k<kLen; k++)
			{
				ret.setAttribute(keys[k], id[keys[k]]);
			}
*/
		}
		else
		{
			id && ret.setAttribute("id", id);
			className && ret.setAttribute("class", className);
		}
		return ret;
	};

	_this.newRecentEmoji	= function(code){
		var img	= newElem('span', {
			"file": code.file,
			"symbol": code.symbol,
			"unicode": code.unicode,
			"txt": code.txt,
			"class": "img emoji-cat-" + code.catid + " emoji-" + code.txt,
			"title": code.txt.replace(/_/g, " ").ucfirst(),
			"position": code.position,
			"style": "background-position:" + code.position
//			"src": _this.bi
		});
		_this.categories[-1].appendChild(img);
	};

	_this.Storage	= new function(){

		var self	= this;

		self.Get	= function(){
			// return JSON.parse(typeof localStorage !== "undefined" ? (localStorage.smx_emoji || '{}') : (typeof window.external.getStorge !== "undefined" ? (window.external.getStorge() || '{}') : '{}'));
			var ret = '{}';
			if (typeof localStorage !== "undefined")
			{
				ret = localStorage.smx_emoji || '{}';
			}
			else if(typeof window.external.getStorge !== "undefined")
			{
				ret = window.external.getStorge() || '{}';
			}
			return JSON.parse(ret);
		};
		self.Set	= function(selectedData){
			var obj	= self.Get();

			if (!obj.recent)
				obj.recent	= [];

			if (!obj.recent_list)
				obj.recent_list	= {};

			if (!obj.recent_list[selectedData.txt])
			{
				selectedData.times	= 1;
				obj.recent_list[selectedData.txt]	= selectedData;
				obj.recent.push(selectedData.txt);

				_this.newRecentEmoji(selectedData);
			}
			else
			{
				obj.recent_list[selectedData.txt].times	= obj.recent_list[selectedData.txt].times + 1;
			}

			obj = JSON.stringify(obj);
			if (typeof localStorage !== "undefined")
			{
				localStorage.smx_emoji	= obj;
			}
			else if(typeof window.external.setStorge !== "undefined")
			{
				window.external.setStorge(obj);
			}

			return self;
		};

		self.each	= function(clbk){
			var obj	= self.Get();

			if (obj && obj.recent && obj.recent_list)
			{
				// Need sorting fn here.
				var sortedRecent	= obj.recent.quickSort(function(a, b){
					return obj.recent_list[a].times < obj.recent_list[b].times;
				});
				for (var i=0, iLen=sortedRecent.length; i<iLen; i++)
				{
					clbk(obj.recent_list[sortedRecent[i]]);
				}
				return true;
			}
			return false;
		};
	};

	_this.menus	= [];
	_this.categories	= [];

	_this.showCat	= function(catid){
		for (var i=-1, iLen=_this.categories.length; i<iLen; i++)
		{
			_this.categories[i].className	= _this.categories[i].className.replace(" active", "");
			_this.menus[i].className	= _this.menus[i].className.replace(" active", "");
		}

		_this.categories[catid].className	= _this.categories[catid].className + " active";
		_this.menus[catid].className	= _this.menus[catid].className + " active";
		
		if (_this.emojiScroll)
			_this.emojiScroll.refresh();
		else
			_this.emojiScroll	= new scrollbot(document.getElementById("emoji-cat-list"), options.scrollBarWid).setStyle({width: "7px"},{width: "7px", backgroundColor:"lightgray"});

		typeof options.onCatChange === "function" && options.onCatChange();
	};

	var onMenuClick	= function(e){
		_this.showCat(e.target.getAttribute("catid"));
	};

	var onEmojiSelect = function(e, catid){
		if (e.target.tagName == "SPAN")
		{
			var selectedData	= {
				txt: e.target.getAttribute("txt"),
				unicode: e.target.getAttribute("unicode"),
				file: e.target.getAttribute("file"),
				position: e.target.getAttribute("position"),
				catid: catid
			};

			_this.Storage.Set(selectedData);
			options.onSelect(selectedData, e);
		}
	};

	_this.buildTmpl	= function(){
		if (!options.config)
			return false;

		var ifRenderTmpl	= options.emojiBox ? true : false;

		if (ifRenderTmpl)
		{
			var emoji_box	= getById(options.emojiBox);
			emoji_box && emoji_box.setAttribute("class", "emoji-box");
			var emoji_cat	= newElem("div", "emoji-cat");
			emoji_box && emoji_box.appendChild(emoji_cat);

// #Menu begins
			var emoji_menu_list	= newElem("ul", null, "emoji-menu-list");
			emoji_cat.appendChild(emoji_menu_list);
// #Menu End

// # Emoji List Div Begins
			var emojiList = newElem("div", "emoji-cat-list", "emoji-cat-list");
			emoji_cat.appendChild(emojiList);
// # Emoji List Div End

// #History Menu & list Begins
			var recentMenu	= newElem("li", {
				"class":"emoji-menu",
				"catid": -1
			});

			recentMenu.onclick	= onMenuClick;
			recentMenu.appendChild(newElem("a", {
				"href": "javascript:;",
				"catid": -1,
				"title": "Recent",
				"class": "menu-recent"
			}));
			_this.menus[-1]	= recentMenu;
			emoji_menu_list.appendChild(recentMenu);

			var recentList	= newElem('div');
			recentList.setAttribute("id", "emoji-list--1");
			recentList.setAttribute("class", "emoji-list");

			recentList.onclick = function(e){
				onEmojiSelect(e, -1);
			};
			_this.categories[-1]	= recentList;
			var isRecent = _this.Storage.each(_this.newRecentEmoji);
			emojiList.appendChild(recentList);
// #History Menu & list End
		}

		var i=0, j=0,
			totalCat = config.EmojiCategories.length,
			category = null,
			dataItem = null;

		var total_columns = 9,
			i_width	 = 20,
			i_height = 20,
			gap = 4,
			padding = 2;

		var menus	= ["menu-smile", "menu-flower", "menu-bell", "menu-car", "menu-grid"];
		// while (i < totalCat)
		for (i=0; i<totalCat; i++)
		{
			category	= config.EmojiCategories[i];

			if (ifRenderTmpl)
			{
				var menu	= newElem("li", {
					"class":"emoji-menu",
					"catid": i
				});
				menu.onclick	= onMenuClick;
				menu.appendChild(newElem("a", {
					"href": "javascript:;",
					"catid": i,
					"class": menus[i]
				}));
				_this.menus[i]	= menu;
				emoji_menu_list.appendChild(menu);

				var div	= newElem('div');
				div.setAttribute("id", "emoji-list-" + i);
				div.setAttribute("class", "emoji-list");

				div.onclick = (function(catId){
					return function(e){
						onEmojiSelect(e, catId);
					};
				})(i);
				_this.categories[i]	= div;
			}

			// var y = 0;
			var row=0, col=0;
			var pos = "";
			for (var j=0, jLen=category.length; j<jLen; j++)
			{
				if (col == total_columns)
				{
					row++;
					col = 0;
				}
				dataItem	= config.Emoji[category[j]];

				if (col == 0)
				{
					pos = (col * (i_width + gap) + gap - padding) + "px ";
				}
				else
				{
					pos = "-" + (col * (i_width + gap) - gap + padding) + "px ";
				}

				if (row == 0)
				{
					pos += (row * (i_height + gap) + gap - padding) + "px";
				}
				else
				{
					pos += "-" + (row * (i_height + gap) - gap + padding) + "px";
				}

				if (ifRenderTmpl)
				{
					var img	= newElem('span', {
						"file": category[j],
						"symbol": dataItem[2],
						"unicode": dataItem[0],
						"txt":dataItem[1][0], //.join(' '),
						"class": "img emoji-" + dataItem[1].join(' '),
						"title": dataItem[1].join(' ').replace(/_/g, " ").ucfirst(),
						"position": pos,
						"style": "background-position:" + pos
//						"src": _this.bi
					});
					div.appendChild(img);
				}

// #Mapping Data preparation begins
				unicodes.push(dataItem[0]);
				if (dataItem[1].length > 1)
				{
					for (var tmpTxt=0; tmpTxt < dataItem[1].length; tmpTxt++)
					{
						reversemap[dataItem[0]]	= dataItem[1][tmpTxt];
						config.mapping[":" + dataItem[1][tmpTxt] + ":"]	= {
							"file": category[j],
							"symbol": dataItem[2],
							"unicode": dataItem[0],
							"txt":dataItem[1][0], //.join(' '),
							"position": pos,
							"cat": i
						};
					}
				}
				else
				{
					reversemap[dataItem[0]]	= dataItem[1][0];
					config.mapping[":" + dataItem[1][0] + ":"]	= {
						"file": category[j],
						"symbol": dataItem[2],
						"unicode": dataItem[0],
						"txt":dataItem[1][0], //.join(' '),
						"position": pos,
						"cat": i
					};
				}
// #Mapping Data preparation end

				col++;
			}

			ifRenderTmpl && emojiList.appendChild(div);
		}
		ifRenderTmpl && _this.showCat(isRecent ? -1 : 0);
		rx_codes	= new RegExp('(' + unicodes.join("|") + ')', 'g');
	};

	var toImg	= function(a){
		// return config.mapping[a] ? '<img class="icon-emoji emoji-cat-' + config.mapping[a].cat +'" txt="' + reversemap[a] + '" unicode="' + a + '" style="background-position:' + config.mapping[a].position + ';"src="' + _this.bi + '" title="' + a + '" />' : a;
		// return config.mapping[a] ? '<img src="svg/' + config.mapping[a].file + '.svg" width="25px" height="25px" class="" title="' + a + '" />' : a;

		return config.mapping[a] ? '<img class="icon-emoji emoji-cat-' + config.mapping[a].cat +'" code="' + config.mapping[a].unicode.hexEncode() + '" txt="' + config.mapping[a].txt + '" style="background-position:' + config.mapping[a].position + ';" src="' + _this.bi + '" title="' + config.mapping[a].txt + '" />' : a;
	};

	_this.toEmoji	= function(msg){
		if (!config.mapping)
		{
			_this.buildTmpl();
		}

//		/(\:\w+\:)/g
//		/(\:\+1\:)|(\:-1\:)|(\:\w+\:)/g

		msg	= _this.unicodeToImage(msg);
		msg = _this.codeToImage(msg);
		msg	= _this.smilyToImage(msg);

		return msg;
	};

	_this.codeToImage	= function(msg){
		return msg.replace(/(\:[\+|-]?\w+\:)/g, function(a){
			return toImg(a);
		});
	};

	_this.smilyToImage	= function(msg){
		return msg.replace(config.smileys_regex, function(a){
			return toImg(":" + config.smileys[a.trim()] + ":");
		});
	};

	_this.unicodeToImage	= function(msg){
		return msg.replace(rx_codes, function(a){
			return toImg(":" + reversemap[a] + ":");
		});
	};
}

