/* for jquery 1.1.8 to 3.1.0 migration begins */
var oldSelf = jQuery.fn.andSelf || jQuery.fn.addBack;

jQuery.fn.andSelf = function () {
	return oldSelf.apply(this, arguments);
};

jQuery.uaMatch = function (ua) {
	ua = ua.toLowerCase();

	var match = /(chrome)[ \/]([\w.]+)/.exec(ua) ||
		/(webkit)[ \/]([\w.]+)/.exec(ua) ||
		/(opera)(?:.*version|)[ \/]([\w.]+)/.exec(ua) ||
		/(msie) ([\w.]+)/.exec(ua) ||
		ua.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua) ||
		[];

	return {
		browser: match[1] || "",
		version: match[2] || "0"
	};
};

// Don't clobber any existing jQuery.browser in case it's different
if (!jQuery.browser) {
	matched = jQuery.uaMatch(navigator.userAgent);
	browser = {};

	if (matched.browser) {
		browser[matched.browser] = true;
		browser.version = matched.version;
	}

	// Chrome is Webkit, but Webkit is also Safari.
	if (browser.chrome) {
		browser.webkit = true;
	} else if (browser.webkit) {
		browser.safari = true;
	}

	jQuery.browser = browser;
}
/* for jquery 1.1.8 to 3.1.0 migration end */

ko.observableArray.fn.append = function (valuesToPush) {
	var underlyingArray = this();
	this.valueWillMutate();
	ko.utils.arrayPushAll(underlyingArray, valuesToPush);
	this.valueHasMutated();
	return this;
};

ko.observableArray.fn.prepend = function (valuesToPush) {
	var underlyingArray = this() || [];
	this.valueWillMutate();

	for (var i = 0, j = valuesToPush.length; i < j; i++) {
		underlyingArray.splice(i, 0, valuesToPush[i]);
	}

	this.valueHasMutated();

	return this;
};

ko.observableArray.fn.prependSingle = function (valueToPush, pushAt) {
	var underlyingArray = this() || [];
	pushAt = pushAt || 0;
	this.valueWillMutate();
	underlyingArray.splice(pushAt, 0, valueToPush);
	this.valueHasMutated();
	return this;
};

ko.bindingHandlers.log = {
	update: function (element, params) {
		console.log("Handler : ", params());
	}
};

ko.bindingHandlers.autosize = {
	init: function (element, params) {
		if ($(element).is("textarea") && autosize) {
			autosize($(element));
		}
	},
	update: function (element, params) {
		autosize.update($(element));
	}
};/*
ko.bindingHandlers.editor	= {
	init: function(element, valueAccessor){
		// var _params	= (typeof params() == 'object') ? params() : {};
		// _params.search_contains	= ko.utils.unwrapObservable(_params.search_contains);
// element.value
		var editr = new nicEditor({
			fullPanel: false,
			buttons: {},
			buttonList: [],
			iconsPath: 'assets/nicEdit/nicEditorIcons.gif',
			save: function(){
				console.log("Save");
			}
		}).panelInstance(element);
		// }).panelInstance(element, {hasPanel:false});
console.log(editr);
// myEditor.instanceById('myArea2').getContent()
		editr.addEvent("add", function(){
			console.log("add");
		});
		editr.addEvent("focus", function(){
			console.log("Focus");
		});
		editr.addEvent("blur", function(){
			console.log("Blur");
		});
		

// 	editr.setContent("Suresh");
		// bkLib.onDomLoaded(function() { nicEditors.allTextAreas() });
	},
	update: function(element, params){
// console.log("Called", element.value);
		// autosize.update($(element));
	}
};*/
ko.bindingHandlers.richtextEditor = {
	init: function (element, valueAccessor) {
		var params = valueAccessor();

		var editor_params = {
			format: false, fsize: false, color: false
			, b: false, i: false, u: false
			, ol: false, ul: false
			, sub: false, sup: false
			, outdent: false, indent: false
			, left: false, center: false, right: false
			, strike: false, remove: false
			, link: false, unlink: false, rule: false
			//			,source: false
		};
		if (params.focus) {
			editor_params.focus = function () {
				params.focus(true);
			};
		}
		$(element).jqte(editor_params);
	}
	//	,update: function(element, params){
	//	}
};
var fileTypeMap = {
	"text/x-comma-separated-values": "csv",
	"text/comma-separated-values": "csv",
	"application/octet-stream": "undefined",
	"application/vnd.ms-excel": "xls",
	"application/x-csv": "csv", "text/x-csv": "csv", "text/csv": "csv", "application/csv": "csv",
	"application/excel": "xls",
	"application/vnd.msexcel": "xls",
	"application/x-photoshop": "psd",
	"application/pdf": "pdf",
	"application/x-download": "undefined",
	"application/postscript": "ps",
	"application/msexcel": "xls",
	"application/powerpoint": "ppt",
	"application/vnd.ms-powerpoint": "ppt",
	"application/x-gzip": "zip",
	"application/x-javascript": "js",
	"application/x-tar": "zip",
	"application/x-gzip-compressed": "zip",
	"application/xhtml+xml": "xml",
	"application/x-zip": "zip",
	"application/zip": "zip",
	"application/x-zip-compressed": "zip",
	"image/bmp": "bmp",
	"image/x-windows-bmp": "bmp",
	"image/gif": "gif",
	"image/jpeg": "jpg",
	"image/pjpeg": "jpg",
	"image/png": "png",
	"image/x-png": "png",
	"image/tiff": "tiff",
	"text/css": "css",
	"text/html": "html",
	"text/plain": "txt",
	"text/x-log": "txt",
	"text/richtext": "rtf",
	"text/rtf": "rtf",
	"text/xml": "xml",
	"application/msword": "doc",
	"application/vnd.openxmlformats-officedocument.wordprocessingml.document": "doc",
	"application/vnd.openxmlformats-officedocument.spreadsheetml.sheet": "xls",
	"message/rfc822": "undefined",
	"application/json": "json",
	"text/json": "json",
	"video/mp4": "mp4",
	"video/3gpp": "v3gp",
	"video/quicktime": "mp4",
	"video/x-msvideo": "mov",
	"video/x-ms-wmv": "wmv",
	"video/avi": "avi",
	"video/x-flv": "flv"
};
var preparePreview = function (ev, data, parent, params) {
	var file = data.files[0];
	var disphtml = file.name;
	if ((file.size/1000000)>100) {
		alert('Maximum file upload size is 100MB!');
		return false;
	}
	if (file.size > 0) {
		disphtml += " (" + Math.round(file.size / 1024) + "KB" + ")";
	}

	var listDiv = $('<div class="list" title="' + disphtml + '" />');

	var preview_div = $("<div/>");
	if (file.type && file.type.search(/image\/.*/) != -1) {
		var thumb = new Image();
		thumb.src = (URL && URL.createObjectURL) ? URL.createObjectURL(file) : ev.target.result;
		$(thumb).css({
			"height": "110px"
		}).appendTo(preview_div);
	}
	else {
		preview_div.addClass("file-type");
		var className = '';
		if (!file.type) {
			preview_div.addClass(file.name.substr((file.name.lastIndexOf('.') + 1)).toLowerCase() || "undefined");
		}
		else {
			preview_div.addClass(fileTypeMap[file.type] || "undefined");
		}
	}
	preview_div.addClass("img-preview").appendTo(listDiv);
	// preview_div.addClass("img-preview").prependTo();

	var fileName = $('<div class="file-name pull-left" />');
	$('<span title="' + disphtml + '">' + disphtml + '</span>').appendTo(fileName);
	var removeBtn = $('<button title="Remove" class="close">&times;</button>');

	removeBtn.click(function () {
		typeof params.onRemoveFile === "function" && params.onRemoveFile(data);
		data.abort.call(data);
		listDiv.remove();
		// data.files.splice(0, 1);
		// data.files.length	= 0;
	});

	removeBtn.appendTo(fileName);
	fileName.appendTo(listDiv);
	listDiv.appendTo(parent);
};

ko.bindingHandlers.fileApi = {
	init: function (element, params) {
		var params = ko.utils.unwrapObservable(params());

		params.replaceFileInput = true;
		/*
		params.submit	= function(e, data){
			console.log("Submit", e, data);
			return false;
		};*/
		element = $(element);

		element.addClass("fle");

		var div1 = $("<div/>").addClass("file-uploader");
		div1.insertBefore(element);

		var listDiv = div1;
		if (params.separateList) {
			listDiv = $("<div/>").addClass("file-list-progress");
			listDiv.insertAfter(element);
		}

		var div2 = $("<div/>").addClass("pull-left file-browse pr");
		div2.appendTo(div1);

		var fileUploadButton = $('<button tabindex="0" class="btn btn-none btn-xs "><span class="icon icon-paper-clip"></span></button>');
		fileUploadButton.appendTo(div2);
		element.appendTo(div2);

		var fileListDiv = $("<div/>").addClass("pull-left file-list");
		fileListDiv.appendTo(listDiv);

		var progressDiv = $('<div class="pull-left fw" style="visibility:hidden;"><div class="progress"><div class="progress-bar"></div></div></div>');
		progressDiv.appendTo(listDiv);

		var uploadPlugin = $(element).fileupload(params);
		params.onFileuploadadd && uploadPlugin.on("fileuploadadd", params.onFileuploadadd);
		uploadPlugin.prop('disabled', !$.support.fileInput).parent().addClass($.support.fileInput ? undefined : 'disabled');
		uploadPlugin.on("fileuploadadd", function (e, data) {
			preparePreview(e, data, fileListDiv, params);
		});
		uploadPlugin.on("fileuploadprogressall", function (e, data) {
			progressDiv.css('visibility', 'visible');
			var progress = parseInt(data.loaded / data.total * 100, 10);
			$(".progress-bar", progressDiv).css('width', progress + '%');
			if (progress == 100) {
				progressDiv.css('visibility', 'hidden');
			}
		});
	}
};

ko.bindingHandlers.chosen = {
	init: function (element, params) {
		var $element = $(element);
		var _params = (typeof params() == 'object') ? params() : {};
		_params.search_contains = ko.utils.unwrapObservable(_params.search_contains);
		_params.disable_search = ko.utils.unwrapObservable(_params.isSearch) === false ? true : false;
		//		_params.disable_search	= (_params.disable_search===false) ? true : false;
		_params.width = _params.width || '100%';

		$element.chosen(_params);
		if (_params.change) {
			$element.chosen().on("change", function (evt, params) {
				_params.change($(this), params);
			});
		}
		if (typeof _params.open == 'function') {
			$element.chosen().on("chosen:showing_dropdown", function (evt, params) {
				_params.open($(this), evt, params);
			});
		}
		if (typeof _params.close == 'function') {
			$element.chosen().on("chosen:hiding_dropdown", function (evt, params) {
				_params.close($(this), evt, params);
			});
		}
	},
	update: function (element, params) {
		$(element).trigger("chosen:updated");
	}
};

// Activity date display
ko.bindingHandlers.actdate = {
	update: function (element, valueAccessor) {
		var value = ko.utils.unwrapObservable(valueAccessor());

		var date = new Date(ko.utils.unwrapObservable(value.date));
		var is12 = ko.utils.unwrapObservable(value.is12);

		var str = date.format(is12 ? 'OO:NN' : 'HH:NN AP');

		if (date > new Date().addMinutes(-1)) {
			str = 'Just Now';
			setTimeout(function () {
				ko.bindingHandlers.actdate.update(element, valueAccessor);
			}, date - new Date().addMinutes(-1));
		}
		else if (date.isYesterday()) {
			str = 'Yesterday ' + str;
		}
		else if (!date.isToday()) {
			str = date.format(date.isThisYear() ? 'DD MMM ' : 'DD MMM, YYYY ') + str;
		}

		return ko.bindingHandlers.text.update(element, function () {
			return str;
		});
	}
};
ko.virtualElements.allowedBindings.actdate = true;

String.escapeChars = { '&': '&amp;', '<': '&lt;', '>': '&gt;' };
String.prototype.escapeStr = function () {
	return this.replace(/[&<>]/g, function (tag) {
		return String.escapeChars[tag] || tag;
	});
};
String.prototype.toLinks = function () {
	return this.replace(/(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/i, '<a target="_blank" href="$1">$1</a>');
};
var tagExpr = /(^|[^a-z0-9_])[#|@]([a-z0-9_]+)/ig;
ko.bindingHandlers.msgText = {
	update: function (element, valueAccessor) {
		var value = ko.utils.unwrapObservable(valueAccessor());
		value = ko.utils.unwrapObservable(value);
		//value = value.escapeStr().toLinks();

		value = value.replace(/\n/g, '<br/>');

		/*value = value.replace(tagExpr, function (str) {
			str = str.trim();
			return ' <a data-bind="click:$root.showTag" href="' + str.replace(/#/g, 'tagname/').replace(/@/g, 'user/') + '" target="_black" title="' + str + '">' + str + '</a>';
		});*/
		// var str = value.replace(/&lt;/g, '<').replace(/&gt;/g, '>'); 
		var patt1 = /<a[^>]*>[@ | #](.*?)([^<]+)<\/a>/g;
		var result = value.match(patt1);
		
		if (result && result.length) {
			console.log(result);
			var i =0;
			for (;i<result.length;i++) {
				var str_rep = result[i];
				var tmp = $(result[i]);
				var a_str = tmp.text();
				if (tmp.attr('class')=="tag_trend"){
					str_rep = ' <a data-bind="click:$root.showTag" href="' + a_str.replace(/#/g, 'tagname/')+ '" target="_black" title="' + a_str + '">' + a_str + '</a>';
				} else if (tmp.attr('class')=="tag_user" && tmp.attr('id')) {
					str_rep = ' <a data-bind="click:$root.showUser" href="#" id="' + tmp.attr('id') + '" target="_black" title="' + a_str + '">' + a_str + '</a>';
				}
				value = value.replace(result[i], str_rep);
			}
		}
		// match existing trends tag
		var tagExpr = /(^|[\s])[#]([a-z0-9_]+)/ig;
		value = value.replace(tagExpr, function (str) {
			str = str.trim();
			return ' <a data-bind="click:$root.showTag" href="' + str.replace(/#/g, 'tagname/')+ '" target="_black" title="' + str + '">' + str + '</a>';
		})
		
		// value	= OTWall.Smily.replaceSmiles(value);
		value = window.wall_emoji.toEmoji(value);

		return ko.bindingHandlers.html.update(element, function () {
			return value;
		});
	}
};
ko.virtualElements.allowedBindings.msgText = true;
/*
ko.bindingHandlers.smily	= {
	init: function(elem){
		OTWall.Smily.init(elem);
	}
};
*/
$(document).on("click", function (e) {
	if (window.emojiBox.is(":visible") && !$(e.target).is("i.icon.icon-smile, .emoji-menu, .emoji-menu a, .emoji-list img, .scrollbot-scrollbar-holder, .scrollbot-scrollbar, .scrollbot-outer-parent") && !window.wall_emoji.emojiScroll.mdown) {
		window.emojiBox.hide();
		window.emojiBox.appendTo($("body"));
	} else {
		window.wall_emoji.emojiScroll.mdown = false;
	}
});
ko.bindingHandlers.smily = {
	init: function (elem) {
		// SMXIcons();
		// OTWall.Smily.init(elem);
		var smile_box = $('<div class="smily-box"></div>');
		var smile_icon = $('<i class="icon icon-smile smily-trigger gray"></i>');
		smile_box.insertAfter(elem);
		smile_icon.appendTo(smile_box);

		smile_icon.click(function (e) {
			if (window.emojiBox.is(":visible")) {
				$(document).off("onEmojiSelect");
				window.emojiBox.appendTo($("body"));
				window.emojiBox.hide();
			}
			else {
				window.emojiBox.insertAfter(e.target);
				window.emojiBox.css({
					right: 0,
					left: "auto",
					top: "100%"
				});
				window.emojiBox.show();
				window.wall_emoji.emojiScroll.refresh();

				$(document).off("onEmojiSelect").on("onEmojiSelect", {}, function (event, data) {
					elem.value = elem.value + ":" + data.txt + ": ";
					$(elem).trigger('change');
					$(elem).focus();
					window.emojiBox.hide();
					window.emojiBox.appendTo($("body"));
				});
			}
			/*
						if (window.emojiBox.is(":visible"))
						{
							window.emojiBox.css({
								left: -1000,
								top: -1000
							});
							window.emojiBox.hide();
						}
						else
						{
							var rect = e.target.getBoundingClientRect();
			
							window.emojiBox.css({
								left: rect.left - window.emojiBox.width() + rect.width,
								top: rect.top + rect.height
							});
			//				$(window).one("click", function(){
			//					window.emojiBox.hide();
			//				});
							window.emojiBox.show();
						}
			*/
		});
	}
};

ko.bindingHandlers.nanoScroll = {
	init: function (element, params) {
	},
	update: function(element, params){
		var element = $(element);
		var _params = ko.utils.unwrapObservable(params());

		element.mCustomScrollbar('destroy');

		var scrollParams = {
			axis: _params.axis || "y",
			theme:"dark",
			scrollInertia:100,
			advanced:{
				autoExpandHorizontalScroll: false,
				updateOnContentResize: true,
				updateOnImageLoad: true,
				autoUpdateTimeout: 200
			},
			scrollButtons:{
				enable:false
			},
			callbacks: {}
		};

		if (typeof _params.onScroll === 'function') {
			scrollParams.callbacks.onTotalScroll = _params.onScroll;
			scrollParams.callbacks.onTotalScrollOffset = 50;
		}

		element.mCustomScrollbar(scrollParams);
	}
};
var trendList;
var userList;
ko.bindingHandlers.summernote = {
	init: function (element, params) {
		var element = $(element);

		var _params = (typeof params() == 'object') ? params() : {};

		// _params.search_contains	= ko.utils.unwrapObservable(_params.search_contains);

		var editor_hints = [];
		var tmp_hint = {};
		
		if (_params.users) {
			tmp_hint = {
				// words: _params.users || [],
				match: /\B@([\-+\w]*)$/,
				search: function (keyword, callback) {
					callback($.grep(userList, function (item) {
						return item.name.toLowerCase().indexOf(keyword.toLowerCase()) === 0 ? item : null;
					}));
				},
				template: function (item) {
					return item.name;
				},
				content: function (item) {
					var node = $('<a class="tag_user" id="' + item.user_id + '" contenteditable="false">@' + item.name + '</a>');
					setTimeout(function () {
						element.find('.note-editable').focus();
						element.summernote('insertText', ' ');
					}, 10);
					return node[0];
				}
			};
			editor_hints.push(tmp_hint);
		}

		//if (_params.trends) {
		tmp_hint = {
			// words: _params.trends || [],
			match: /\B#([\-+\w]*)$/,
			search: function (term, callback) {
				callback($.grep(trendList, function (item) {
					return item.name.toLowerCase().indexOf(term.toLowerCase()) === 0 ? item : null;
				}));
			},
			template: function (item) {
				return item.name;
			},
			content: function (item) {
				var node = $('<a class="tag_trend" contenteditable="false">#' + item.name + '</a>');
				setTimeout(function () {
					element.find('.note-editable').focus();
					element.summernote('insertText', ' ');
				}, 10);
				return node[0];
			}
		};
		editor_hints.push(tmp_hint);
		// }
		element.summernote({
			shortcuts: false,
			focus: false,
			disableDragAndDrop: true,
			placeholder: '',
			minHeight: 100,
			maxHeight:350,
			toolbar: false,
			hint: editor_hints,
			popover: false,
			callbacks: {
				onKeyup: function(e) {
					element.summernote('saveRange');
				},
				onChange: function(contents, $editable) {
					_params.value(contents);
				}
			}
		});

		var smile_box = $('<div class="smily-box"></div>');
		var smile_icon = $('<i class="icon icon-smile smily-trigger"></i>');
		smile_box.insertAfter(element);
		smile_icon.appendTo(smile_box);

		smile_icon.click(function (e) {			
			if (window.emojiBox.is(":visible")) {
				$(document).off("onEmojiSelect");
				window.emojiBox.appendTo($("body"));
				window.emojiBox.hide();
			}
			else {
				window.emojiBox.insertAfter(e.target);
				window.emojiBox.css({
					right: 0,
					left: "auto",
					top: "100%"
				});
				window.emojiBox.show();
				window.wall_emoji.emojiScroll.refresh();

				$(document).off("onEmojiSelect").on("onEmojiSelect", {}, function (event, data) {
					element.summernote('restoreRange');
					var node = $(window.wall_emoji.toEmoji(":" + data.txt + ":")).get(0);
					element.summernote('insertNode', node);
					window.emojiBox.hide();
					window.emojiBox.appendTo($("body"));
				});
			}
		});
	}, update: function (element, params) {
		var _params = (typeof params() == 'object') ? params() : {};
		_params.trends = ko.utils.unwrapObservable(_params.trends);
		trendList = _params.trends;
		_params.users = ko.utils.unwrapObservable(_params.users);
		userList = _params.users;
	}
};

ko.bindingHandlers.enterkey = {
	init: function (element, valueAccessor, allBindings, viewModel) {
		var callback = valueAccessor();
		$(element).keypress(function(event){
			var keyCode = (event.which ? event.which : event.keyCode);
			if (!event.shiftKey && keyCode === 13) {
				callback.call(viewModel);
				return false;
			}
			return true;
		});
	}
};

ko.bindingHandlers.loadMore = {
	init: function (element, valueAccessor, allBindings, viewModel) {
		setTimeout(function(){
			var elem = $(element);
			var params = valueAccessor() || {len:200};
			var maxHeight = params.len;

			if (elem.get(0).scrollHeight > maxHeight) {
				elem.addClass('less');
				var moreBtnParent = $("<div/>").addClass("show_more_less");
				moreBtnParent.insertAfter(elem);
				var moreBtn = $("<span/>");
				moreBtn.addClass("icon icon-double-angle-down");
				moreBtn.appendTo(moreBtnParent);
				moreBtn.attr("title", "Show More");
				// moreBtn.text("Show More");
				moreBtn.click(function(){
					elem.toggleClass('less');

					if (elem.hasClass('less')) {
						// moreBtn.text("Show More");
						moreBtn.attr("title", "Show More");
						moreBtn.get(0).className = 'icon icon-double-angle-down';
						// elem.parents(".post.media").get(0).scrollIntoView();
						// moreBtnParent.get(0).scrollIntoView(false);
					} else {
						moreBtn.attr("title", "Hide Less");
						moreBtn.get(0).className = 'icon icon-double-angle-up';
						// moreBtn.text("Show Less");
					}
					if (params.clbk) {
						params.clbk(true);
					}
				});
			}
		}, 200);
	}
};

