window.OTWall = new function OTWall(){return this;};
var wall_token = '';
var user_notification_count = 0;
(function(OTWall){

	OTWall.dateFormat	= 'MMM DD, YYYY';
	OTWall.jsDateFormat	= 'YYYY/MM/DD';
	OTWall.sqlDateFormat	= '';

	OTWall.o	= ko.observable;
	OTWall.a	= ko.observableArray;
	OTWall.c	= ko.computed;
	OTWall.i	= ko.isObservable;

	OTWall.base_url	= '';
	OTWall.site_url	= '';
	OTWall.api_url	= '';
	OTWall.attachUrl= '';

	OTWall.Modules	= {};

	OTWall.is_list_view = false;

	OTWall.isWebSocket = false;

	OTWall.Storage	= new function(){
		var _this	= this;

		_this.keyPrefix	= "OW_";

		_this.get	= function(key, _default){
			if (window.localStorage != undefined && window.localStorage.length>0 && key)
			{
				return window.localStorage.getItem(_this.keyPrefix + key) || _default;
			}
			return false;
		};

		_this.set	= function(key, val){
			if (window.localStorage != undefined && key)
			{
				window.localStorage.setItem(_this.keyPrefix + key, val);
				return true;
			}
			return false;
		};

		_this.clear	= function(){
			var keys = Object.keys(window.localStorage);
			for (var i=0, iLen=keys.length; i<iLen; i++)
			{
				if (keys[i].substr(0,5) == _this.keyPrefix)
				{
					delete window.localStorage[keys[i]];
				}
			}
			return _this;
		};

		_this.onChange	= function(callback){
			if (!$.browser.msie)
			{
				$(window).unbind("storage").bind("storage", function(e){
					callback && callback(e.originalEvent);
				});
			}
			return _this;
		};
		return _this;
	};

	OTWall.onTabChange	= function(clbk){

		var targEvent	= "hidden";

		var onchange	= function(evt){
			var v	= "visible",
				h	= "hidden",
				evtMap	= {
					focus: v,
					focusin: v,
					pageshow: v,
					blur: h,
					focusout: h,
					pagehide: h
				};

			evt	= evt || window.event;

			var isHidden	= (evtMap[evt.type] != undefined) ? evtMap[evt.type] : document[targEvent];

			clbk && typeof clbk == "function" && clbk(isHidden);
		};

		if (typeof document.hidden !== "undefined") {
			targEvent	= "hidden";
			document.addEventListener("visibilitychange", onchange);
		} else if(typeof document.mozHidden !== "undefined") {
			targEvent	= "mozHidden";
			document.addEventListener("mozvisibilitychange", onchange);
		} else if(typeof document.webkitHidden !== "undefined") {
			targEvent	= "webkitHidden";
			document.addEventListener("webkitvisibilitychange", onchange);
		} else if(typeof document.msHidden !== "undefined") {
			targEvent	= "msHidden";
			document.addEventListener("msvisibilitychange", onchange);
		} else if (typeof document.onfocusin !== "undefined") {
			document.onfocusin = document.onfocusout = onchange;
		} else {
			window.onpageshow = window.onpagehide = window.onfocus = window.onblur = onchange;
		}

		return;
	};

	OTWall.setEditor	= function(elem){
		elem.jqte({
			format: false, fsize: false, color: false
			,b: false, i: false, u: false
			,ol: false, ul: false
			,sub: false, sup: false
			,outdent: false, indent: false
			,left: false, center: false, right: false
			,strike: false, remove: false
			,link: false, unlink: false, rule: false
			// ,source: false
		});
	};

	OTWall.toLinks	= function(text){
		return text.replace(/(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/i, '<a target="_blank" href="$1">$1</a>');
	};

	OTWall.ExtNotify	= function(cnt){
		try {
			window.parent && window.parent.postMessage({
					type: 'notify',
					arg1: cnt
			},  "*");
			window.external && window.external.Notify(cnt);
		} catch(Ex){
			// Ex
		}
	};

	OTWall.PostNotify	= function(cnt){
		try {
			window.parent && window.parent.postMessage({
					type: 'post',
					arg1: cnt
			},  "*");
			window.external && window.external.PostNotify(cnt);
		} catch(Ex){
			// Ex
		}
	};

	OTWall.initEmoji	= function(){
		var emoji_box	= document.getElementById("wal-emoji-box");
		if (!emoji_box)
		{
			emoji_box	= document.createElement('div');
			emoji_box.setAttribute("id", "wal-emoji-box");
			document.body.appendChild(emoji_box);
		}
		if (!window.wall_emoji)
		{
			window.wall_emoji = new SMXIcons({
				config: SmxEmojiConfig,
				emojiBox: "wal-emoji-box",
				onSelect: function(data, e){
					$(document).trigger("onEmojiSelect", data);
				}
			});
			window.wall_emoji.buildTmpl();
		}
		window.emojiBox	= $("#wal-emoji-box");
	};

	OTWall.init	= function(token, oauth_token){
		OTWall.initEmoji();

		if (!oauth_token)
			token = token || OTWall.Storage.get('wall_token');
		else 
			oauth_token = oauth_token || OTWall.Storage.get('oauth_token');
		$.ajaxSetup({
			error: function(jqXHR,error, errorThrown) {
				var res = JSON.parse(jqXHR.responseText);
				var err = res.error_description || res.error || (typeof(res)=='string'?res:'Something went wrong');

				if(jqXHR.status&&jqXHR.status==401)
				{
					OTWall.Storage.set('wall_token', '');
					OTWall.Storage.set('oauth_token', '');					
					alert(err);
					try {
						window.external.InvalidToken(err);
					} catch(Ex){
						// Ex
					} 
				}
				else
				{
					alert(err);
				}
			}
		});

		if (!oauth_token) {
			if (token!=OTWall.Storage.get('wall_token'))
			{
				$.post(OTWall.api_url+"token", {'auth_token':token,type:OTWall.wall_type},function(resp){
					if (resp.data) {
						OTWall.Storage.set('wall_token', resp.data.auth_token);
						OTWall.init();
					}
				});
				return true;
			}
		} else if (oauth_token!=OTWall.Storage.get('oauth_token')){
			OTWall.Storage.set('oauth_token', oauth_token);
			OTWall.init();
		}
		
		if (OTWall.Storage.get('wall_token')) {
			$.ajaxSetup({headers: {'Authorization-ot':OTWall.Storage.get('wall_token')}});
		} else {
			$.ajaxSetup({headers: {'Authorization':'bearer '+OTWall.Storage.get('oauth_token')}});
		}

		$.ajaxSetup({headers: {'wall_type':OTWall.wall_type}});
// console.log($("#poll_form .emotion-list .list").get(0));

		OTWall.Users.get_details(function(){
			OTWall.Post.init();
		});
	};

})(window.OTWall);
$(function(){
/*	$("#notification-container").mouseleave(function(){
		$("#notification-container").hide();
	});
*/
	$("#notification").unbind("click").click(function(){
		OTWall.Notification.init(true);
		OTWall.ExtNotify(0);
	});
});
window.showImagePopup = function(imgArray, imgIndex){
/*
	var style = "";
	style	+= "<style>";
	style	+= "*{";
	style	+= "-webkit-touch-callout:none;";
	style	+= "-webkit-user-select:none;";
	style	+= "-khtml-user-select:none;";
	style	+= "-moz-user-select:none;";
	style	+= "-ms-user-select:none;";
	style	+= "user-select:none;";
    style	+= "}";

	style	+= "body .prev, .next{";
	style	+= "height:45px;";
	style	+= "position:absolute;";
	style	+= "text-align:center;";
	style	+= "vertical-align:middle;";
	style	+= "top: 48%;";
	style	+= "font-size: 100px;";
	style	+= "line-height:22px;";
	style	+= "cursor: pointer;";
	style	+= "border-radius: 50%;";
	style	+= "width: 45px;";
	style	+= "background: rgba(0,0,0,0.3);";
	style	+= "color:rgba(255,255,255,0.9);";
	style	+= "padding:8px;";
	style	+= "}";
	style	+= ".prev{left:0;}";
	style	+= ".next{right:0;}";
	style	+= "img{width:100%;height:auto;}";
	style	+= "</style>";

	var script = "<script>";
	script	+= "var imagePopupScript = function(imgArray, imgIndex){";
	script	+= "if (!imgArray || !imgArray.length) {";
	script	+= "	return false;";
	script	+= "}";

	script	+= "imgIndex = imgIndex || 0;";
	script	+= "var img = document.createElement('img');";

	script	+= "var assignImage = function(){";
	script	+= "	if (imgIndex < 0) { imgIndex = imgArray.length-1; }";
	script	+= "	if (imgIndex == imgArray.length) { imgIndex = 0; }";
	script	+= "	img.setAttribute('src', imgArray[imgIndex]);";
	script	+= "};";

	script	+= "var prevFn=function(){imgIndex--;assignImage();};";
	script	+= "var nextFn=function(){imgIndex++;assignImage();};";

	script	+= "var prev = document.createElement('span');";
	script	+= "prev.innerHTML = '&#8249;';";
	script	+= "prev.className = 'prev';";
	script	+= "if (prev.addEventListener) {prev.addEventListener('click', prevFn);}";
	script	+= "else if(prev.attachEvent){prev.attachEvent('onclick', prevFn);}";
	script	+= "else if(prev.onclick){next.onclick=prevFn}";

	script	+= "";

	script	+= "var next = document.createElement('span');";
	script	+= "next.className = 'next';";
	script	+= "next.innerHTML = '&#8250;';";
	script	+= "if (next.addEventListener){next.addEventListener('click', nextFn);}";
	script	+= "else if(next.attachEvent){next.attachEvent('onclick', nextFn);}";
	script	+= "else if(next.onclick){next.onclick=nextFn}";

	script	+= "assignImage();";
	script	+= "document.documentElement.appendChild(document.createElement('body'));";
	script	+= "document.body.appendChild(prev);";
	script	+= "document.body.appendChild(img);";
	script	+= "document.body.appendChild(next);";
	script	+= "};";
	script	+= "imagePopupScript(" + JSON.stringify(imgArray) + ", " + imgIndex + ");";
	script	+= "</script>";

	try {
		window.external && window.external.wallImagePopup(style + script);
	} catch(Ex){
		// Ex
		return false;
	}
*/
	if (OTWall.wall_type!='OM') return false;
	try {
		
		window.parent && window.parent.postMessage({type:'imagepopup', arg1:imgArray.join(","),arg2:imgIndex},'*');
		if (window.top==window) {
			 window.external && window.external.wallImagePopup(imgArray.join(","), imgIndex);
		}
	} catch(Ex){
		// Ex
		return false;
	}
/*
	var wallImagePopup = window.open("", "Wall Images", "width=800,height=600");
	wallImagePopup.document.write(style + script);
*/

	return true;
};
