(function(OTWall){

	OTWall.Smily	= new function Smily(){
		var _this	= this;

		_this.Emotions	= {
			":)": { symbol: ":)",title: "Smile",className: "smile",regExp: ":\)" }
			,"(VH)": { symbol: "(VH)",title: "Very Happy",className: "very-happy",regExp: "\(VH\)" }
			,"(BT)": { symbol: "(BT)",title: "Baring Teeth",className: "baring-teeth",regExp: "\(BT\)" }
			,"(WK)": { symbol: "(WK)",title: "Winking",className: "winking",regExp: "\(WK\)" }
			,"(SH)": { symbol: "(SH)",title: "Shocked",className: "shocked",regExp: "\(SH\)" }
			,"-t)": { symbol: "-t)",title: "OMG",className: "omg",regExp: "-t\)" }
			,":p": { symbol: ":p",title: "Tongue out",className: "tonque-out",regExp: ":p" }
			,":w)": { symbol: ":w)",title: "Nerd",className: "nerd",regExp: ":w\)" }

			,"(AN)": { symbol: "(AN)",title: "Angry",className: "angry",regExp: "\(AN\)" }
			,"(AH)": { symbol: "(AH)",title: "Ashamed",className: "ashamed",regExp: "\(AH\)" }
			,":^)": { symbol: ":^)",title: "I don't know",className: "i-dont-know",regExp: ":\^\)" }
			,":-s": { symbol: ":-s",title: "Confused",className: "confused",regExp: ":-s" }
			,":')": { symbol: ":')",title: "Crying",className: "crying",regExp: ":'\)" }
			,":(": { symbol: ":(",title: "Sad",className: "sad",regExp: ":\(" }
			,":-#": { symbol: ":-#",title: "Don't tell everyone",className: "dont-tell-anyone",regExp: ":-\#" }
			,"(B)": { symbol: "(B)",title: "Bye",className: "bye",regExp: "\(B\)" }

			,"*-)": { symbol: "*-)",title: "Thinking",className: "thinking",regExp: "\*-\)" }
			,":s)": { symbol: ":s)",title: "Sorry",className: "sorry",regExp: ":s\)" }
			,"|-)": { symbol: "|-)",title: "Sleepy",className: "sleepy",regExp: "\|-\)" }
			,"+o(": { symbol: "+o(",title: "Sick",className: "sick",regExp: "\+o\(" }
			,"(C)": { symbol: "(C)",title: "Cool",className: "cool",regExp: "\(C\)" }
			,"-c)": { symbol: "-c)",title: "Angel",className: "angel",regExp: "-c\)" }
			,"(D)": { symbol: "(D)",title: "Devil",className: "devil",regExp: "\(D\)" }
			,":o)": { symbol: ":o)",title: "Party",className: "party",regExp: ":o\)" }

			,";w)": { symbol: ";w)",title: "Whistle",className: "whistle",regExp: ";w\)" }
			,"(BRB)": { symbol: "(BRB)",title: "brb",className: "brb",regExp: "\(BRB\)" }
			,":-*": { symbol: ":-*",title: "Secret Telling",className: "secret",regExp: ":-\*" }
			,"-h)": { symbol: "-h)",title: "Headache",className: "headache",regExp: "-h\)" }
			,"(GF)": { symbol: "(GF)",title: "Gift",className: "gift",regExp: "\(GF\)" }
			,"(^)": { symbol: "(^)",title: "Birthday Cake",className: "birthday-cake",regExp: "\(\^\)" }
			,"(L)": { symbol: "(L)",title: "Heart",className: "heart",regExp: "\(L\)" }
			,"(U)": { symbol: "(U)",title: "Broken Heart",className: "broken-heart",regExp: "\(U\)" }

			,"(*)": { symbol: "(*)",title: "Star",className: "star",regExp: "\(\*\)" }
			,"(O)": { symbol: "(O)",title: "Clock",className: "clock",regExp: "\(O\)" }
			,"(CF)": { symbol: "(CF)",title: "Coffee",className: "coffee",regExp: "\(CF\)" }
			,"(PL)": { symbol: "(PL)",title: "Food",className: "food",regExp: "\(PL\)" }
			,"($)": { symbol: "($)",title: "Money",className: "money",regExp: "\(\$\)" }
			,"(H5)": { symbol: "(H5)",title: "Clapping Hands",className: "clapping-hands",regExp: "\(H5\)" }
			,"(YN)": { symbol: "(YN)",title: "FingersCrossed",className: "finger-scrossed",regExp: "\(YN\)" }
			,"(SN)": { symbol: "(SN)",title: "Snail",className: "snail",regExp: "\(SN\)" }

			,"(F)": { symbol: "(F)",title: "Rose",className: "rose",regExp: "\(F\)" }
			,"(W)": { symbol: "(W)",title: "Wilted Rose",className: "wilted-rose",regExp: "\(W\)" }
			,"(SO)": { symbol: "(SO)",title: "Play",className: "play",regExp: "\(SO\)" }
			,"-i)": { symbol: "-i)",title: "Idea",className: "idea",regExp: "-i\)" }
			,"(BR)": { symbol: "(BR)",title: "Beer",className: "beer",regExp: "\(BR\)" }
			,"(P)": { symbol: "(P)",title: "Phone",className: "phone",regExp: "\(P\)" }
			,"(Y)": { symbol: "(Y)",title: "Thumbs Up",className: "thumbs-up",regExp: "\(Y\)" }
			,"(N)": { symbol: "(N)",title: "Thumbs Down",className: "thumbs-down",regExp: "\(N\)" }

		//	,":-)": { symbol: ":-)",title: "Smile",className: "smile",regExp: ":-\)" }
		};

		_this.getTag	= function(str){
			return '<i class="emotion emotion-' + _this.Emotions[str].className + '" title="' + _this.Emotions[str].title + ' ' + _this.Emotions[str].symbol + '"></i>';
		};

		var smilyRegExp	= /(:\)|\(VH\)|\(BT\)|\(WK\)|\(SH\)|-t\)|:p|:w\)|\(AN\)|\(AH\)|:\^\)|:-s|:'\)|:\(|:-\#|\(B\)|\*-\)|:s\)|\|-\)|\+o\(|\(C\)|-c\)|\(D\)|:o\)|;w\)|\(BRB\)|:-\*|-h\)|\(GF\)|\(\^\)|\(L\)|\(U\)|\(\*\)|\(O\)|\(CF\)|\(PL\)|\(\$\)|\(H5\)|\(YN\)|\(SN\)|\(F\)|\(W\)|\(SO\)|-i\)|\(BR\)|\(P\)|\(Y\)|\(N\)|:-\))/g;
		_this.replaceSmiles	= function(value){
			value	= value.replace(smilyRegExp, function(str){
				return _this.getTag(str);
			});
			return value;
		};

		_this.prepareTable	= function(){
			var i=0;
			var table	= '<tbody>';
			$.each(_this.Emotions, function(key, val){
				if (i%8 == 0)
				{
					table	+= (i == 0 ? '' : '</tr>') + '<tr>';
				}
				table	+= '<td class="smily" symbol="' + val.symbol + '" title="' + val.title + '"></td>';
				i++;
			});
			table	+= '</tr></tbody>';
			return table;
		};

		_this.init	= function(elem){
			var jelem	= $(elem);

			var emotion_list	= $('<span class="emotion-list"></span>');
			var smile_icon	= $('<i class="icon icon-smile"></i>');

			smile_icon.appendTo(emotion_list);

			var smile_list_table	= '';
			smile_list_table	+= '<table class="list" style="display:none;">';
			smile_list_table	+= _this.prepareTable();
			smile_list_table	+= '</table>';
			smile_list_table	= $(smile_list_table);

			smile_list_table.appendTo(emotion_list);

			smile_icon.on("click", function(){
				smile_list_table.toggle();
			});
			smile_list_table.on("click", function(e){
				elem.value	= elem.value + e.target.getAttribute("symbol");
				jelem.trigger('change');
				jelem.focus();
			});
			jelem.on("focus", function(){
				smile_list_table.hide();
			});

			emotion_list.insertAfter(jelem);
		};
	};

})(window.OTWall);

