DROP TABLE IF EXISTS `ot_wall_activity`;
CREATE TABLE IF NOT EXISTS `ot_wall_activity` (
  `activity_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` INT( 11 ) NOT NULL,
  `to_type` char(1) NOT NULL COMMENT 'U-User/P-Project/E-Every One/M-Project Manager/F-Project Finance/A-Administrator',
  `to_id` int(11) NOT NULL COMMENT 'User_Id or Project_id or 0',
  `module_type` char(1) NOT NULL COMMENT 'P(Project), T(Task),I(Invoice),E(Estimate),U(User),X(Expense),R(Invoice Payment Receipt),A(Attachment), O(post)',
  `module_id` int(11) NOT NULL,
  `last_updated` int(11) NOT NULL,
  PRIMARY KEY (`activity_id`),
  UNIQUE KEY `IX_to` (`to_type`,`to_id`,`last_updated`),
  KEY `IX_Activity` (`module_type`,`module_id`,`to_type`,`to_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
DROP TABLE IF EXISTS `ot_wall_favorite`;
CREATE TABLE IF NOT EXISTS `ot_wall_favorite` (
  `post_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  UNIQUE KEY `user_post_id` (`user_id`,`post_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ot_wall_posts`;
CREATE TABLE IF NOT EXISTS `ot_wall_posts` (
  `post_id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` INT( 11 ) NOT NULL,
  `post_date` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp',
  `post_by` int(11) NOT NULL,
  `post_to` text NOT NULL,
  `post_type` char(1) NOT NULL COMMENT 'M-Message / E-Event / P-Poll / A-Announcement',
  `post_subject` varchar(255) NOT NULL DEFAULT '',
  `post_message` text NOT NULL,
  `post_content` text NOT NULL,
  `post_input` text NOT NULL,
  `followers` text NOT NULL COMMENT 'User_id comma delimiter',
  `unfollow` text NOT NULL COMMENT 'User_id comma delimiter',
  `like_count` smallint(5) unsigned NOT NULL,
  `liked` text NOT NULL COMMENT 'User_id comma delimiter',
  `ack_count` smallint(5) unsigned NOT NULL,
  `ack` text NOT NULL COMMENT 'User_id comma delimiter',
  `keep_ontop_till` int(11) NOT NULL COMMENT 'Timestamp',
  `comments_count` int(11) NOT NULL,
  PRIMARY KEY (`post_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
DROP TABLE IF EXISTS `ot_wall_tagmessages`;
CREATE TABLE IF NOT EXISTS `ot_wall_tagmessages` (
  `tag_id` int(11) NOT NULL,
  `message_id` int(11) NOT NULL,
  PRIMARY KEY (`tag_id`,`message_id`),
  KEY `message_id` (`message_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ot_wall_tags`;
CREATE TABLE IF NOT EXISTS `ot_wall_tags` (
  `tag_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) NOT NULL,
  `entity_id` int(11) NOT NULL,
  PRIMARY KEY (`tag_id`),
  UNIQUE KEY `entity_tagname` (`entity_id`,`name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

ALTER TABLE `ot_comments` ADD `like_count` SMALLINT( 5 ) NOT NULL DEFAULT '0' AFTER `is_protected` ,
ADD `liked` TEXT NOT NULL AFTER `like_count` ;

CREATE TABLE IF NOT EXISTS `ot_wall_notification` (
  `notification_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `module_type` char(1) NOT NULL COMMENT 'P/T/I/W/C',
  `module_id` int(11) NOT NULL,
  `module_action` char(1) NOT NULL,
  `post_by` text NOT NULL,
  `is_read` tinyint(1) NOT NULL DEFAULT '0',
  `posted_on` int(11) NOT NULL,
  PRIMARY KEY (`notification_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
CREATE TABLE IF NOT EXISTS `ot_wall_tokens` (
  `token_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `first_name` varchar(30) NOT NULL,
  `email` varchar(50) NOT NULL,
  `user_role` varchar(1) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `auth_token` varchar(250) NOT NULL,
  `expiry_date` datetime NOT NULL,
  PRIMARY KEY (`token_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
ALTER TABLE `ot_users_auth_tokens` CHANGE `auth_token` `auth_token` VARCHAR(250) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
